{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 56384,0,655360}

Program Statistici;

var fin,fout:text;
    xc,yc,ung,uaux:array[1..1001] of extended;
    ordo1,ordo2,oaux1,oaux2:array[1..1001] of integer;
    i,j,k,m,n,np,intt:integer;
    x0,y0,xp,yp,a,b,c:extended;
    smn0,smnp:shortint;
    sens:shortint;

procedure sorti(li,ls:integer);
begin
if (ls-li=1) then
  begin
    if (ung[li]>ung[ls]) then
      begin
        k:=ordo1[li];
        ordo1[li]:=ordo1[ls];
        ordo1[ls]:=k;

        k:=ordo2[li];
        ordo2[li]:=ordo2[ls];
        ordo2[ls]:=k;

        a:=ung[li];
        ung[li]:=ung[ls];
        ung[ls]:=a;
      end;
  end
else
  begin
    sorti(li,(li+ls) div 2);
    sorti((li+ls) div 2+1,ls);

    k:=li-1;
    i:=li;
    m:=(li+ls) div 2;
    j:=m+1;

    while (i<=m) and (j<=ls) do
      begin
        inc(k);
        if (ung[i]<ung[j]) then
          begin
            oaux1[k]:=ordo1[i];
            oaux2[k]:=ordo2[i];
            uaux[k]:=ung[i];
            inc(i);
          end
        else
          begin
            oaux1[k]:=ordo1[j];
            oaux2[k]:=ordo2[j];
            uaux[k]:=ung[j];
            inc(j);
          end;
      end;

    if (i<=m) then
      begin
        for j:=i to m do
          begin
            inc(k);
            oaux1[k]:=ordo1[j];
            oaux2[k]:=ordo2[j];
            uaux[k]:=ung[j];
          end;
      end
    else
      begin
        for i:=j to ls do
          begin
            inc(k);
            oaux1[k]:=ordo1[i];
            oaux2[k]:=ordo2[i];
            uaux[k]:=ung[i];
          end;
      end;

    for k:=li to ls do
      begin
        ordo1[k]:=oaux1[k];
        ordo2[k]:=oaux2[k];
        ung[k]:=uaux[k];
      end;
  end;
end;

procedure cauta(xx,yy:extended; var intt:integer);
var li,ls:integer;
    uu:extended;
begin

if (yy=y0) then uu:=pi
else
  uu:=arctan((yy-y0)/(xx-x0));

if (xx<x0) and (yy>y0) then
  uu:=uu+pi
else
  if (xx<x0) and (yy<x0) then
     uu:=uu+pi;

li:=1; ls:=n;

while (li<ls) do
  begin
    m:=(li+ls+1) div 2;
    if (ung[m]>uu) then
      begin
        ls:=m-1;
      end
    else
      if (ung[m]<uu) then
        begin
          li:=m
        end
      else
        if (ung[m]=uu) then
          begin
            li:=m; ls:=m;
          end;
  end;

intt:=li;
end;

function semn(aa,bb,cc,xxx,yyy:extended):shortint;
var r:extended;
begin
r:=aa*xxx+bb*yyy+cc;

if abs(r)<1e-5 then semn:=0
else
  if (r>0) then semn:=1
  else semn:=-1;
end;

begin
assign(fin,'INPUT.TXT');
reset(fin);
readln(fin,n);

x0:=0; y0:=0;

for i:=1 to n do
  begin
    readln(fin,xc[i],yc[i]);
    x0:=x0+xc[i]; y0:=y0+yc[i];
  end;

xc[n+1]:=xc[1];
yc[n+1]:=yc[1];

x0:=x0/n; y0:=y0/n;

for i:=1 to n+1 do
  begin
    ordo1[i]:=i;

    if (xc[i]=x0) then
      ung[i]:=pi
    else
      begin
        ung[i]:=arctan((yc[i]-y0)/(xc[i]-x0));
        if (xc[i]<x0) and (yc[i]>y0) then
          ung[i]:=ung[i]+pi
        else
          if (xc[i]<x0) and (yc[i]<x0) then
            ung[i]:=ung[i]+pi;

      end;
  end;

sens:=-1;
for i:=1 to n do
  if (ung[i]<ung[i+1]) and (ung[i+1]-ung[i]<pi) then
    begin
      sens:=1; break;
    end;


for i:=1 to n do
  begin
    j:=i+sens;
    if j<1 then j:=n
    else
      if j>n then j:=1;
    ordo2[i]:=j;
  end;

sorti(1,n);


np:=0;

readln(fin,m);

for k:=1 to m do
  begin
    readln(fin,xp,yp);
    cauta(xp,yp,intt);

    a:=yc[ordo1[intt]]-yc[ordo2[intt]];
    b:=xc[ordo2[intt]]-xc[ordo1[intt]];
    c:=xc[ordo1[intt]]*yc[ordo2[intt]]-xc[ordo2[intt]]*yc[ordo1[intt]];

    smn0:=semn(a,b,c,x0,y0);
    smnp:=semn(a,b,c,xp,yp);

    if (smnp=smn0) or (smnp=0) then
      np:=np+1;
  end;

close(fin);


assign(fout,'OUTPUT.TXT');
rewrite(fout);
writeln(fout,np);
close(fout);

end.