#include <iostream>
#include <deque>
#include <set>
#include <algorithm>
#include <iterator>
using namespace std;
int const MAXN=10001;
long long n;
long long k;
long long a[MAXN];
deque <set <long long> > Names;
void init(void)
{
     for (long long i=0;i<=n;i++)
     {set <long long> a;
      a.insert(i);
      Names.push_back(a);
     }
}
bool fold(long long place)
{
     long long i,j,k,s=Names.size();
     if (s<=2) return true;
     for (i=0;i<s;i++)
	 {   set<long long>::iterator p=Names[i].find(place);
		 if (p!=NULL && p!=Names[i].end()) break;
	 }
	 if (i==0 || i==s-1) return false;
     if (i<=(s-1)>>1)
      { for (j=i+1,k=i-1;k>=0;j++,k--) set_union(Names[j].begin(), Names[j].end(),
                                                 Names[k].begin(), Names[k].end(),
                                                 inserter(Names[j], Names[j].begin()));
        for (j=0;j<i;j++) Names.pop_front();
      }
     else
      { for (j=i-1,k=i+1;k<s;j--,k++)  set_union(Names[j].begin(), Names[j].end(),
                                                 Names[k].begin(), Names[k].end(),
                                                 inserter(Names[j], Names[j].begin()));
        for (j=i+1;j<s;j++) Names.pop_back();
      }
     return false;
}
int main(void)
{
    int i;
    cin>>n>>k;
    for (i=0;i<k;i++) cin>>a[i];
    init();
    for (i=0;i<k;i++) if (fold(a[i])) break;
    cout<<Names.size()-1<<endl;
    return 0;
}


