#include<stdio.h>
#include<stdlib.h>

#define MIN(a,b) ((a < b) ? a : b ) 

struct job {
  int a;		// 1st time
  int b;		// 2nd time
};

struct job *work;

int N;
long long cas=0;

int usp(int a, int b) 
{
  if (a < b) return 0;
  if (a == b) return 1;
//  if (a > b)
  return 2;
}

int cmp (const void *a,const void *b)
{
  struct job *j1 = (struct job*) a;
  struct job *j2 = (struct job*) b;

  if (usp(j1->a,j1->b) != usp(j2->a,j2->b))
    return usp(j1->a,j1->b) - usp(j2->a,j2->b);
  else {
    if ( usp(j1->a,j1->b) == 0) 	// <
      return j1->a - j2->a; 
    else
      return j2->b - j1->b;    
  }  
}

int main(void) {
  int i, wa, wb, t;

  stdin = fopen("cakes.in", "r");
  stdout = fopen("cakes.out", "w");

  scanf("%d",&N);

  work  = malloc(N * sizeof(struct job));
  for(i=0;i<N;i++) 
    scanf("%d %d",&work[i].a,&work[i].b);
  
  qsort(work,N,sizeof(struct job),cmp);

  wa = wb = 0;

  while( ! (wa >= N)) {
    t = work[wa].a;
    if (wb+1 <= wa) 
      t = MIN(t, work[wb].b);    
 
    work[wa].a -= t;
    if (wb+1 <= wa) {
      work[wb].b -= t;
      if (work[wb].b == 0)
	wb++;
    }

    if (work[wa].a == 0)
      wa++;
    
    cas += t; 
  }
  
  while (! (wb >= N) ) {
    cas += work[wb].b;
    wb++;
  }
  
  printf("%lld\n", cas);
  return 0;
}
