#include<stdio.h>
#include<stdlib.h>

struct job {
  int a;		// 1st time
  int b;		// 2nd time
};

struct job * less;	// a < b
struct job * equal;	// a == b
struct job * great;	// a > b
struct job * work;	// zoznam robot pre 2. robotnika

int less_end = -1;
int equal_end = -1;
int great_end = -1;

int work_begin = 0;
int work_end = -1;


int less_cmp(const void * a1,const void * a2) {
  struct job * b1, * b2;
  b1 = (struct job *)a1;
  b2 = (struct job *)a2;
  return (b2->a - b1->a);
}

int great_cmp(const void *a1,const void *a2) {
  struct job * b1, * b2;
  b1 = (struct job *)a1;
  b2 = (struct job *)a2;
  return (b1->b - b2->b);
}




void sort(void) {
  qsort(less,less_end+1,sizeof(struct job),less_cmp);
  qsort(great,great_end+1,sizeof(struct job),great_cmp);
}

int less_empty(void) {
  return less_end==-1;
}

int equal_empty(void) {
  return equal_end==-1;
}

int great_empty(void) {
  return great_end==-1;
}

int work_empty(void) {
  if (work_begin > work_end) return 1;
  else return 0;
}



void input(void) {
  int N,i;
  struct job temp;
  printf("Count jobs: \n");
  scanf("%d",&N);

  less 	= malloc(N * sizeof(struct job));
  equal = malloc(N * sizeof(struct job));
  great = malloc(N * sizeof(struct job));
  work  = malloc(N * sizeof(struct job));

//  memset(less,0,N*sizeof(struct job));
//  memset(equal,0,N*sizeof(struct job));
//  memset(great,0,N*sizeof(struct job));

  for(i=0;i<N;i++) {
    scanf("%d",&temp.a);
    scanf("%d",&temp.b);
    if (temp.a < temp.b) {
      less_end++;
      less[less_end] = temp;
    }
    else
      if (temp.a == temp.b) {
	equal_end++;
        equal[equal_end] = temp;
      }
      else {
	great_end++;
        great[great_end] = temp;
      }	
    
  }  
/*
  for (i=0;i<great_end;i++)
    printf("AAAA%d ",great[i]);
*/
}

void solve(void) {
  long long  cas;
  int new_time;
  cas = 0;
  while(1) {
    if ( !less_empty())
      new_time = less[less_end].a;
    else if ( !equal_empty() )
	    new_time = equal[equal_end].a;
         else
	   if ( !great_empty())	 
             new_time = great[great_end].a;
	   else {
	     while( !work_empty()) {
	       cas += work[work_end].b;
               work_end--;
             }	       
	     printf("%lld\n", cas);
	     break;
	   } 
     
    if ((new_time > work[work_begin].b) && !work_empty())
      new_time = work[work_begin].b;

    if (!work_empty()) {
      work[work_begin].b -= new_time;
      if (work[work_begin].b == 0)
	work_begin++;
    }

    if ( !less_empty()) {
      less[less_end].a -=  new_time;
      if (less[less_end].a == 0) {		//skoncil pracu 1.
	work_end++;
        work[work_end] = less[less_end];
	less_end--;
      }
    }
    else
      if ( !equal_empty()) {
	equal[equal_end].a -= new_time;
        if (equal[equal_end].a == 0) {
	  work_end++;
          work[work_end] = equal[equal_end];
	  equal_end--;
        }
      }
      else 
	if ( !great_empty()) {
	  great[great_end].a -= new_time;
	  if (great[great_end].a == 0) {
	    work_end++;
            work[work_end] = great[great_end];
            great_end--;
          }
	}
    cas += new_time;  
  }
}

int main(void) {
  input();
  sort();
  solve();	
  return 0;
}
