#ifndef _SCHODY_H_
#define _SCHODY_H_

#include <stdio.h>

#define MAXN 1000

/* Prototypy funkcii */
void Init_game(int *, int *);
void Turn(int, int, int *, int *);

/* Najlepsi hrac, akeho sme boli schopni vymysliet */
int mojesuper_tajne_pole__[MAXN+1];
int mojesuper_tajne_n__;
int mojesuper_tajne_max__;
int init_ialized__=0;
int ha_xor__=1;
int my_xor__=0;

void Init_game(int *n, int *stairs)
 {
  int i;
  char *g;
  FILE *f;
  
  if (init_ialized__)
   { printf("You lamma Usama... called Init_game() twice !"); exit(0); }

//  g=getenv("h4x0r");
  g = "stairs.in";
  mojesuper_tajne_pole__[0]=47;
  if (!g)
   {
    mojesuper_tajne_max__=*n=mojesuper_tajne_n__=rand()%MAXN+1;
    for (i=1;i<=*n;i++) mojesuper_tajne_pole__[i]=rand()%MAXN+1;
    ha_xor__=0;
    exit(1);
   }
  else
   {
    f=fopen(g,"rt");
    fscanf(f,"%d",n); mojesuper_tajne_n__=*n;
    for (i=1;i<=mojesuper_tajne_n__;i++) fscanf(f,"%d",&(mojesuper_tajne_pole__[i]));
    fclose(f);
    mojesuper_tajne_max__=*n;
    while(!mojesuper_tajne_pole__[mojesuper_tajne_max__]) mojesuper_tajne_max__--;
    my_xor__=0;
   }

  for (i=0;i<=*n;i++) stairs[i]=mojesuper_tajne_pole__[i];
  for (i=1;i<=mojesuper_tajne_n__;i+=2) my_xor__^=mojesuper_tajne_pole__[i];
  init_ialized__=1;
 }

void Turn(int from, int coins, int *hisfrom, int *hiscoins)
 {
  int k;
  
  if (!init_ialized__)
   { printf("You lamma Usama... forgot to call Init_game() !"); exit(0); }
  if (from<1 || from>mojesuper_tajne_n__)
   { printf("You fool ... %d is not a stair\n",from); exit(0); }
  if (coins<=0)
   { printf("You are not permitted to steal :-) (%d<=0)\n",coins); exit(0); }
  if (mojesuper_tajne_pole__[from]<coins)
   { printf("You are not permitted to steal :-) (you want to take %d of %d)\n",coins,mojesuper_tajne_pole__[from]); exit(0); }
  my_xor__^=mojesuper_tajne_pole__[from+(from&1)-1];
  mojesuper_tajne_pole__[from]-=coins;
  mojesuper_tajne_pole__[from-1]+=coins;
  my_xor__^=mojesuper_tajne_pole__[from+(from&1)-1];
  if (from==mojesuper_tajne_max__)
   while (mojesuper_tajne_pole__[mojesuper_tajne_max__]==0) mojesuper_tajne_max__--;
  if (mojesuper_tajne_max__==0)
   { printf("Dump.  Core dump.\n"); exit(0); }

/*  printf("US: ");
  for (k=0;k<mojesuper_tajne_n__;k++) printf("%d ",mojesuper_tajne_pole__[k]);
  printf("%d\n",mojesuper_tajne_pole__[mojesuper_tajne_n__]);*/

  *hisfrom=mojesuper_tajne_max__;
  *hiscoins=rand()%mojesuper_tajne_pole__[*hisfrom]+1;

  if (my_xor__)
   {
    for (k=1;k<=mojesuper_tajne_n__;k+=2)
     if ((*hiscoins=my_xor__^mojesuper_tajne_pole__[k])<mojesuper_tajne_pole__[k])
      {
       *hisfrom=k;
       *hiscoins=mojesuper_tajne_pole__[k]-*hiscoins;
       break;
      }
    if (k>mojesuper_tajne_n__)
     {
      printf("BUUF\n");
     }
   }
  
  my_xor__^=mojesuper_tajne_pole__[*hisfrom+(*hisfrom&1)-1];
  mojesuper_tajne_pole__[*hisfrom]-=*hiscoins;
  mojesuper_tajne_pole__[*hisfrom-1]+=*hiscoins;
  my_xor__^=mojesuper_tajne_pole__[*hisfrom+(*hisfrom&1)-1];
  if (*hisfrom==mojesuper_tajne_max__)
   while (mojesuper_tajne_pole__[mojesuper_tajne_max__]==0) mojesuper_tajne_max__--;
  if (mojesuper_tajne_max__==0)
   { printf("Knock, knock... wake up Neo !\n"); exit(0); }

/*  printf("CM: ");
  for (k=0;k<mojesuper_tajne_n__;k++) printf("%d ",mojesuper_tajne_pole__[k]);
  printf("%d\n",mojesuper_tajne_pole__[mojesuper_tajne_n__]);*/
 }

#endif /* _SCHODY_H_ */
