#include <stdio.h>
#include <stdlib.h>

#include "gamelib.h"

#define r_MAX 32
static int r_M, r_N;
static int r_l[r_MAX], r_r[r_MAX];

static void r_init(void)
{
  int i;
  for (i=0; i<r_M; i++)
    {
      r_l[i] = 0;
      r_r[i] = r_N-1;
    }
  srand(12345);
}

static void r_move(int row, int delta)
{
  r_r[row] += delta;
}

static void r_ask(int *prow, int *pdelta)
{
  int i,d,z=0,pos[r_MAX];
  for (i=0; i<r_M; i++)
    if (r_r[i] >= 2)
      pos[z++] = i;
  if (!z)
    g_giveup();
  i = pos[random() % z];
  do
    d = random() % r_r[i];
  while (d == r_l[i]);
  *prow = i;
  *pdelta = d - r_l[i];
  r_l[i] = d;
}

int main(void)
{
  g_init(&r_M, &r_N);
  r_init();
  for(;;)
    {
      int r, d;
      r_ask(&r, &d);
      g_move(r, d);
      g_ask(&r, &d);
      r_move(r, d);
    }
}
