#include <assert.h>
#include <stdio.h>

int N[100100];
int C[100100];

char dig[] = { '0', '1', '2', '3', '4',
    '5', '6', '7', '8', '9', 'a', 'b',
    'c', 'd', 'e', 'f' };
int lz;

int gcd(int a, int b) /* a < b */
{
    if (a == 0) return b;
    return gcd(b%a, a);
}

void hex(int h)
{
    assert(h >= 0 && h <= 15);
    if (!h && !lz)
        return;
    putchar(dig[h]);
    lz = 1;
}

int main()
{
    int n;
    int i;
    int* t = C;
    int* t2;
    int tmp = 0;
    int mask = 1;
    long long carry = 0;

    scanf("%d", &n);

    for (i=1; i<=n; i++)
        C[gcd(i,n)]++;

    for(i=0; i<=n+5;) {
        if (C[i]&1)
            tmp |= mask;
        C[i+1] += C[i]/2;

        i++;
        mask <<= 1;

        if (!(i%24)) {
            *(t++) = tmp;
            mask = 1;
            tmp = 0;
        }
    }

    *t = tmp;
    t2 = t;

    while (t >= C) {
        long long s = *t + (((long long)carry)<<24);
        *t = s/n;
        carry = s%n;
        t--;
    }

    assert(carry == 0);

    t = t2;
    while (t >= C) {
        hex(*t >> 20);
        hex((*t >> 16) & 0xf);
        hex((*t >> 12) & 0xf);
        hex((*t >> 8) & 0xf);
        hex((*t >> 4) & 0xf);
        hex(*t & 0xf);
        t--;
    }
    putchar('\n');

    return 0;
}

