#if 1
#include <stdio.h>
static inline int gc(void) { return getchar(); }
static inline void write_char(int c) { putchar(c); }
#else
#include "svio.h"
static int gclen = -1, gcpos = -1;
static int gc(void)
{
 restart:
  if (gcpos < gclen)
    {
      gcpos++;
      return read_char();
    }
  else if (gclen >= 0)
    {
      gcpos = gclen = -1;
      return '\n';
    }
  else
    {
      gcpos = 0;
      gclen = read_strlen();
      goto restart;
    }
}
#endif

#define MAX 1000000

int q[MAX];
int t[4], neg;

static void xf(int i)
{
  if (q[i] == -1)
    write_char('a' + neg);
  else if (q[i] == -2)
    write_char('a' + !neg);
  else
    {
      int j, z[4];
      i++;
      for (j=0; j<4; j++)
	{
	  if (q[i] >= 0)
	    {
	      z[j] = i;
	      i = q[i] + 1;
	    }
	  else
	    z[j] = i++;
	}
      write_char('(');
      for (j=0; j<4; j++)
	xf(z[t[j]]);
      write_char(')');
    }
}

int main(void)
{
  int N, i, j, sp, xp;

  sp = MAX;
  xp = 1;
  for (i=0;i<MAX;i++)
    switch (gc())
      {
      case 'a':
	if (!xp--)
	  return 120;
	q[i] = -1;
	break;
      case 'b':
	if (!xp--)
	  return 120;
	q[i] = -2;
	break;
      case '(':
	if (!xp--)
	  return 120;
	q[i] = sp | (xp << 28);
	sp = i;
	xp = 4;
	break;
      case ')':
	if (sp < 0)
	  return 102;
	if (xp)
	  return 121;
	j = q[sp] & ((1 << 28) - 1);
	xp = q[sp] >> 28;
	q[sp] = i;
	q[i] = sp;
	sp = j;
	break;
      case '\n':
	goto done;
      default:
	return 101;
      }
  return 109;
 done:
  if (sp < MAX)
    return 103;
  if (xp)
    return 122;
  N = i;

  t[0] = 0; t[1] = 1; t[2] = 2; t[3] = 3;
  neg = 0;
  for (i=0;;i++)
    switch (gc())
      {
      case 'L':
	j = t[0]; t[0] = t[1]; t[1] = t[3]; t[3] = t[2]; t[2] = j;
	break;
      case 'R':
	j = t[0]; t[0] = t[2]; t[2] = t[3]; t[3] = t[1]; t[1] = j;
	break;
      case 'X':
	j = t[0]; t[0] = t[1]; t[1] = j;
	j = t[2]; t[2] = t[3]; t[3] = j;
	break;
      case 'Y':
	j = t[0]; t[0] = t[2]; t[2] = j;
	j = t[1]; t[1] = t[3]; t[3] = j;
	break;
      case 'N':
	neg = !neg;
	break;
      case '\n':
	goto dotwo;
      default:
	return 112;
      }
 dotwo:

  if (N)
    xf(0);
  write_char('\n');
  return 0;
}
