#include <cstdio>
#include <cstdlib>
#include <vector>
using namespace std;

vector<int> p;

long long cash(){
	vector<vector<long long> > d;
	d.resize(p.size());
	for(unsigned int i=0;i<d.size();i++)d[i].resize(p[0]+10,0);
	for(int i=0;i<=p[0];i++)d[0][i]=i;
	for(unsigned int i=1;i<p.size();i++){
		for(int j=1;j<=p[i];j++){
			d[i][j]=d[i-1][p[i-1]]+d[i][j-1]-d[i-1][j-1];
		}
	}
	long long m=0;
	for(unsigned int i=-0;i<d.size();i++){
		m+=d[i][p[i]];
	}
	return m;
}

int main(int argc, char **argv){
	if(argc<4){
		printf("WRONG Grrr... bad arguments\n");	
		return 1;
	}
	FILE *in=fopen(argv[1],"r");
	FILE *ts=fopen(argv[2],"r");
	FILE *out=fopen(argv[3],"r");
	int N,poc,gpoc;
	fscanf(in,"%d ",&N);
	fscanf(ts,"%d ",&poc);
	fscanf(out,"%d ",&gpoc);
	if(poc!=gpoc){
		printf("WRONG Number of partitiont does not match!\n");
		return 1;
	}
	int num=0;
	while(!feof(ts)){
		int a;
		fscanf(ts," %d ",&a);
		num+=a;
		p.push_back(a);
	}
	if(num!=N){
		printf("WRONG The partition is not the right partition.\n");
		return 1;
	}
	if(poc!=cash()){
		printf("WRONG The number of subpartitions did not match. Incorrect output.\n");
		return 1;
	}
	printf("OK\n");
	return 0;
}
