#include <cstdio>
#include <map>
#include <set>
#include <iostream>
#include <vector>

#define H first
#define T second

#define YSTART 0
#define XLN 1
#define YEND 2

#define XSTART 0
#define XEND 1
#define YC 7

#define CONT(c,v) ((c).find(v)!=(c).end())
#define INS(c,v) (c).insert(v)
#define DEL(c,v) if((c).find(v)!=(c).end())(c).erase((c).find(v))

using namespace std;

typedef pair<int,int> TC;
typedef pair<int,int> CT;
typedef pair<int,int> X12;
typedef pair<CT,CT> Event;

int N;
vector<Event> evts;

void pt(map<int,int> d)
{
  cerr << '[';
  for(map<int,int>::iterator i=d.begin();i!=d.end();i++)
  {
    cerr << '(' << (*i).H << '/' << (*i).T << ") ";
  }
  cerr << ']' << endl;
}

long long solve()
{
  map<int,int> trci;
  map<X12,long long> vrchy;
  vector<Event>::iterator ev;
  int od, lvl=0;

  long long RES=0;

  sort(evts.begin(),evts.end());

  cerr << evts.size() << endl;

  for(ev=evts.begin();ev!=evts.end();ev++)
  {
    Event evt=*ev;
    cerr << evt.H.H << ':' << evt.H.T << ',' << evt.T.H << ":" << evt.T.T << "  ";
    if(evt.H.T==YSTART)
    {
      if(!CONT(trci,evt.T.H))trci[evt.T.H]=0;
      trci[evt.T.H]=trci[evt.T.H]+1;
    }
    else if(evt.H.T==YEND)
    {
      trci[evt.T.H]=trci[evt.T.H]-1;
      if(trci[evt.T.H]==0)
      {
        DEL(trci,evt.T.H);
        map<X12,long long> nv;
        for(map<X12,long long>::iterator i=vrchy.begin();i!=vrchy.end();i++)
          if(((*i).H.H!=evt.T.H)&&((*i).H.T!=evt.T.H))INS(nv,*i);
        vrchy=nv;
      }
    }
    else//evt.H.T==XLN
    {
      if(evt.T.T==XSTART)
      {
        if(lvl==0)od=evt.T.H;
        lvl++;
      }
      else
      { //evt.T.T==XEND
        lvl--;
        if(lvl==0)
        {
          for(map<X12,long long>::iterator i=vrchy.begin();i!=vrchy.end();i++)
            if((od<=(*i).H.H)&&((*i).H.T<=evt.T.H))
            {
              RES+=(*i).T;
              cerr << " +" << (*i).T << "{" << (*i).H.H << "," << (*i).H.T << "}" << " ";
            }

          for(map<int,int>::iterator i=trci.begin();i!=trci.end();i++)
          {
            map<int,int>::iterator j=i;
            j++;
            for(;j!=trci.end();j++)if((od<=(*i).H)&&((*j).H<=evt.T.H))
            {
              X12 vr=X12((*i).H,(*j).H);
              if(!CONT(vrchy,vr))vrchy[vr]=0;
              vrchy[vr]=vrchy[vr]+1;
            }
          }
        }
      }
    }
    pt(trci);
  }

  return RES;
}

int main()
{
  cin >> N;
  for(int i=0;i<N;i++)
  {
    int a,b,c,d;
    cin >> a >> b >> c >> d;
    if(a>c)swap(a,c);
    if(b>d)swap(b,d);
    if(b==d)
    {
      evts.push_back(Event(CT(b,XLN),CT(a,XSTART)));
      evts.push_back(Event(CT(b,XLN),CT(c,XEND)));
    }
    else if(a==c)
    {
      evts.push_back(Event(CT(b,YSTART),CT(a,YC)));
      evts.push_back(Event(CT(d,YEND),CT(a,YC)));
    }
    else cout << "BLBY VSTUP " << a << b << c << d << endl;
  }
  cout<<solve()<<endl;
  return 0;
}
