#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <queue>
#include <list>
#include <stack>
#include <map>
#include <set>
#include <functional>
#include <algorithm>
using namespace std;

#define CLEAR(t) memset((t),0,sizeof(t))
#define FOR(i,a,b) for(__typeof(a)i=(a);i<=(b);++i)
#define FORD(i,a,b) for(__typeof(a)i=(a);i>=(b);--i)
#define REP(i,n) for(__typeof(n)i=0;i<(n);++i)
#define FOREACH(it,c) for(__typeof((c).begin()) it=(c).begin();it!=(c).end();++it)
#define DRAIN(t,a) for(;!(a).empty();(a).pop())
#define PB(x) push_back(x)
#define MP(x,y) make_pair((x),(y))
#define $ size()
#define $$ length()

#define PII pair<int,int>
#define x(a) (a).first
#define y(a) (a).second
#define POS(a) y(a)][x(a)

#define PPII pair<pair<int,int>,pair<int,int> >


vector<vector<pair<int,int> > > H,V;
vector<int> Hp,Vp;

vector<pair<int,pair<int,int> > > horiz,vert;

int N;

bool is_rectangle(int x1,int y1,int x2,int y2){
//	cout<<x1<<" "<<y1<<" "<<x2<<" "<<y2<<endl;
	if(x1==x2||y1==y2)return false;
	bool is1=false;
	bool is2=false;
	bool is3=false;
	bool is4=false;
	REP(i,horiz.$){
		if(horiz[i].first==y1&&x1>=horiz[i].second.first&&x2<=horiz[i].second.second)is1=true;
		if(horiz[i].first==y2&&x1>=horiz[i].second.first&&x2<=horiz[i].second.second)is2=true;
	}
	REP(i,vert.$){
		if(vert[i].first==x1&&y1>=vert[i].second.first&&y2<=vert[i].second.second)is3=true;
		if(vert[i].first==x2&&y1>=vert[i].second.first&&y2<=vert[i].second.second)is4=true;
	}
	return is1&&is2&&is3&&is4;
}

int main(){
	scanf("%d ",&N);
	REP(i,N){
		int x1,y1,x2,y2;
		scanf("%d %d %d %d ",&x1,&y1,&x2,&y2);
		if(x1>x2)swap(x1,x2);
		if(y1>y2)swap(y1,y2);
		if(y1==y2)horiz.push_back(MP(y1,MP(x1,x2)));
		if(x1==x2)vert.push_back(MP(x1,MP(y1,y2)));
	}

	sort(horiz.begin(),horiz.end());
	sort(vert.begin(),vert.end());
	REP(i,horiz.$){
		int c=horiz[i].first;
		Hp.push_back(c);
		unsigned int ind=i;	
		while(i<horiz.$&&horiz[i].first==c)i++;
		H.resize(H.$+1);
		int k=H.$-1;
		FOR(j,ind,i-1)H[k].push_back(horiz[j].second);
		if(i!=horiz.$)i--;
		int j=0;
		FOR(i,(unsigned int)1,H[k].$-1){
			if(H[k][j].second>=H[k][i].first){
				H[k][j].second=max(H[k][j].second,H[k][i].second);
			}else{
				j++;
				H[k][j]=H[k][i];
			}
		}
		H[k].resize(j+1);
	}
	REP(i,vert.$){
		int c=vert[i].first;
		Vp.push_back(c);
		unsigned int ind=i;	
		while(i<vert.$&&vert[i].first==c)i++;
		V.resize(V.$+1);
		int k=V.$-1;
		FOR(j,ind,i-1)V[k].push_back(vert[j].second);
		if(i!=vert.$&&i!=ind)i--;
		int j=0;
		FOR(i,(unsigned int)1,V[k].$-1){
			if(V[k][j].second>=V[k][i].first){
				V[k][j].second=max(V[k][j].second,V[k][i].second);
			}else{
				j++;
				V[k][j]=V[k][i];
			}
		}
		V[k].resize(j+1);
	}
	horiz.resize(0);
	vert.resize(0);
	REP(i,H.$)REP(j,H[i].$)horiz.push_back(MP(Hp[i],H[i][j]));
	REP(i,V.$)REP(j,V[i].$)vert.push_back(MP(Vp[i],V[i][j]));
	set<pair<int,int> > body;
	REP(i,horiz.$)
		REP(j,vert.$){
			int a,b,c,d,e,f;
			a=horiz[i].first;
			b=vert[j].second.first;
			c=vert[j].second.second;
			d=vert[j].first;
			e=horiz[i].second.first;
			f=horiz[i].second.second;
			if(b<=a&&a<=c&&e<=d&&d<=f)body.insert(MP(d,a));
		}
	long long sum=0;
	vector<pair<int,int> > bod(body.size());
	copy(body.begin(),body.end(),bod.begin());
	REP(i,bod.$){
//		cout<<bod[i].first<<" "<<bod[i].second<<endl;
	}
	set<PPII > was;
	REP(i,bod.$)FOR(j,i+1,bod.$){
		int x1,y1,x2,y2;
		x1=bod[i].first;
		x2=bod[j].first;
		y1=bod[i].second;
		y2=bod[j].second;
		if(x1>x2)swap(x1,x2);
		if(y1>y2)swap(y1,y2);
//		cout<<x1<<" "<<y1<<" "<<x2<<" "<<y2<<endl;
		if(was.find(MP(MP(x1,x2),MP(y1,y2)))==was.end()&&is_rectangle(x1,y1,x2,y2)){
			sum++;
			was.insert(MP(MP(x1,x2),MP(y1,y2)));
			//cout<<x1<<" "<<y1<<" "<<x2<<" "<<y2<<endl;
		}
	}
	printf("%lld\n",sum);
	return 0;
}

