{
  Problem B : Step by Step
  Author    : Yuan Hao
  Algorithm : Dynamic Programming
}
program Step_by_Step;
const
  fn_in='step.inp';
  fn_out='step.out';
  size=15000;
var
  w,z,ans,a,b:longint;
  h:array[0..size] of longint;

  procedure init;
  begin
    assign(input,fn_in);
    reset(input);
    readln(w,z);
    readln(a,b);
    close(input);
  end;

  procedure main;
  var i:longint;
  begin
    fillchar(h,sizeof(h),0);
    h[w mod size]:=1;
    for i:=w-1 downto z do
      h[i mod size]:=h[(i+a) mod size]+h[(i+b) mod size];
    ans:=h[z mod size];
  end;

  procedure out;
  begin
    assign(output,fn_out);
    rewrite(output);
    writeln(ans);
    close(output);
  end;

  begin
    init;
    main;
    out;
  end.