{
  Problem A : Tenshi no Yubikili
  Author    : Yuan Hao
  Algorithm : High Precision
}

program Yubikili;
const
  fn_in='yubikili.inp';
  fn_out='yubikili.out';
  maxlen=1000;
var
  a:array[1..maxlen] of longint;
  b,len,ans:longint;

  procedure init;
  var ch:char;
  begin
    assign(input,fn_in);
    reset(input);
    readln(b);
    len:=0;
    while(not eoln(input)) do
    begin
      read(ch);
      inc(len);
      a[len]:=ord(ch)-ord('0');
    end;
    close(input);
  end;

  procedure main;
  var i:longint;
  begin
    ans:=0;
    for i:=1 to len do
    begin
      ans:=ans*10+a[i];
      ans:=ans mod b;
    end;
    if ans=0 then ans:=b;
  end;

  procedure out;
  begin
    assign(output,fn_out);
    rewrite(output);
    writeln(ans);
    close(output);
  end;

  begin
    init;
    main;
    out;
  end.