{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y-}
{$M 65520,0,655360}
{Problem: NOI Regional Simulation by Tenshi, Punctuation Mark}
{Author: Zig}
{Date: 2001-Nov-21}
program __program_punct;
const
  InputFileName='punct.inp';
  OutputFileName='punct.out';
const
  maxlen=10;
  maxn=100;
  maxs=255;
  maxc=50;
var
  w:array [1..maxn] of string[maxlen];
  can:array [1..maxs,1..10] of boolean;
  c:array [0..maxs,0..maxc] of boolean;
  d:array [0..maxs] of integer;
  s:string;
  n,i,j,k,p:integer;
procedure match(var p:string);
var
  next:array [1..maxlen] of integer;
  i,k,l:integer;
begin
  l:=length(p);
  for i:=1 to l do p[i]:=upcase(p[i]);
  next[1]:=0;
  i:=1;k:=0;
  while i<l do
  begin
    if (k=0) or (p[i]=p[k]) then
    begin
      inc(i);inc(k);
      next[i]:=k;
    end else k:=next[k];
  end;
 k:=1;
 for i:=1 to length(s) do
 begin
   while (k>0) and (s[i]<>p[k]) do k:=next[k];
   inc(k);
   if k>l then
   begin
     can[i,l]:=true;
     k:=next[l]+1;
   end;
 end;
end;
begin
  assign(input,InputFileName);
  assign(output,OutputFileName);
  reset(input);rewrite(output);
  readln(n);
  for i:=1 to n do readln(w[i]);
  readln(s);
  for i:=1 to length(s) do s[i]:=upcase(s[i]);
  fillchar(can,sizeof(can),false);
  for i:=1 to n do match(w[i]);
  fillchar(d,sizeof(d),$FF);
  d[0]:=0;
  for i:=1 to length(s) do
   if d[i-1]>=0 then
   begin
     fillchar(c,sizeof(c),false);
     c[i-1,0]:=true;
     for j:=i to length(s) do
     begin
       for k:=1 to 10 do
        if can[j,k] then
         for p:=1 to 50 do
          c[j,p]:=c[j,p] or c[j-k,p-1];
       if d[i-1]+1>d[j] then
       begin
         for k:=3 to 50 do
          if c[j,k] and ((j-i+1) mod k=0) then
          begin
            d[j]:=d[i-1]+1;
            break;
          end;
       end;
     end;
   end;
  if d[length(s)]<0 then writeln(0) else writeln(d[length(s)]);
  close(input);close(output);
end.