#include<iostream.h>
#include<fstream.h>
#include<string.h>

#define maxn 103

const int maxlen = 33;

class HP
{
public:
	int len;
	int s[maxlen];
	HP() { (*this)=0; };
	HP(int inte) { (*this)=inte; };
	HP(const char*str) { (*this)=str; };
	friend ostream& operator<<(ostream &out,const HP &x);
	HP operator=(int inte);
	HP operator=(const char*str);
	HP operator*(const HP &b);
	HP operator+(const HP &b);
	HP operator-(const HP &b);
	HP operator/(const HP &b);
	HP operator%(const HP &b);
	int Compare(const HP &b);
	
};

ostream& operator<<(ostream &out,const HP &x)
{
	int i;
	for(i=x.len;i>=1;i--)
		out<<x.s[i];
	return out;
}
	
HP HP::operator=(const char *str)
{
	memset(s,0,sizeof(s));
	len=strlen(str);
	int i;
	for(i=1;i<=len;i++)
		s[i]=str[len-i]-'0';	
	return *this;
}
HP HP::operator=(int inte)
{
	memset(s,0,sizeof(s));
   len=0;
	if(inte==0)
	{
		len=1;
		return (*this);		
	}	
	while(inte>0)
	{
		len++;
		s[len]=inte%10;
		inte/=10;
	}	
	return (*this);
}

HP HP::operator*(const HP &b)
{
	HP c;
	int i,j;
	for(i=1;i<=len;i++)
		for(j=1;j<=b.len;j++)
		{
			c.s[i+j-1] += s[i] * b.s[j];
			c.s[i+j]   += c.s[i+j-1] / 10;						
			c.s[i+j-1] %= 10;
		}
	c.len = len+b.len-1;
	while(c.s[c.len+1]>0)
		c.len++;
	return c;
}

HP HP::operator+(const HP &b)
{
	HP c;
	int i;
	for(i=1;((i<=len)||(i<=b.len));i++)
	{
		c.s[i]+=s[i]+b.s[i];
		c.s[i+1]+=c.s[i]/10;
		c.s[i]=c.s[i]%10;
	}
	while((i>1)&&(c.s[i]==0))
		i--;
	c.len=i;
	return c;
}

int n;
HP a[maxn];

int main()
{
	ifstream cin("poly.inp");
	ofstream cout("poly.out");
	int i,j,k;
	HP x;
	cin>>n;
	a[0]=1;
	for(i=1;i<=n;i++)
	{
		cin>>k;
		x=-k;
		for(j=i;j>0;j--)
			a[j]=a[j]+a[j-1]*x;
	}
	for(i=1;i<=n;i++)
			cout<<a[i]<<endl;			
	return 0;
}
