{$Q-,R-,S-}
Const
    Infile                          ='kgood.dat';
    Outfile                         ='kgood.out';
    Maxnumlen                       =20;
    Maxlen                          =10;
    Maxk							=16;
Type
    Tnum                            =array[1..Maxnumlen]of longint;
    Tdp								=array[1..Maxlen,0..Maxk-1]of Tnum;
Var
    dp								:Tdp;
    k,len                           :longint;

Procedure csh(x,y:longint);
var
    i                               :longint;
begin
    for i:=1 to Maxnumlen do
     dp[x,y][i]:=0;
end;

Procedure init;
var
	i								:longint;
begin
    assign(input,Infile); reset(input);
     read(k,len);
    close(input);
    if (k=0)or(len=0)
     then begin
              assign(output,Outfile); rewrite(output);
               writeln(0);
              close(output);
              halt;
          end;
    for i:=0 to k-1 do
     begin
         csh(1,i);
         if i>0
          then dp[1,i][Maxnumlen]:=1;  {important!!!}
     end;
end;

Procedure jia(a,b:Tnum; var c:Tnum);
var
	i,s,g							:longint;							
begin
    g:=0;
    for i:=Maxnumlen downto 1 do
     begin
         s:=a[i]+b[i]+g;
         c[i]:=s mod 10;
         g:=s div 10;
     end;
end;

Procedure work;
var
	i,j,pre							:longint;
begin
    for i:=2 to len do
     for j:=0 to k-1 do
      begin
          csh(i,j);
          for pre:=0 to k-1 do
           if (pre-j<>1)and(j-pre<>1)
            then jia(dp[i,j],dp[i-1,pre],dp[i,j]);
      end;
end;

Procedure out;
var
	result						:Tnum;
	j							:longint;
begin
    assign(output,Outfile); rewrite(output);
     for j:=1 to Maxnumlen do
      result[j]:=0;
     for j:=0 to k-1 do
      jia(result,dp[len,j],result);
     j:=1;
     while (j<=Maxnumlen)and(result[j]=0) do
      inc(j);
     if j>Maxnumlen
      then write(0)      {important!!!}
      else begin
                while j<=Maxnumlen do
                 begin
                     write(result[j]);
                     inc(j);
                 end;
           end;
     writeln;
    close(output);
end;

Begin
    init;
    work;
    out;
End.
