program prob3;

var
  can:array[-50..50,-50..50,-50..50] of Boolean;
  best:array[-51..50,-51..50,-51..50] of Byte;
  x0,y0,z0,max:Longint;

procedure Init;
  var
    i,n,x,y,z,t,j:Longint;
    kind:Char;
  procedure SwapIt(var a,b:Longint);
    var
      c:Longint;
    begin
      c:=a;a:=b;b:=c;
    end;  
  begin
    max:=0;
    Fillchar(can,Sizeof(can),True);
    Fillchar(best,Sizeof(best),0);
    Readln(x0,y0,z0,n);
    for i:=1 to n do
      begin
        Readln(kind,x,y,z,t);
        case kind of
          'x':
            begin
              if x>t then SwapIt(x,t);
              for j:=x to t do
                can[j,y,z]:=False;
            end;
          'y':
            begin
              if y>t then SwapIt(y,t);
              for j:=y to t do
                can[x,j,z]:=False;
            end;
          'z':
            begin
              if z>t then SwapIt(z,t);
              for j:=z to t do
                can[x,y,j]:=False;
            end;
        end;
      end;
  end;

procedure Work;
  var
    x,y,z:Longint;
  function Minest(a,b,c,d,e,f,g:Longint):Longint;
    function Min(a,b:Longint):Longint;
      begin
        if a<b then Min:=a else Min:=b;
      end;
    begin
      Minest:=Min(Min(Min(a,b),Min(c,d)),Min(Min(e,f),g));
    end;
  begin
    for x:=-x0 to x0 do
      for y:=-y0 to y0 do
        for z:=-z0 to z0 do
          begin
            if can[x,y,z] then best[x,y,z]:=
            Minest(best[x-1,y,z],best[x,y-1,z],best[x,y,z-1]
            ,best[x-1,y-1,z],best[x-1,y,z-1],best[x,y-1,z-1]
            ,best[x-1,y-1,z-1])+1;
            if best[x,y,z]>max then max:=best[x,y,z];
          end;
  end;

begin
  Init;
  Work;
  Writeln(max);
{  Readln;Readln;Readln;}
end.