program second;
const
  maxn=10;
type
  Ttreepoint=^Ttree;
  Ttree=record
          types:shortint;
          s:string;
          left,right:Ttreepoint;
        end;
var
  n:integer;
  score:array [1..maxn] of integer;
  prob:array [1..maxn] of Ttreepoint;
procedure init;
  var
    i:integer;
    s:string;
    ch:char;
    canbreak:set of char;
  procedure readblank(num:integer);
    var
      i:integer;
    begin
      for i:=1 to num do
        begin
          read (ch);
          while ch in canbreak do
            read (ch);
        end;
    end;{readblank}
  procedure readdata;
    begin
      readblank(1);
      if ch='.' then
        exit;
      case ch of
        'I':begin
              readblank (1);
              s:='IF';
            end;
        'T':begin
              readblank (1);
              if ch='H' then
                begin
                  readblank (2);
                  s:='THEN'
                end
              else
                begin
                  readblank (3);
                  s:='TRADE';
                end;
            end;
        'E':begin
              readblank (3);
              s:='ELSE';
            end;
        'A':begin
              readblank (2);
              s:='AND';
            end;
        'O':begin
              readblank (1);
              s:='OR';
            end;
        '=','#','1','2':s:=ch;
        'N':begin
              readblank (3);
              s:='NULL';
            end;
        'M':begin
              readblank(1);
              s:='0';
            end;
        'Y':begin
              readblank (3);
              s:='1';
            end;
        'L':begin
              readblank (3);
              s:='LAST';
            end;
        'C':begin
              readblank (4);
              s:='CHEAT'
            end;
      end;
    end;{readdata}
  procedure make(p:Ttreepoint);
    begin
      readdata;
      if s='TRADE' then
        p^.types:=2
      else
        if s='CHEAT' then
          p^.types:=3
        else
          begin
            p^.types:=1;
            p^.s:='';
            readdata;
            while s<>'THEN' do
              begin
                if s<>'LAST' then
                  begin
                    if s='TRADE' then
                      s:='1';
                    if s='CHEAT' then
                      s:='2';
                    if s='NULL' then
                      s:='0';
                    p^.s:=p^.s+s;
                  end;
                readdata;
              end;
            new(p^.left);
            make(p^.left);
            readdata;{ELSE}
            new(p^.right);
            make(p^.right);
          end;
    end;{make}
  begin
    readln (n);
    canbreak:=[' ',#13,#10];
    for i:=1 to n do
      begin
        new(prob[i]);
        make(prob[i]);
        readln;
      end;
  end;{init}
procedure solve;
  var
    i,j,k:integer;
    last:array [1..2,1..2] of shortint;
    t1,t2:shortint;
    p:Ttreepoint;
    s:string;
    my,your,now:shortint;
  function GetTrue(head,tail:integer):boolean;
    var
      u:shortint;
    begin
      while s[head]=' ' do
        inc(head);
      while s[tail]=' ' do
        dec(tail);
      for u:=head to tail-1 do
        if s[u]='O' then
          break;
      if s[u]='O' then
        begin
          GetTrue:=GetTrue(head,u-1) or GetTrue(u+2,tail);
          exit;
        end;
      for u:=head to tail-2 do
        if s[u]='A' then
          break;
      if s[u]='A' then
        begin
          GetTrue:=GetTrue(head,u-1) and GetTrue(u+3,tail);
          exit;
        end;
      if s[head]='0' then
        now:=my
      else
        now:=your;
      if s[tail-1]='=' then
        GetTrue:=ord(s[tail])-48=last[ord(s[head+1])-48,now]
      else
        GetTrue:=ord(s[tail])-48<>last[ord(s[head+1])-48,now];
    end;{Gettrue}
  function Get(i:integer):shortint;
    begin
      p:=prob[i];
      while p^.types=1 do
        begin
          s:=p^.s;
          if GetTrue(1,length(s)) then
            p:=p^.left
          else
            p:=p^.right;
        end;
      Get:=p^.types-1;
    end;{Get}
  begin
    fillchar (score,sizeof(score),0);
    for i:=1 to n-1 do
      for j:=i+1 to n do
        begin
          fillchar (last,sizeof(last),0);
          for k:=1 to 10 do
            begin
              my:=1;
              your:=2;
              t1:=Get(i);
              my:=2;
              your:=1;
              t2:=Get(j);
              last[2]:=last[1];
              last[1,1]:=t1;
              last[1,2]:=t2;
              if t1=t2 then
                if t1=1 then
                  begin
                    inc(score[i]);
                    inc(score[j]);
                  end
                else
                  begin
                    dec(score[i]);
                    dec(score[j]);
                  end
              else
                if t1=1 then
                  begin
                    dec(score[i],2);
                    inc(score[j],2);
                  end
                else
                  begin
                    inc(score[i],2);
                    dec(score[j],2);
                  end;
            end;
        end;
  end;{solve}
procedure out;
  var
    i:integer;
  begin
    for i:=1 to n-1 do
      write (score[i],' ');
    writeln (score[n]);
  end;{out}
begin
  init;
  solve;
  out;
end.