  {$I-,Q-,R-,S-}
Const MaxN              = 12;
      Left              = -(MaxN-2) Div 2+1;
      Right             = MaxN;
      Top               = (MaxN+1) Div 2;
      Total             = (Right-Left+1)*Top-Abs(Left)-1;
      OutName           = 'Output.txt';

Type  Arr               = Record
        x,y             : Integer;
      End;
      Arr2              = Array[1..Total] of Integer;
      Arr3              = Array[1..Total] of Boolean;

Var   Map               : Array[0..MaxN+1,-MaxN..MaxN+1] of Integer;
      P                 : Array[-MaxN..Total] of Arr;
      A                 : Array[1..MaxN] of Integer;
      Join              : Array[1..Total,1..4] of Integer;
      Q                 : Array[1..100] of Integer;
      Num,C             : Arr2;
      B                 : Arr3;
      TotalPink         : Longint;
      N                 : Integer;

Procedure Init;
Var   i,j               : Integer;
      T                 : Integer;
Begin
  T := 0;
  For i := 1 to N do
    Begin
      Inc(T); P[T].x := 1; P[T].y := i;
      Map[1,i] := T;
    End;
  For i := 0 downto Left do
    Begin
      Map[1,i] := i; P[i].x := 1; P[i].y := i;
    End;

  For i := 2 to (N+1) Div 2 do
    For j :=-(N Div 2-2) to N do
      Begin
        Inc(T); P[T].x := i; P[T].y := j;
        Map[i,j] := T;
      End;
  For i := 1 to T do
    Begin
      If Map[P[i].x-1,P[i].y]>0 then
        Begin
          Inc(C[i]); Join[i,C[i]] := Map[P[i].x-1,P[i].y];
        End;
      If Map[P[i].x+1,P[i].y]>0 then
        Begin
          Inc(C[i]); Join[i,C[i]] := Map[P[i].x+1,P[i].y];
        End;
      If Map[P[i].x,P[i].y-1]>0 then
        Begin
          Inc(C[i]); Join[i,C[i]] := Map[P[i].x,P[i].y-1];
        End;
      If Map[P[i].x,P[i].y+1]>0 then
        Begin
          Inc(C[i]); Join[i,C[i]] := Map[P[i].x,P[i].y+1];
        End;
    End;

  For i := (N+1) Div 2+1 to N+1 do
    For j :=-(N Div 2-2) to N do
      Begin
        Inc(T); Map[i,j] := T;
      End;
End;

Function MaxNum(X,Y : Integer) : Integer;
Begin If X>Y then MaxNum := X else MaxNum := Y End;

Function MinNum(X,Y : Integer) : Integer;
Begin If X<Y then MinNum := X else MinNum := Y End;

Function  Pass(L,R,H : Integer) : Boolean;
Var i                : Integer;
    Temp,M           : Array[1..MaxN,1..MaxN] of Integer;

    Function Smaller : Boolean;
      Var j,k        : Integer;
      Begin
        For j := 1 to R-L+1 do
          If Temp[1,j]=1 then Break;
        Smaller := False;
        If j>(R-L) Div 2+1 then Exit;
        For j := 1 to H do
          For k := 1 to R-L+1 do
            If M[j,k]<>Temp[j,k] then
              Begin
                Smaller := Temp[j,k]<M[j,k];
                Exit;
              End;
      End;
Begin
  Pass := False;
  {Turn1}
  Fillchar(Temp,Sizeof(Temp),0);
  For i := 1 to N do Temp[P[A[i]].x,P[A[i]].y-L+1] := 1;
  M := Temp;
      Fillchar(Temp,Sizeof(Temp),0);{Turn2}
      For i := 1 to N do
        Temp[H+1-P[A[i]].x,P[A[i]].y-L+1] := 1;
      If Smaller then Exit;

      Fillchar(Temp,Sizeof(Temp),0);{Turn4}
      For i := 1 to N do
        Temp[H+1-P[A[i]].x,R+1-P[A[i]].y] := 1;
      If Smaller then Exit;

  Fillchar(Temp,Sizeof(Temp),0);{Turn3}
  For i := 1 to N do
    Temp[P[A[i]].x,R+1-P[A[i]].y] := 1;
  If Smaller then Exit;

  If (R-L+1)=H then
    Begin
      Fillchar(Temp,Sizeof(Temp),0);
      For i := 1 to N do
        Temp[P[A[i]].y-L+1,P[A[i]].x] := 1;
      If Smaller then Exit;

      Fillchar(Temp,Sizeof(Temp),0);
      For i := 1 to N do
        Temp[R+1-P[A[i]].y,P[A[i]].x] := 1;
      If Smaller then Exit;

      Fillchar(Temp,Sizeof(Temp),0);
      For i := 1 to N do
        Temp[P[A[i]].y-L+1,H+1-P[A[i]].x] := 1;
      If Smaller then Exit;

      Fillchar(Temp,Sizeof(Temp),0);
      For i := 1 to N do
        Temp[R+1-P[A[i]].y,H+1-P[A[i]].x] := 1;
      If Smaller then Exit;
    End;
  Pass := True;
End;

Procedure Print(L,R,H : Integer);
Var       PrMap       : Array[1..MaxN,-MaxN..MaxN] of Byte;
          i,j         : Integer;
Begin
  If (-L+2>R) or (R-L+1<H) or (Not Pass(L,R,H)) then Exit;
  Inc(TotalPink);
End;

Procedure Try(X,Y,Max : Integer;L,R,H : Integer);
Var       i           : Integer;
          NumBak      : Arr2;
          BBak        : Arr3;
Begin
  NumBak := Num; BBak := B;
  For i := 1 to C[A[X-1]] do
    If Num[Join[A[X-1],i]]=0 then
      Begin
        Inc(Y); Q[Y] := Join[A[X-1],i];
        Num[Q[Y]] := Y;
      End;
  For i := Max+1 to Y do
    Begin
      A[X] := Q[i];
      If BBak[A[X]] then
        Begin
          B[A[X]] := False; BBak[A[X]] := False;
          If X<N then
            Try(X+1,Y,Num[A[X]],
                MinNum(L,P[A[X]].y),MaxNum(R,P[A[X]].y),MaxNum(H,P[A[X]].x))
                 else Begin
                        Print(MinNum(L,P[A[X]].y),MaxNum(R,P[A[X]].y),MaxNum(H,P[A[X]].x));
                      End;
          B[A[X]] := True;
        End;
    End;
  Num := NumBak;
End;

Begin
  Readln(N);
  If N=1 then
    Begin
      Writeln(1); Halt;
    End;
  Init;
  Fillchar(B,Sizeof(B),True);
  A[1] := 1; B[1] := False; Num[1] := -1;
    Try(2,0,0,1,1,1);
    Writeln(TotalPink);
End.
