program rational;
const
  inputfilename='rational.dat';
  outputfilename='rational.out';
  maxn=30000;
var
  N,P,X,Y,A1,B1,A2,B2:longint;
procedure init;
  begin
    assign (input,inputfilename);
    reset (input);
    readln (P,N);
    close (input);
  end;{init}
procedure solve;
  var
    R,PP:Real;
    Y1,Y2:longint;
  function Max(a,b,c,d:longint):boolean;
    begin
      Max:=a*d>b*c;
    end;{Max}
  begin
    PP:=P;
    A1:=1;
    B1:=maxn+1;
    A2:=maxn+1;
    B2:=1;
    for X:=1 to N do
      begin
        R:=X;
        R:=Sqrt(R*R*PP);
        Y1:=Trunc(R);
        Y2:=Y1+1;
        if (Y1<=N) and Max(Y1,X,A1,B1) then
          begin
            A1:=Y1;
            B1:=X;
          end;
        if (Y2<=N) and Max(A2,B2,Y2,X) then
          begin
            A2:=Y2;
            B2:=X;
          end;
      end;
  end;{solve}
procedure out;
  begin
    assign (output,outputfilename);
    rewrite (output);
    writeln (A1,'/',B1,' ',A2,'/',B2);
    close (output);
  end;{out}
begin
  init;
  solve;
  out;
end.