const
  infile  ='rational.dat';
  outfile ='rational.out';

type
  Tkey    =record
             fm,fz:longint;
           end;

var
  n,p	  :longint;
  key1,
  key2	  :Tkey;

procedure init;
begin
  assign(input,infile); reset(input);
    readln(p,n);
  close(input);
end;

function getgcd(a,b:longint):longint;
begin
  if a mod b=0 then
     begin
       getgcd:=b;
       exit;
     end;
  getgcd:=getgcd(b,a mod b);
end;

procedure work;
var i,a,gcd:longint;
    b1,b2,tmp:extended;
begin
  b1:=-1;
  b2:=n+1;
  for i:=1 to n do
    begin
      tmp:=i/sqrt(p);
      a:=trunc(tmp)+1;
      if a>n then a:=n;
      if a=0 then gcd:=0 else gcd:=getgcd(i,a);
      if gcd=1 then
         begin
           if i/a>b1 then
              begin
                b1:=i/a;
                key1.fz:=i;
                key1.fm:=a;
              end;
         end;
      dec(a);
      if abs(i-a*sqrt(p))<1e-8 then dec(A);
      if a=0 then gcd:=0 else gcd:=getgcd(i,a);
      if gcd=1 then
         if i/a<b2 then
            begin
              b2:=i/a;
              key2.fz:=i;
              key2.fm:=a;
            end;
    end;
end;

procedure out;
begin
  assign(output,outfile); rewrite(output);
     writeln(key1.fz,'/',key1.fm,' ',key2.fz,'/',key2.fm);
  close(output);
end;

begin
  init;
  work;
  out;
end.