const
  infile  ='cross.dat';
  outfile ='cross.out';
  limit   =240;

var n,m	  :longint;
    up,down:array [1..200] of longint;
    tot   :array [0..limit,0..limit] of longint;

procedure init;
var i,j:longint;
begin
  assign(input,infile); reset(input);
    read(n,m);
    for i:=1 to n do read(up[i]);
    for j:=1 to m do read(down[j]);
  close(input);
  fillchar(tot,sizeof(tot),0);
end;

function fmax(a,b:longint):longint;
begin
  if a>b then fmax:=a else fmax:=b;
end;

procedure work;
var i,j,k,p,a1,a2:longint;
begin
  for i:=2 to n do
    for j:=2 to m do
      begin
        tot[i,j]:=fmax(tot[i-1,j],tot[i,j-1]);
        if down[j]=up[i] then continue;
        a1:=0; a2:=0;
        for k:=j-1 downto 1 do
          if down[k]=up[i] then
             begin
               a2:=k;
               break;
             end;
        for k:=i-1 downto 1 do
          if up[k]=down[j] then
             begin
               a1:=k;
               break;
             end;
        if (a1>0) and (a2>0) then
           if tot[a1-1,a2-1]+1>tot[i,j] then
              tot[i,j]:=tot[a1-1,a2-1]+1;
      end;
end;

procedure out;
begin
  assign(output,outfile); rewrite(output);
    writeln(tot[n,m]*2);
  close(output);
end;

begin
  init;
  work;
  out;
end.