const
  infile ='satanic.dat';
  outfile='satanic.out';

var
  min,
  n,sum,
  head,
  tail	 :longint;
  map	 :array [1..100,1..100] of longint;
  queue  :array [1..100] of longint;

procedure init;
var i,j:longint;
begin
  assign(input,infile); reset(input);
    read(n);
    sum:=0;
    for i:=1 to n do
      for j:=1 to n do
        begin
          read(map[i,j]);
          if map[i,j]<0 then inc(sum,-map[i,j]);
        end;
  close(input);
end;

function check(hp:extended):boolean;
var i,j:longint;
    hps:array [1..100] of extended;
    modify:boolean;
begin
  fillchar(hps,sizeof(hps),0);
  hps[1]:=hp;
  repeat
    modify:=false;
    for i:=2 to n do
      if hps[i]<sum then
         begin
           for j:=1 to n-1 do
             if (hps[j]>0) and (map[j,i]<>0) then
                if hps[j]*2+map[j,i]>hps[i] then
                   begin
                     hps[i]:=hps[j]*2+map[j,i];
                     modify:=true;
                   end;
           if hps[i]>sum then hps[i]:=sum;
         end;
    if hps[n]>0 then break;
  until not modify;
  if hps[n]<=0 then check:=false else check:=true;
end;

procedure work;
var head,tail,mid:longint;
begin
  head:=1; tail:=sum; min:=sum;
  if sum=0 then min:=1;
  while head<=tail do
    begin
      mid:=(head+tail) div 2;
      if check(mid) then
         begin
           min:=mid;
           tail:=mid-1;
         end
      else head:=mid+1;
    end;
end;

procedure out;
begin
  assign(output,outfile); rewrite(output);
    writeln(min);
  close(output);
end;

begin
  init;
  work;
  out;
end.