const fin='baghdad.in';fout='baghdad.ans';
      maxn=100000;
type link=^node;
     node=record
            t:longint;
            next:link;
          end;
var line:array[1..maxn] of link;
    fa,rank,son,bro,order,q,up,down,ans:array[1..maxn] of longint;
    cyc,check:array[1..maxn] of boolean;
    n,hs,m,st,nd,rlt:longint;
function find_set(x:longint):longint;
begin
  if fa[x]<>x then
    begin
      fa[x]:=find_set(fa[x]);
    end;
  exit(fa[x]);
end;
procedure union(x,y:longint);
begin
  if rank[x]<rank[y] then
    begin
      fa[x]:=y;
      if cyc[x] then cyc[y]:=true;
    end else
    begin
      fa[y]:=x;
      if cyc[y] then cyc[x]:=true;
      if rank[x]=rank[y] then inc(rank[x]);
    end;
end;
procedure add(i,j:longint);
var p:link;
begin
  new(p);
  p^.t:=j;
  p^.next:=line[i];
  line[i]:=p;
  new(p);
  p^.t:=i;
  p^.next:=line[j];
  line[j]:=p;
end;
procedure init;
var t,i,j,ri,rj:longint;
begin
  fillchar(line,sizeof(line),0);
  fillchar(rank,sizeof(rank),0);
  fillchar(cyc,sizeof(cyc),0);
  fillchar(son,sizeof(son),0);
  fillchar(bro,sizeof(bro),0);
  assign(input,fin);
  reset(input);
  read(n,m);
  for i:=1 to n do
    fa[i]:=i;
  for t:=1 to m do
    begin
      read(i,j);
      ri:=find_set(i);
      rj:=find_set(j);
      if ri=rj then cyc[ri]:=true else
        begin
          add(i,j);
          union(ri,rj);
        end;
    end;
  close(input);
end;
procedure build_tree(i:longint);
var p:link;
begin
  st:=1;nd:=1;
  order[1]:=i;
  check[i]:=true;
  repeat
    p:=line[order[st]];
    while p<>nil do
      begin
        if not check[p^.t] then
          begin
            inc(nd);
            order[nd]:=p^.t;
            check[p^.t]:=true;
            bro[p^.t]:=son[order[st]];
            son[order[st]]:=p^.t;
          end;
        p:=p^.next;
      end;
    inc(st);
  until st>nd;
end;
procedure swap(i,j:longint);
var t:longint;
begin
  t:=q[i];q[i]:=q[j];q[j]:=t;
end;
procedure shift_down(t:longint);
var i:longint;
begin
  repeat
    i:=t;
    if (i*2<=hs) and (q[i*2]<q[t]) then t:=i*2;
    if (i*2+1<=hs) and (q[i*2+1]<q[t]) then t:=i*2+1;
    if t<>i then swap(i,t);
  until t=i;
end;
procedure delete;
begin
  q[1]:=q[hs];
  dec(hs);
  shift_down(1);
end;
procedure make_down(i:longint);
var t:longint;
begin
  hs:=0;
  t:=son[i];
  while t>0 do
    begin
      inc(hs);
      q[hs]:=down[t];
      t:=bro[t];
    end;
  for t:=hs downto 1 do
    shift_down(t);
  down[i]:=hs+1;
  while hs>0 do
    begin
      if q[1]+hs-1>down[i] then
        down[i]:=q[1]+hs-1;
      delete;
    end;
end;
procedure make_ans(i:longint);
var t,neck:longint;
begin
  if up[i]>0 then
    begin
      hs:=1;
      q[1]:=up[i];
      t:=son[i];
    end else
      hs:=0;
  t:=son[i];
  while t>0 do
    begin
      inc(hs);
      q[hs]:=down[t];
      t:=bro[t];
    end;
  for t:=hs downto 1 do
    shift_down(t);
  ans[i]:=hs+1;
  neck:=0;
  while hs>0 do
    begin
      if q[1]+hs-1>=ans[i] then
        begin
          ans[i]:=q[1]+hs-1;
          neck:=q[1];
        end;
      delete;
    end;
  t:=son[i];
  while t>0 do
    begin
      if down[t]>=neck then up[t]:=ans[i]-1 else up[t]:=ans[i];
      t:=bro[t];
    end;
end;
procedure dynamic;
var i:longint;
begin
  for i:=nd downto 1 do
    make_down(order[i]);
  up[order[1]]:=0;
  for i:=1 to nd do
    make_ans(order[i]);
  for i:=1 to nd do
    if ans[order[i]]<rlt then
      rlt:=ans[order[i]];
end;
procedure main;
var i,ri:longint;
begin
  rlt:=n+1;
  fillchar(check,sizeof(check),0);
  for i:=1 to n do
    if not check[i] then
      begin
        ri:=find_set(i);
        build_tree(i);
        if not cyc[ri] then
          dynamic;
      end;
end;
begin
  init;
  main;
  assign(output,fout);
  rewrite(output);
  if rlt>n then
    writeln('Impossible') else
    writeln(rlt);
  close(output);
end.
