#include <iostream>
#include <fstream>
#include <cstring>
using namespace std;
ifstream fin(""b.in"");
ofstream fout(""b.out"");
const int maxN=100;
int n,m,timer;
int d[maxN];
int low[maxN];
int parent[maxN];
enum {WHITE,GRAY,BLACK} color[maxN];
bool g[maxN][maxN];
bool dir[maxN][maxN];
void dfs(int u,int p)
{
  if(color[u]==WHITE)
  {
    color[u]=GRAY;
    d[u]=low[u]=++timer;
    for(int v=0;v<n;v++)
      if(v!=p&&g[u][v])
      {
        if(color[v]==WHITE)
        {
          dir[u][v]=true;
          dir[v][u]=false;
          parent[v]=u;
          dfs(v,u);
          if(low[v]<low[u])
            low[u]=low[v];
        }
        else if(color[v]==GRAY)
        {
          dir[u][v]=true;
          dir[v][u]=false;
          if(d[v]<low[u])
            low[u]=d[v];
        }
      }
    color[u]=BLACK;
  }
}
int main()
{
  fin>>n>>m;
  memset(g,false,sizeof(g));
  for(int i=0;i<m;i++)
  {
    int u,v;
    fin>>u>>v;
    g[u-1][v-1]=g[v-1][u-1]=true;
  }
  timer=0;
  memset(color,0,sizeof(color));
  dfs(0,-1);
  bool fail=false;
  for(int i=1;i<n&&!fail;i++)
    if(low[i]>d[parent[i]]||color[i]!=BLACK)
      fail=true;
  if(fail)
    fout<<""impossible""<<endl;
  else
  {
    for(int i=0;i<n;i++)
      for(int j=i+1;j<n;j++)
        if(g[i][j])
        {
          if(dir[i][j])
            fout<<i+1<<' '<<j+1<<endl;
          else
            fout<<j+1<<' '<<i+1<<endl;
        }
  }
  return 0;
}
