{$R-,S-,Q-}
Program OIBH_6_B(Input,Output);
const
  Maxn                  =100;
  Inputfile             ='b.in';
  Outputfile            ='b.out';
var
  Map,Answer            :Array [1..Maxn,1..Maxn] of Boolean;
  Order,Father,Get      :Array [1..Maxn] of Longint;
  Reach                 :Array [1..Maxn] of Boolean;
  N,M,H                 :Longint;

Procedure Init;
  var
    I,J,K               :Longint;
  begin
    Fillchar(Map,Sizeof(Map),0);
    Fillchar(Answer,Sizeof(Answer),0);
    Readln(N,M);
    For K:=1 to M do
      begin
        Readln(I,J);
        Map[I,J]:=True;
        Map[J,I]:=True;
      end;
  end;

Procedure DFS(Now:Integer);
  var
    K                   :Integer;
  begin
    Reach[Now]:=True;
    Inc(H);
    Order[Now]:=H;
    Get[Now]:=H;
    For K:=1 to N do if Map[Now,K] then
      begin
        Answer[Now,K]:=True;
        Map[Now,K]:=False;
        Map[K,Now]:=False;
        if Not Reach[K] then
          begin
            Father[K]:=Now;
            DFS(K);
            if Get[Now]>Get[K] then Get[Now]:=Get[K];
          end else if Order[K]<Get[Now] then Get[Now]:=Order[K];
      end;
  end;

Function OK:Boolean;
  var
    K                   :Integer;
  begin
    Fillchar(Reach,Sizeof(Reach),0);
    H:=0;
    DFS(1);
    OK:=False;
    if H<N then Exit;
    For K:=2 to N do
      if Get[K]>Order[Father[K]] then Exit;
    Ok:=True;
  end;

Procedure Print;
  var
    I,J                 :Longint;
  begin
    For I:=1 to N do
      For J:=1 to N do if Answer[I,J] then Writeln(I,' ',J);
  end;

Begin
  Assign(Input,Inputfile);
  Reset(Input);
  Assign(Output,Outputfile);
  Rewrite(Output);
  Init;
  if OK then Print
        else Writeln('impossible');
  Close(Input);
  Close(Output);
End.