const
  max=1024;
  heapsize=(max*max*4-1) div 3-1;
var
  add,heap:array[0..heapsize] of longint;
  kill:array[0..heapsize] of boolean;
  tx1,tx2,ty1,ty2:longint;
  ans,a,b,c,n,m,h,k:longint;
procedure push(i,s:longint);
begin
  if kill[i] then begin
    if i<h then begin
      add[i*4+1]:=0;
      add[i*4+2]:=0;
      add[i*4+3]:=0;
      add[i*4+4]:=0;
      kill[i*4+1]:=true;
      kill[i*4+2]:=true;
      kill[i*4+3]:=true;
      kill[i*4+4]:=true;
    end;
    heap[i]:=0;
  end;
  inc(heap[i],add[i]*s);
  if i<h then begin
    inc(add[i*4+1],add[i]);
    inc(add[i*4+2],add[i]);
    inc(add[i*4+3],add[i]);
    inc(add[i*4+4],add[i]);
  end;
  kill[i]:=false;
  add[i]:=0;
end;
function fire(i,x1,y1,x2,y2:longint):longint;
var
  ans,mx,my:longint;
begin
  if (tx2<=x1) or (x2<=tx1) or (ty2<=y1) or (y2<=ty1) then exit(0);
  if kill[i] then heap[i]:=0;
  if (tx1<=x1) and (x2<=tx2) and (ty1<=y1) and (y2<=ty2) then begin
    kill[i]:=true;
    ans:=heap[i]+add[i]*(y2-y1)*(x2-x1);
    add[i]:=0;
    heap[i]:=0;
    exit(ans);
  end;
  push(i,(y2-y1)*(x2-x1));
  if kill[i] then exit(0);
  mx:=(x1+x2) shr 1;
  my:=(y1+y2) shr 1;
  ans:=fire(i*4+1,x1,y1,mx,my);
  inc(ans,fire(i*4+2,mx,y1,x2,my));
  inc(ans,fire(i*4+3,x1,my,mx,y2));
  inc(ans,fire(i*4+4,mx,my,x2,y2));
  dec(heap[i],ans);
  exit(ans);
end;
function reinforce(i,x1,y1,x2,y2:longint):longint;
var
  ans,mx,my:longint;
begin
  if (tx2<=x1) or (x2<=tx1) or (ty2<=y1) or (y2<=ty1) then exit(0);
  if (tx1<=x1) and (x2<=tx2) and (ty1<=y1) and (y2<=ty2) then begin
    inc(add[i]);
    exit((y2-y1)*(x2-x1));
  end;
  push(i,(y2-y1)*(x2-x1));
  mx:=(x1+x2) shr 1;
  my:=(y1+y2) shr 1;
  ans:=reinforce(i*4+1,x1,y1,mx,my);
  inc(ans,reinforce(i*4+2,mx,y1,x2,my));
  inc(ans,reinforce(i*4+3,x1,my,mx,y2));
  inc(ans,reinforce(i*4+4,mx,my,x2,y2));
  inc(heap[i],ans);
  exit(ans);
end;
begin
  fillchar(heap,sizeof(heap),0);
  fillchar(kill,sizeof(kill),0);
  assign(input,'c.in');
  reset(input);
  assign(output,'c.out');
  rewrite(output);
  read(n,m);
  n:=max;
  h:=(n*n*4-1) div 3-n*n;
  ty1:=0;
  for a:=1 to m do begin
    read(k,tx1,tx2,ty2);
    dec(tx1);
    if k=1 then reinforce(0,0,0,n,n) else writeln(fire(0,0,0,n,n));
  end;
  close(output);
  close(input);
end.

