Program bowling;
 const
   inputfilename='bowling.in';
   outputfilename='bowling.out';
 var
   tot,last:integer;
   shoot:array[1..10,1..2] of byte;

procedure readdata;
 begin
   assign(input,inputfilename);
   reset(input);
   readln(tot);
   close(input);
 end;

function check(now,t,last:integer):integer;
 var
   i,s:integer;
begin
  if t=0 then for i:=now+1 to 10 do begin
   shoot[i,1]:=0; shoot[i,2]:=0; end;
  if t=1 then for i:=now+1 to 10 do
   shoot[i,1]:=10;
  if t=1 then shoot[10,2]:=10;

  s:=last;
  for i:=1 to 10 do inc(s,shoot[i,1]+shoot[i,2]);
  for i:=1 to 8 do
    if shoot[i,1]=10 then
      if shoot[i+1,1]=10 then inc(s,10+shoot[i+2,1])
        else inc(s,shoot[i+1,1]+shoot[i+1,2])
    else if shoot[i,1]+shoot[i,2]=10 then inc(s,shoot[i+1,1]);
  if shoot[9,1]=10 then inc(s,shoot[10,1]+shoot[10,2])
   else if shoot[9,1]+shoot[9,2]=10 then inc(s,shoot[10,1]);
  check:=s;
end;

procedure main;
 var
   i,j,step,nmax,nmin,score:integer;
begin
  step:=0;
  fillchar(shoot,sizeof(shoot),0);
  nmin:=0; nmax:=300;

  while (nmin<tot) and (tot<nmax) do
   begin
     inc(step);
     if step<10 then
      begin
        shoot[step,1]:=10; shoot[step,2]:=0;
        nmin:=check(step,0,0); nmax:=check(step,1,10);
        if (tot-nmin<=10) and (0<=tot-nmin) and (nmax-tot<=10) and (0<=nmax-tot) then break;
        if (nmin<=tot) and (tot<=nmax) then continue;
        for i:=9 downto 0 do
         begin
           shoot[step,1]:=i; shoot[step,2]:=10-i;
           nmin:=check(step,0,0); nmax:=check(step,1,10);
           if (nmin<=tot) and (tot<=nmax) then break;
         end;
        if (nmin<=tot) and (tot<=nmax) then continue;
        if (tot-nmin<=10) and (0<=tot-nmin) and (nmax-tot<=10) and (0<=nmax-tot) then break;

        for i:=9 downto 0 do
         begin
           for j:=0 to 9-i do
            begin
              shoot[step,1]:=i; shoot[step,2]:=j;
              nmin:=check(step,0,0); nmax:=check(step,1,10);
              if (nmin<=tot) and (tot<=nmax) then break;
            end;
           if (nmin<=tot) and (tot<=nmax) then break;
         end;
        if (nmin<=tot) and (tot<=nmax) then continue;
        shoot[step,1]:=i; shoot[step,2]:=j;
        if (tot-nmin<=10) and (0<=tot-nmin) and (nmax-tot<=10) and (0<=nmax-tot) then break;
      end
     else
      for i:=10 downto 0 do
       begin
         shoot[10,1]:=i;
         for j:=10 downto 0 do
          begin
            shoot[10,2]:=j;
            score:=tot-check(10,0,0);
            if (0<=score) and (score<=10) then
             begin last:=score; exit; end;
          end;
       end;
   end;

   if (tot-nmin<=10) and (0<=tot-nmin) then
    begin check(step,0,0); last:=tot-nmin; end;
   if (nmax-tot<=10) and (0<=nmax-tot) then
    begin check(step,1,10); last:=10-nmax+tot; end;
end;

procedure print;
 var
   i:integer;
   st:string;
begin
  st:='_123456789X';
  assign(output,outputfilename);
  rewrite(output);
  if tot>300 then writeln('You were cheated!')
   else
    begin
      for i:=1 to 9 do
       begin
         if shoot[i,1]=10 then write('X ')
          else if shoot[i,1]+shoot[i,2]=10 then write(st[shoot[i,1]+1],'/')
           else write(st[shoot[i,1]+1],st[shoot[i,2]+1]);
         write(' ');
       end;
      write(st[shoot[10,1]+1],st[shoot[10,2]+1],st[last+1]);
      writeln;
    end;
  close(output);
end;

Begin
  readdata;
  if tot<=300 then main;
  print;
End.