const
     maxm=1001;
     inputfilename='';
     outputfilename='';
type
    nodetype=record
                   info:byte;
                   lp,rp:integer;
             end;
    treetype=array[0..maxm] of nodetype;
    arrtype=array[0..maxm]of integer;
    lsttype=array[0..maxm,0..maxm]of integer;
var
   tree:treetype;
   lst:lsttype;
   n,m:integer;
   father,deg:arrtype;
procedure init;
var
   name:string;
   fp:text;
   i,j,k:integer;
procedure visit(root:integer);
var
   dl,dr:integer;
begin
     if tree[root].lp>0 then
     begin
          visit(tree[root].lp);
          dl:=deg[tree[root].lp];
     end
     else dl:=0;
     if tree[root].rp>0 then
     begin
          visit(tree[root].rp);
          dr:=deg[tree[root].rp];
     end
     else dr:=0;
     deg[root]:=dl+dr+1;
end;
begin
     fillchar(tree,sizeof(tree),0);
     fillchar(father,sizeof(father),0);
     name:=inputfilename;
     assign(fp,name);
     reset(fp);
     readln(fp,m,n);
     for i:=0 to m do
     begin
          if i>0 then readln(fp,father[i],tree[i].info);
          tree[i].rp:=-1; tree[i].lp:=-1;
          fillchar(lst[i],sizeof(lst[i]),0);
     end;
     for i:=1 to m do
     begin
          if tree[father[i]].lp<0
          then tree[father[i]].lp:=i
          else
          begin
               j:=i-1;
               while father[j]<>father[i] do dec(j);
               tree[j].rp:=i;
          end;
     end;
     close(fp);
     fillchar(deg,sizeof(deg),0);
     visit(0);
end;
procedure solve(root,usenum:integer);
var
   i,j,k:integer;
   nrp,nlp:integer;
   ns,ls,rs:integer;
begin
     if (usenum>0)and(lst[root][usenum]<=0)and(root>=0)and(usenum<=deg[root])
     then
     begin
          nrp:=tree[root].rp;
          nlp:=tree[root].lp;
          for i:=0 to usenum do
          begin
               j:=usenum-i;
               if (nlp=-1)or(i=0) then ls:=0
               else begin
                    solve(nlp,i-1);
                    ls:=lst[nlp][i-1];
                    end;
               if nrp=-1 then rs:=0 else
               begin
                    solve(nrp,j);
                    rs:=lst[nrp][j];
               end;
               if i=0 then ns:=rs
               else ns:=ls+rs+tree[root].info;
               if ns>lst[root][usenum] then lst[root][usenum]:=ns;
          end;
     end;
end;
procedure printout;
var
   name:string;
   hash:array[1..maxm]of boolean;
   fp:text;
   i,j:integer;
procedure printans(root,usenum:integer);
var
   i,j,k:integer;
   nrp,nlp:integer;
   ns,ls,rs:integer;
begin
     if (usenum>0)and(root>=0) then
     if (usenum<=deg[root]) then
     begin
          nrp:=tree[root].rp;
          nlp:=tree[root].lp;
          for i:=0 to usenum do
          begin
               j:=usenum-i;
               if (nlp=-1)or(i=0) then ls:=0
               else ls:=lst[nlp][i-1];
               if nrp=-1 then rs:=0
               else rs:=lst[nrp][j];
               if i=0 then ns:=rs
               else ns:=ls+rs+tree[root].info;
               if ns=lst[root][usenum] then
               begin
                    if (i>0)and(root>0) then hash[root]:=true;
                    printans(nlp,i-1);
                    printans(nrp,j);
                    exit;
               end;
          end;
     end;
end;

begin
     name:=outputfilename;
     assign(fp,name);
     rewrite(fp);
     writeln(fp,lst[0][n+1]);
     if m<=99 then
     begin
     fillchar(hash,sizeof(hash),0);
     printans(0,n+1);
     for i:=1 to m do
     if hash[i] then writeln(fp,i);
     end;
     close(fp);
end;

begin
     init;
     solve(0,n+1);
     printout;
end.
