const
     maxn=100;
     infile='kd.in';
     outfile='kd.out';
type
    swordtype=record
                    l,rad:extended;
              end;
    graphtype=array[1..maxn,1..maxn]of shortint;
    settype=array[1..maxn]of boolean;
    swords=array[1..maxn]of swordtype;
    dragons=array[1..maxn]of extended;
var
   sword:swords;
   dragon:dragons;
   g:graphtype;
   n,m:integer;
   s,t,cx,cy:settype;
   found:boolean;
procedure init;
var
   i:longint;
begin
     fillchar(sword,sizeof(sword),0);
     fillchar(dragon,sizeof(dragon),0);
     readln(n);
     for i:=1 to n do
     begin
          readln(sword[i].l,sword[i].rad);
          sword[i].rad:=sword[i].rad/360*pi;
     end;
     for i:=1 to n do
     readln(dragon[i]);
end;
procedure graphinit;
var
   i,j:integer;
   r:extended;
begin
     fillchar(g,sizeof(g),0);
     fillchar(s,sizeof(s),0);
     fillchar(t,sizeof(t),0);
     fillchar(cx,sizeof(cx),0);
     fillchar(cy,sizeof(cy),0);
     for i:=1 to n do
     for j:=1 to n do
     begin
          r:=sword[i].l*sin(sword[i].rad)/(1+sin(sword[i].rad));
          if r>=dragon[j] then g[i,j]:=1;
     end;
end;
function path(x:integer):boolean;
var
   i,j:integer;
begin
     path:=false;
     for i:=1 to n do
     if not(t[i])and(g[x,i]<>0) then
     begin
          t[i]:=true;
          if not(cy[i]) then
          begin
               g[x,i]:=-g[x,i];
               cy[i]:=true;
               path:=true;
               exit;
          end;
          j:=1;
          while (j<=n)and(not(s[j]))and(g[j,i]>=0)do inc(j);
          if j<n then
          begin
               s[j]:=true;
               if path(j) then
               begin
                    g[x,i]:=-g[x,i];
                    g[j,i]:=-g[j,i];
                    path:=true;
                    exit;
               end;
          end;
     end;
end;
procedure main;
var
   u,i,j:integer;
begin
     found:=true;
     u:=1;
     fillchar(cx,sizeof(cx),0);
     fillchar(cy,sizeof(cy),0);
     while u<=n do
     begin
          fillchar(s,sizeof(s),0);
          s[u]:=true;
          fillchar(t,sizeof(t),0);
          if not(cx[u]) then
          begin
               if not path(u) then
               begin
                    found:=false;
                    exit;
               end
               else cx[u]:=true;
               u:=0;
          end;
          inc(u);
     end;
end;
var
   i:integer;
begin
     //assign(input,infile);
     //reset(input);
     //assign(output,outfile);
     //rewrite(output);
     readln(m);
     for i:=1 to m do
     begin
          init;
          graphinit;
          main;
          if found then
             writeln('Yes!')
          else
              writeln('No!');
     end;
     //close(input);
     //close(output);
end.
