const
  fin = '';
  fout = '';
  degree : array [1..21] of byte =
    (0,2,4,5,7,9,11,
    12,14,16,17,19,21,23
    ,24,26,28,29,31,33,35);
  max = 40;
type
  xltype = record
             first , last : byte;
             long : longint;
           end;
var
   s : string;
   xl : array [1..max] of xltype;
   xllink : array [1..max,0..max] of integer;
   ok : array [0..40] of boolean;
   g , i ,  m ,  n , bestlong : longint;
   all : integer;
   ll : real;
   use : array [1..max] of byte;

function gcd(aa ,bb : longint) : longint;
begin
  if bb = 0 then gcd := aa else gcd := gcd(bb , aa mod bb);
end;

function duf(ttt : string) : byte;
var
   tt : string;
   g1: byte;
   gz : shortint;
begin
  tt := ttt;
  if pos('0',tt) > 0 then begin
    duf := 200;
    exit;
  end;
  gz := 0;
  case tt[1] of
  '#' : gz := 1;
  'b' : gz := -1;
  end;
  if tt[1] in ['#','b'] then delete(tt,1,1);
  case tt[1] of
  '+': g1 :=14;
  '-': g1 := 0;
  else g1 := 7;
  end;
  if tt[1] in ['+','-'] then delete(tt,1,1);
  g1 := g1 + ord(tt[1]) - ord('0');
  duf := degree[g1] + gz;
end;

function duc(tt : string) : byte;
begin
  if pos('e',tt) > 0 then begin
    duc := 1;
    exit;
  end;
  if pos('f',tt) > 0 then begin
    duc := 2;
    exit;
  end;
  if pos('t',tt) > 0 then begin
    duc := 4;
    exit;
  end;
  if pos('o',tt) > 0 then begin
    duc := 8;
    exit;
  end;
end;

procedure change(ii:integer);
var
  fer : boolean;
  posi  : byte;
  yf , yc : integer;
  temp : string;
begin
  fer := true;
  with xl[ii] do begin
    while s<>'' do begin
      posi := pos(' ',s);
      if posi = 0 then posi := length(s) + 1;
      temp := copy(s,1,posi-1);
      yf := duf(temp);
      if fer and (yf <> 200) then begin
        first := duf(temp);
        fer := false;
      end;
      if yf <> 200 then
        last := duf(temp);
      long := long + duc(temp);
      delete(s,1,posi);
    end;
  end;
end;

procedure init;
begin
  assign(input , fin);
  reset(input);
  readln(n);
  for i := 1 to n do begin
    readln(s);
    change(i);
  end;
  fillchar(use,sizeof(use),0);
  fillchar(ok,sizeof(ok),0);
  readln(m);
  for i := 1 to m do begin
    readln(ll);
    ok[trunc(ll*2)] := true;
  end;
  close(input);
end;

procedure sub(wz : byte; lastyf : integer; nowlong : longint;pre : byte);
var
  jj : integer;
begin
  if nowlong  > bestlong then
    bestlong := nowlong;
  if (wz = 1) then begin
    for jj := 1 to n do begin
        inc(use[jj]);
        sub(wz+1,xl[jj].last,nowlong+xl[jj].long,jj);
        dec(use[jj]);
      end;
  end else
    for jj := 1 to xllink[pre,0] do
      if use[xllink[pre,jj]] < 2 then begin
        inc(use[xllink[pre,jj]]);
        sub( wz+1 , xl[xllink[pre,jj]].last ,
        nowlong+xl[xllink[pre,jj]].long , xllink[pre,jj]);
        dec(use[xllink[pre,jj]]);
      end;
end;

procedure out;
var
  fff : boolean;
begin
  fff := true;
  assign(output , fout);
  rewrite(output);
  if bestlong div 8 <> 0 then
  write(bestlong div 8) else fff := false;
  bestlong := bestlong mod 8;
  g := gcd(bestlong,8);
  if bestlong <> 0 then begin
    if fff then write(' ');
    writeln(bestlong div g,'/',8 div g) end else writeln;
  close(output);
end;
procedure preprocess;
var
  ii , jj , ll : integer;
begin
  for ii := 1 to n do begin
    ll := 0;
    for jj := 1 to n do
      if ok[abs(xl[jj].first - xl[ii].last)] then begin
        inc(ll);
        xllink[ii,ll] := jj;
      end;
    xllink[ii,0] := ll;
  end;
end;




begin
  init;
  preprocess;
  bestlong := 0;
  sub(1,0,0,0);
  out;
end.

