{
problem:oibh-may-c
author:batie
date:2003-5-1
ver:1.0
}
const fin='c.dat';fout='c.out';
      maxm=5000;maxn=500;maxk=50;
type linenode=record
                x,y:integer;
                v:longint;
              end;
     rltnode=record
               max,min:longint;
             end;
var line:array[1..maxm] of linenode;
    fa,rank:array[1..maxn] of integer;
    rlt:array[1..maxk] of rltnode;
    n,m,sour,targ,k,keep:integer;
procedure swap(i,j:integer);
var t:linenode;
begin
  t:=line[i];line[i]:=line[j];line[j]:=t;
end;
procedure q_sort(st,nd:integer);
var i,j:integer;
    x:longint;
begin
  if st>=nd then exit;
  i:=st;j:=nd;
  x:=line[(st+nd) div 2].v;
  repeat
    while (i<j) and (line[i].v<x) do inc(i);
    while (i<j) and (line[j].v>x) do dec(j);
    if i<j then
      begin
        swap(i,j);
        if random(2)=0 then
          if line[i].v=x then dec(j) else inc(i) else
          if line[j].v=x then inc(i) else dec(j);
      end;
  until i=j;
  q_sort(st,i-1);
  q_sort(i+1,nd);
end;
procedure init;
var t:integer;
begin
  assign(input,fin);
  reset(input);
  readln(n,m);
  for t:=1 to m do
    with line[t] do
      readln(x,y,v);
  readln(sour,targ,k);
  close(input);
  q_sort(1,m);
end;
function insert(a:rltnode):boolean;
var i,j:integer;
begin
  i:=1;
  while (i<=keep) and (int64(a.max)*rlt[i].min>
                       int64(rlt[i].max)*a.min) do
    inc(i);
  if i>k then exit(false);
  if (i<=keep) and
     (int64(a.max)*rlt[i].min=int64(rlt[i].max)*a.min) then
    exit(true);
  if keep<k then
    begin
      inc(keep);
      for j:=keep downto i+1 do
        rlt[j]:=rlt[j-1];
      rlt[i]:=a;
    end else
    begin
      for j:=k downto i+1 do
        rlt[j]:=rlt[j-1];
      rlt[i]:=a;
    end;
  exit(true);
end;
function find_set(x:integer):integer;
begin
  if fa[x]<>x then
    fa[x]:=find_set(fa[x]);
  exit(fa[x]);
end;
function link(x,y:integer):integer;
begin
  if rank[x]<rank[y] then
    begin
      fa[x]:=y;
      exit(y);
    end else
    begin
      fa[y]:=x;
      if rank[x]=rank[y] then inc(rank[x]);
      exit(x);
    end;
end;
procedure process(t:integer);
var a:rltnode;
    i,rx,ry,rs,rn:integer;
begin
  for i:=1 to n do
    fa[i]:=i;
  i:=t;
  repeat
    with line[i] do
      begin
        rx:=find_set(x);
        ry:=find_set(y);
        if rx<>ry then link(rx,ry);
      end;
    rx:=find_set(sour);
    ry:=find_set(targ);
    rn:=find_set(line[t].x);
    if (rx=ry) and (rn=rx) then break;
    inc(i);
  until i>m;
  while i<=m do
    begin
      a.max:=line[i].v;
      a.min:=line[t].v;
      if not insert(a) then
        break;
      inc(i);
      while i<=m do
        begin
          with line[i] do
            begin
              rx:=find_set(x);
              ry:=find_set(y);
              if rx<>ry then rn:=link(rx,ry) else
                             rn:=rx;
              rs:=find_set(sour);
              if rs=rn then break;
            end;
          inc(i);
        end;
    end;
end;
function gcd(a,b:longint):longint;
var t:longint;
begin
  while b>0 do
    begin
      t:=b;
      b:=a mod b;
      a:=t;
    end;
  exit(a);
end;
procedure main;
var d:longint;
    i:integer;
begin
  keep:=0;
  for i:=m downto 1 do
    process(i);
  if keep=k then
    begin
      d:=gcd(rlt[k].max,rlt[k].min);
      rlt[k].max:=rlt[k].max div d;
      rlt[k].min:=rlt[k].min div d;
    end;
end;
begin
  init;
  main;
  assign(output,fout);
  rewrite(output);
  if keep<k then
    writeln('IMPOSSIBLE') else
  if rlt[k].min=1 then
    writeln(rlt[k].max) else
    writeln(rlt[k].max,'/',rlt[k].min);
  close(output);
end.