{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{ Cautare binara + STUPID Dijkstra }

Program _lanterna_;

const filein = 'lanterna.in';
      fileout = 'lanterna.out';
      MAXN = 50;
      MAXK = 1000;
      infinit = 30000;
      maxdim1 = 63;

var T, W : array [1..MAXN, 1..MAXN] of integer;
    Tmin, Wmin, tata : array [1..MAXN] of integer;
    charge, sel : array [1..MAXN] of boolean;
    i, j, p, M, N, K, dimheap, li, ls : integer;
    TOK, bestK : integer;

procedure readdata;
begin
assign(input, filein);
reset(input);
read(N, K);

for i := 1 to N do
  begin
    read(p);
    charge[i] := (p = 1);
  end;

read(M);

for i := 1 to N do
  for j := 1 to N do
    begin
      T[i,j] := infinit;
      W[i,j] := MAXK + 1;
    end;

for p := 1 to m do
  begin
    read(i, j);
    read(T[i,j], W[i,j]);
    T[j,i] := T[i,j];
    W[j,i] := W[i,j];
  end;

close(input);
end;

procedure writedata;
begin
assign(output, fileout);
rewrite(output);
writeln(TOK, ' ', bestK);
close(output);
end;

procedure compute;
begin
{ Dijkstra }
for i := 1 to N do
  begin
    Tmin[i] := infinit;
    Wmin[i] := infinit;
  end;

fillchar(sel, sizeof(sel), false);

Tmin[1] := 0;
Wmin[1] := 0;
p := 1;
sel[p] := true;

while (not sel[N]) do
  begin
    for i := 2 to N do
      begin
        if (T[p,i] < infinit) and
           ((Tmin[p] + T[p,i] < Tmin[i])

           or
            (Tmin[p] + T[p,i] = Tmin[i]) and (Wmin[p] + W[p,i] < Wmin[i])

            ) then
          begin
            Tmin[i] := Tmin[p] + T[p,i];
            Wmin[i] := Wmin[p] + W[p,i];
            tata[i] := p;

            if (charge[i]) then
              Wmin[i] := 0;
          end;
      end;

    p := 0;
    j := infinit;
    for i := 1 to N do
      if (not sel[i]) and (Tmin[i] < j) then
        begin
          j := Tmin[i];
          p := i;
        end;

    if (p = 0) then
      break;

    sel[p] := true;
  end;

TOK := Tmin[N];
bestK := Wmin[N];

if (bestK = 0) then
  bestK := 1;
end;

begin
readdata;
compute;
writedata;
end.