{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{ Time Complexity : O(Q * N * K) }

Program _trans_;

const filein = 'trans.in';
      fileout = 'trans.out';
      MAXN = 16000;
      infinit = 1000000000;

type longarray = array [1..MAXN] of longint;
     plongarray = ^longarray;
     bytearray = array [1..MAXN] of byte;
     pbytearray = ^bytearray;

var s : plongarray;
    c : pbytearray;
    maxcurr, maxprev : array [0..1] of plongarray;
    i, j, k, m, n, q, iq, t, minim : longint;

begin
assign(input, filein);
reset(input);
assign(output, fileout);
rewrite(output);

read(n);

new(c);
new(s);

for i := 1 to n do
  read(c^[i], s^[i]);

for i := 0 to 1 do
  begin
    new(maxcurr[i]);
    new(maxprev[i]);
  end;

read(q);
for iq := 1 to q do
  begin
    read(k, t);

    for i := 0 to 1 do
      for j := 1 to k do
        maxcurr[i]^[j] := infinit;

    maxcurr[c^[1]]^[1] := t;
    maxcurr[1-c^[1]]^[1] := t + s^[1];

    for j := 2 to n do
      begin
        for i := 0 to 1 do
          begin
            dispose(maxprev[i]);
            maxprev[i] := maxcurr[i];
            new(maxcurr[i]);
          end;

        for i := 2 to k do
          begin
            maxcurr[0]^[i] := infinit;
            maxcurr[1]^[i] := infinit;

            if (maxprev[c^[j]]^[i-1] < maxcurr[c^[j]]^[i]) then
              maxcurr[c^[j]]^[i] := maxprev[c^[j]]^[i-1];

            if (maxprev[1-c^[j]]^[i-1] + s^[j] < maxcurr[1-c^[j]]^[i]) then
              maxcurr[1-c^[j]]^[i] := maxprev[1-c^[j]]^[i-1] + s^[j];
          end;

        minim := infinit;
        for i := 1 to k do
          for m := 0 to 1 do
            if (maxprev[m]^[i] < minim) then
              minim := maxprev[m]^[i];

        maxcurr[c^[j]]^[1] := minim + t;
        maxcurr[1-c^[j]]^[1] := minim + t + s^[j];
      end;

    minim := infinit;
    for i := 1 to k do
      for m := 0 to 1 do
        if (maxcurr[m]^[i] < minim) then
          minim := maxcurr[m]^[i];

    writeln(minim);
  end;

close(input);
close(output);
end.