/* Mugurel Ionut Andreica - Bucuresti, ROMANIA */

#include <stdio.h>
#include <string.h>
#define filein "color.in"
#define fileout "color.out"
#define maxn 16001

typedef struct nod { int x; nod *urm; };

nod *edge[maxn];
char win[maxn], winok[maxn];
int tata[maxn], i, j, k, m, n;

void read();
void print();
void df(int);

int main()
{
int i;

read();

for (i = 1; i <= n; i++)
  {
    memset(tata, 0, sizeof(tata));
    df(i);
    winok[i] = win[i];
  }

print();

return 0;
}

void read()
{
int i, j, k;
nod *aux;

freopen(filein, "r", stdin);
scanf("%d", &n);

for (i = 1; i <= n; i++)
  edge[i] = NULL;

for (k = 1; k < n; k++)
  {
    scanf("%d %d", &i, &j);

    aux = new nod;
    aux->x = j;
    aux->urm = edge[i];
    edge[i] = aux;

    aux = new nod;
    aux->x = i;
    aux->urm = edge[j];
    edge[j] = aux;
  }
}

void print()
{
int i, m;

freopen(fileout, "w", stdout);

for (m = 0, i = 1; i <= n; i++)
  if (winok[i])
    m++;

printf("%d\n", m);
for (i = 1; i <= n; i++)
  if (winok[i])
    printf("%d ", i);

printf("\n");
}

void df(int node)
{
win[node] = 1;

nod *aa = edge[node];
int i;

while (aa!=NULL)
  {
    i = aa->x;

    if (i != tata[node])
      {
        tata[i]=node;
        df(i);

        win[node] &= (1 - win[i]);
      }

    aa = aa->urm;
  }
}
