#include <stdio.h>
#include <assert.h>

#define MAXN     65000
#define Q_MASK   ((1 << 16) - 1)

const long long m = 10000000000;

int main()
{
	int th[MAXN], n, i, can_screw;
	int g[Q_MASK + 1], g_zero, g_max;
	long long topg;
	
	freopen("caraibe.in", "r", stdin);
	scanf("%d", &n);
	assert((n > 0) && (n <= MAXN));
	for(i = 0; i < n - 2; i++) {
		scanf("%d", th + i);
		assert((th[i] >= 0) && (th[i] < n - i - 1));
	}

	topg = m;
	g_zero = g_max = 0, g[0] = 1;
	
	for(i = n - 3; i >= 0; i--) {
		can_screw = (n - i - 2) - th[i];
		for(; (g_max != g_zero) && can_screw >= g[g_max];
			   g_max = (g_max - 1) & Q_MASK) {
			can_screw -= g[g_max];
			topg += (long long) ((g_max - g_zero) & Q_MASK) * g[g_max];
		}
		assert((g_max >= 0) && (g_max <= Q_MASK));
		g[g_max] -= can_screw;
		topg += (long long) ((g_max - g_zero) & Q_MASK) * can_screw;
		
		g_zero = ((g_zero - 1) & Q_MASK);
		assert((g_zero >= 0) && (g_zero <= Q_MASK));
		g[g_zero] = (n - i - 1) - th[i];
		topg -= th[i];
	}
//	fprintf(stderr, "%d %d\n", (int)topg, n);
	fprintf(fopen("caraibe.out", "w"), "%.0f\n", (double) topg);
	return(0);
}
