/* Mugurel Ionut Andreica - Bucuresti, ROMANIA */

/* Time Complexity: O(N*logN) */

#include <stdio.h>
#include <string.h>
#define filein "hof.in"
#define fileout "hof.out"
#define maxterm 20000

long a[maxterm],bcurr,i,n,li,ls,m,found;
long double acurr;

int main()
{
freopen(filein,"r",stdin);
scanf("%ld",&n);

acurr=a[1]=1;
bcurr=2;

for (i=2;i<=n;i++)
  {
  acurr+=bcurr;
  bcurr++;

  li=1;
  if (i<maxterm)
    {
    a[i]=acurr;
    ls=i;
    }
  else
    ls=maxterm-1;
    
  found=0;
  while (li<=ls)
    {
    m=(li+ls)>>1;
    if (a[m]<bcurr)
      li=m+1;
    else
    if (a[m]>bcurr)
      ls=m-1;
    else
      {
      found=1;
      break;
      }
    }

  if (found)
    bcurr++;
  }

freopen(fileout,"w",stdout);
printf("%.0Lf\n",acurr);

return 0;
}
