{
Translated by:	CtoP version 1.2b

From:		Knowledge Software Ltd
		32 Cove Rd, Farnborough, Hants, GU14 0EN, England

	Specialists in language translators and code generators

sea2a.pas	15:31:20  9 Jun 2004
}
Program sea2a;

Var
    GY, My, Nr, Tm, GTz : array[0..524287] of longint;
    T : longint;


{ Sea2 O(NlogN) Segment Tree solution by Berinde Radu }

function max(a: longint; b:longint):longint;
begin
if (a > b) then max := a else max := b;
end;

Function gety(
    x : longint
    ) : longint;
Var
    v : longint;
    n : longint;
    l : longint;
    r : longint;
Begin
v:=0;
n:=0; l:=0; r:=260000;
While True Do
   Begin
   If (v<GY[n]) Then
      Begin
      v:=GY[n];
      End { If };
   If (l=r) Then
      Begin
      gety := v;
      Exit;
      End { If };
   If (x<=((l+r) Div 2)) Then
      Begin
      n:=((n*2)+1); r:=((l+r) Div 2);
      End { If }
   Else
      Begin
      n:=((n*2)+2); l:=((l+r) Div 2)+1;
      End { Else };
   ;
   End { For };
End; { gety }


Function getx(
    y : longint
    ) : longint;
Var
    v : longint;
    n : longint;
    l : longint;
    r : longint;
Begin
v:=0;
n:=0; l:=0; r:=260000;
While (l<r) Do
   Begin
   If (v<GY[n]) Then
      Begin
      v:=GY[n];
      End { If };
   If (max(v, My[n*2+2])<y) Then
      Begin
      n:=((n*2)+1); r:=((l+r) Div 2);
      End { If }
   Else
      Begin
      n:=((n*2)+2); l:=((l+r) Div 2)+1;
      End { Else };
   ;
   End { For };
getx := l;
Exit;
End; { getx }


Procedure sety(
    y : longint;
    xl : longint;
    xr : longint;
    n : longint;
    l : longint;
    r : longint
    );
Begin
If ((xl<=l) And (r<=xr)) Then
   Begin
   GY[n]:=y; My[n]:=y;
   Exit;
   ;
   End { If };
If (xl<=((l+r) Div 2)) Then
   Begin
   sety(y, xl, xr, ((n*2)+1), l, ((l+r) Div 2));
   End { If };
If (((l+r) Div 2)<xr) Then
   Begin
   sety(y, xl, xr, ((n*2)+2), ((l+r) Div 2)+1, r);
   End { If };
My[n]:=max(My[((n*2)+1)], (My[((n*2)+2)]));
End; { sety }


Procedure zero(
    xl : longint;
    xr : longint;
    n : longint;
    l : longint;
    r : longint;
    tz : longint
    );
Begin
If ((xl<=l) And (r<=xr)) Then
   Begin
   Tm[n]:=T;
   GTz[n]:=T;
   Nr[n]:=0;
   Exit;
   ;
   End { If };
If (GTz[n]>tz) Then
   Begin
   tz:=GTz[n];
   End { If };
If (xl<=((l+r) Div 2)) Then
   Begin
   zero(xl, xr, ((n*2)+1), l, ((l+r) Div 2), tz);
   End { If };
If (((l+r) Div 2)<xr) Then
   Begin
   zero(xl, xr, ((n*2)+2), ((l+r) Div 2)+1, r, tz);
   End { If };
Nr[n]:=0;
if (tz < Tm[n*2+1]) then Nr[n] := Nr[n*2+1];
if (tz < Tm[n*2+2]) then Nr[n] := Nr[n] + Nr[n*2+2];
Tm[n]:=T;
End; { zero }


Procedure baga(
    x : longint;
    n : longint;
    l : longint;
    r : longint;
    tz : longint
    );
Begin
If (GTz[n]>tz) Then
   Begin
   tz:=GTz[n];
   End { If };
If (l=r) Then
   Begin
   Nr[n]:=1; Tm[n]:=T;
   Exit;
   ;
   End { If };
If (x<=((l+r) Div 2)) Then
   Begin
   baga(x, ((n*2)+1), l, ((l+r) Div 2), tz);
   End { If }
Else
   Begin
   baga(x, ((n*2)+2), ((l+r) Div 2)+1, r, tz);
   End { Else };
Nr[n]:=0;
if (tz < Tm[n*2+1]) then Nr[n] := Nr[n*2+1];
if (tz < Tm[n*2+2]) then Nr[n] := Nr[n] + Nr[n*2+2];
Tm[n]:=T;
End; { baga }


Function point(
    x : longint;
    y : longint
    ) : longint;
Var
    l : longint;
Begin
If (gety(x)>=y) Then
   Begin
   point := -1;
   Exit;
   End { If };
l:=getx(y)+1;
T:=Succ(T);
zero(l, x, 0, 0, 260000, 0);
T:=Succ(T);
baga(x, 0, 0, 260000, 0);
sety(y, l, x, 0, 0, 260000);
point := Nr[0];
Exit;
End; { point }


Procedure read_and_solve;
Var
    x : longint { & "Address Of" Used };
    y : longint { & "Address Of" Used };
    nr : longint { & "Address Of" Used };
    fi, fo:text;
Begin
assign(fi, 'sea2.in');
assign(fo, 'sea2.out');
reset(fi);
rewrite(fo);
read(fi, nr);
While (nr <> 0) Do
   Begin
   read(fi, x, y);
   writeln(fo, point(x, y));
   dec(nr);
   End { While };
close(fi);
close(fo);
End; { read_and_solve }

begin
read_and_solve{};
halt(0);
End.

