/* Sea2 O(NlogN + M*D) = O(N^2) solution by Berinde Radu */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int X[200008], Y[200008];
int N;

void point()
{
    int l, r, m, i, x, y;
    scanf("%d %d", &x, &y);
    for (l = 0, r = N; l < r; )
        if (X[m = (l+r)/2] < x)
           l = m+1;
        else
           r = m;
    if (l < N && Y[l] > y)
    {
        printf("-1\n");
        return;
    }
    for (i = 0; l-i-1 >= 0 && Y[l-i-1] < y; i++);
    memmove(X+l-i+1, X+l, sizeof(int) * (N-l));
    memmove(Y+l-i+1, Y+l, sizeof(int) * (N-l));
    X[l-i] = x, Y[l-i] = y;
    N -= i-1;
    printf("%d\n", N);
}

void read_and_solve()
{
    int nr;
    freopen("sea2.in", "rt", stdin);
    freopen("sea2.out", "wt", stdout);
    scanf("%d", &nr);
    while (nr--)
        point();
}

int main()
{
    read_and_solve();
    return 0;
}
