{Problema 2 (Labirint):

Se da un labirint dreptunghiular de dimensiuni nxm (n<=20,m<=20).
Pozitiile din stanga sus si dreapta jos sunt marcate cu 0, celelalte
contin unul din numerele 1,2,3,4. Scopul este de a parcurge labirintul
din coltul stanga-sus pana la coltul din dreapta-jos pe un drum de
lungime minima, pe directii paralele cu laturile sale. Drumul urmat
trebuie sa plece din 0 in 1, apoi din 1 in 2, din 2 in 3 din 3 in 4,
din 4 in 1 etc. Se poate ajunge in pozitia finala din oricare pozitie
vecina ei.

Intrare (fisier INPUT.TXT):
Prima linie contine numerele intregi n si m, separate printr-un spatiu.
Fiecare din urmatoarele n linii contine cate m numere intregi separate
prin cate un spatiu, reprezentand labirintul.

Iesire (fisier OUTPUT.TXT):
Fisierul va contine doua linii; pe prima se afla numarul de pasi; pe
a doua se afla un sir de caractere. Sunt folosite caracterele D (jos),
U (sus), L (stanga) respectiv R (dreapta) pentru a reprezenta cel
mai scurt drum in labirint.

Exemplu:
Intrare:			Iesire:
5 4				7
0 1 2 3				RRRDDDD
3 2 1 4
4 1 2 1
1 4 3 2
2 3 4 0

Observatie: Se presupune ca problema are totdeauna cel putin o solutie.

Timp maxim per test: 5 secunde.
Punctaj maxim: 30 puncte.
--------------------------------------
 Programare dinamica
 Fiecare bucla REPEAT UNTIL marcheaza avansarea cu inca un pas prin labirint;
 Lista curenta (controlata de pointerul p) contine initial pozitia (1,1);
 dupa urmatoarea iteratie ea contine pozitiile in care se poate ajunge dupa
 un pas in labirint, etc. Dupa iteratia k, ea contine pozitiile in care se
 poate ajunge pe un drum de lungime k (algoritmul Lee).
 Lista controlata de pointerul prima, lista construita dupa sistemul stivei
 prin inserare la inceput, va deveni lista curenta la iteratia urmatoare.
 Stringul drum memoreaza miscarile in labirint pana in pozitia (i,j).
 }
 program labirint;
 const dx:array[1..4]of shortint=(1,0,-1,0);
       dy:array[1..4]of shortint=(0,1,0,-1);
       dir:array[1..4]of char=('R','D','L','U');
 type adr=^sol;
      sol=record
                i,j:byte;
                drum:string;
                next:adr
          end;
 var l:array[0..21,0..21]of byte;
     n,m,i,j:byte;
     prima,p,q,r:adr;
     f,g:text;
 begin
      assign(f,'input.txt');reset(f);
      assign(g,'output.txt');rewrite(g);
      readln(f,n,m);
      fillchar(l,sizeof(l),6);
      for i:=1 to n do begin
          for j:=1 to m do read(f,l[i,j]);
          readln(f)
      end;
      i:=1;
      if n*m=1 then begin
         writeln(g,0);close(g);
         halt
      end;
      new(prima);
      prima^.i:=1;prima^.j:=1;
      prima^.drum:='';prima^.next:=nil;
      l[1,1]:=6;
      repeat
            p:=prima;prima:=nil;
            while p<>nil do begin
                  for j:=1 to 4 do
                      if l[p^.i+dy[j],p^.j+dx[j]]=0 then begin
                         p^.drum:=p^.drum+dir[j];
                         writeln(g,length(p^.drum));
                         writeln(g,p^.drum);
                         close(g);halt
                      end
                      else
                          if l[p^.i+dy[j],p^.j+dx[j]]=i then begin
                             l[p^.i+dy[j],p^.j+dx[j]]:=6;
                             q:=prima;new(prima);
                             prima^.i:=p^.i+dy[j];prima^.j:=p^.j+dx[j];
                             prima^.drum:=p^.drum+dir[j];
                             prima^.next:=q
                          end;
                  r:=p;p:=p^.next;
                  dispose(r)
            end;
            i:=1+i*byte(i<4)
      until false
 end.