{Problema 1 (Compatibilitate de pesti):

Daca dorim sa cream un acvariu cu pesti exotici, trebuie sa
cerem avizul unui expert pentru a nu ajunge in situatia in care sa
cumparam tipuri de pesti care nu pot coexista in acvariu.

Fiind date numarul maxim F de tipuri de pesti si suma M care poate fi
cheltuita pentru investitie, se cere sa se stabileasca numarul maxim de
tipuri compatibile de pesti care se pot cumpara. Pentru acest numar, se
cere suma maxima folosita (dar nu mai mult de M), stiind ca se cumpara
cate un singur peste din fiecare tip.

Intrare:
Scrieti un program care citeste liniile din fisierul de intrare INPUT.TXT astfel:
- pe prima linie sunt scrise doua numere intregi separate printr-un
spatiu; primul numar reprezinta suma maxima M (M<=1000) de bani care
poate fi investita, iar al doilea reprezinta numarul F (F<=30) de
tipuri diferite de pesti oferiti spre cumparare.
- pe fiecare din urmatoarele F linii se da numarul de identificare al
unui tip de peste si costul unui exemplar de acest tip, separate
printr-un spatiu.
- pe fiecare din urmatoarele linii se specifica cate o pereche de
tipuri de pesti (separate printr-un spatiu) care nu pot coexista in
acelasi timp in acvariu.
- sfarsitul de fisier este indicat printr-o linie de forma
0 0

Iesire:
Iesirea este scrisa in fisierul OUTPUT.TXT astfel:
- pe prima linie, doua numare intregi separate printr-un spatiu. Primul
reprezinta numarul maxim de tipuri de pesti care pot trai in acvariu;
pentru acesta, al doilea numar reprezinta suma cheltuita. Daca
sunt mai multe solutii cu acelasi numar maxim de specii, se alege
solutia in care suma este maxima.
- pe urmatoarele linii, se va scrie lista numerelor care specifica
tipurile de pesti care pot trai in acvariu si pentru care s-a cheltuit
suma maxima posibila.

Exemplu:
Intrare:		Iesire:
170 7			4 160
1 70			2
2 50			4
3 30			5
4 40			6
5 40
6 30
7 20
1 4
1 7
3 4
3 5
5 7
6 7
0 0

Observatie:
Daca sunt mai multe solutii, se cere numai una.


Timp maxim de executare/test: 5 secunde.
Punctaj maxim: 30 puncte
----------------------------------------------
 Algoritm de programare dinamica
 }
program acvariu;
type pesti=set of 1..30;
     adr=^set_pesti;
     set_pesti=record
                     cost:integer;
                     alesi:pesti;
                     next:adr
               end;
var m,max:integer;n,i,j,x,y,nper:byte;
    p:array[1..30]of byte;
    pp:array[1..30]of integer;
    per:array[1..870]of pesti;
    d:array[1..30]of adr;
    sol:set_pesti;
    r,q:adr;  f,g:text;
function card(x:pesti):byte;
var c:byte;
begin
     c:=0;
     for i:=1 to n do
         if i in x then inc(c);
     card:=c
end;
function compatibil(i:byte;x:pesti):boolean;
var j,k:byte;
begin
     compatibil:=false;
     for j:=1 to n do
         if j in x then
            for k:=1 to nper do
                if [p[i],p[j]]=per[k] then exit;
     compatibil:=true
end;
begin {program principal}
      assign(f,'input.txt');reset(f);
      assign(g,'output.txt');rewrite(g);
      readln(f,m,n);
      for i:=1 to n do readln(f,p[i],pp[i]);
      nper:=0;
      readln(f,x,y);
      while x+y<>0 do begin
            inc(nper);
            per[nper]:=[x,y];
            readln(f,x,y)
      end;
      max:=1;
      for i:=1 to n do
          if pp[i]<=m then begin
             r:=d[1];new(d[1]);
             d[1]^.cost:=pp[i];
             d[1]^.alesi:=[i];
             d[1]^.next:=r;
             for j:=1 to n-1 do
               if j+n-i+1>=max then begin
                 r:=d[j];
                 while r<>nil do begin
                       if not(i in r^.alesi) and compatibil(i,r^.alesi) and
                          (r^.cost+pp[i]<=m) then begin
                          q:=d[j+1];
                          new(d[j+1]);max:=j+1;
                          d[j+1]^.cost:=r^.cost+pp[i];
                          d[j+1]^.alesi:=r^.alesi+[i];
                          d[j+1]^.next:=q
                       end;
                       r:=r^.next
                 end
             end
          end;
      r:=d[max];max:=0;
      while r<>nil do begin
            if r^.cost>max then begin
               max:=r^.cost;
               sol:=r^
            end;
            r:=r^.next
      end;
      writeln(g,card(sol.alesi),' ',sol.cost);
      for i:=1 to n do
          if i in sol.alesi then writeln(g,p[i]);
      close(g)
end.