/* Mugurel Ionut Andreica - Bucuresti, ROMANIA */

/* Time Complexity: O(N * 3 * 3!) = O(N) */

/* Score: 100 points */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define filein "comp.in"
#define fileout "comp.out"
#define maxn 16001
#define mare 1000000

long nf[maxn],fiu[maxn][2],final[maxn],col[maxn],howmany[maxn][3],perm[maxn][3];
long psol[3],pact[3],i,j,k,n,p,hm,c,nmax,nmin;

void df(long node)
{
long fs,fd;

for (k=0;k<3;k++)
  perm[node][k]=k;

if (nf[node]==0)
  {
  col[node]=0;
  howmany[node][0]=1;
  }
else
if (nf[node]==1)
  {
  fs=fiu[node][0];
  df(fs);

  for (k=0;k<3;k++)
    howmany[node][k]=howmany[fs][k];
  
  hm=mare; c=0;
  for (k=0;k<3;k++)
    if (howmany[node][k]<hm && col[fs]!=k)
      {
      hm=howmany[node][k];
      c=k;
      }

  howmany[node][c]++;
  col[node]=c;
  }
else /* nf[node]==2 */
  {
  fs=fiu[node][0];
  fd=fiu[node][1];

  df(fs);
  df(fd);

  /* combine the 2 colorings */

  for (i=0;i<3;i++)
    psol[i]=i;

  for (i=0;i<3;i++)
    {
    pact[0]=i;
    
    for (j=0;j<3;j++)
      if (j!=i)
        {
        pact[1]=j;
        
        for (k=0;k<3;k++)
          if (k!=i && k!=j)
            {
            pact[2]=k;

            for (p=0;p<3;p++)
              howmany[node][p]=howmany[fs][p];
            for (p=0;p<3;p++)
              howmany[node][pact[p]]+=howmany[fd][p];

            hm=mare;
            for (p=0;p<3;p++)
              if (howmany[node][p]<hm)
                hm=howmany[node][p];

            c=0;
            for (p=0;p<3;p++)
              if (howmany[node][p]>c)
                c=howmany[node][p];

            nmax=0;
            nmin=0;
            for (p=0;p<3;p++)
              if (howmany[node][p]==hm)
                nmin++;
              else
                nmax++;

            if (c-hm<=1 &&
               (nmin==3 ||
               (nmin==2 && (howmany[node][col[fs]]!=hm ||
                           howmany[node][pact[col[fd]]]!=hm)) ||
               (nmin==1 && (howmany[node][col[fs]]!=hm &&
                            howmany[node][pact[col[fd]]]!=hm))
               ) &&
               (pact[col[fd]]!=col[fs])
               )
              {
              /* OK! */
              for (p=0;p<3;p++)
                psol[p]=pact[p];
              }
            }
        }
    }

  for (k=0;k<3;k++)
    perm[fd][k]=psol[k];

  for (k=0;k<3;k++)
    howmany[node][k]=howmany[fs][k];
  for (k=0;k<3;k++)
    howmany[node][perm[fd][k]]+=howmany[fd][k];

  /* assign a color to node */
  hm=mare; c=0;
  for (k=0;k<3;k++)
    if (howmany[node][k]<hm && col[fs]!=k && perm[fd][col[fd]]!=k)
      {
      hm=howmany[node][k];
      c=k;
      }

  howmany[node][c]++;
  col[node]=c;
  }
}

void df2(long node)
{
long p[3];
/* save the current permutation */
for (k=0;k<3;k++)
  p[k]=pact[k];

/* modify the permutation */
for (k=0;k<3;k++)
  psol[k]=pact[perm[node][k]];
for (k=0;k<3;k++)
  pact[k]=psol[k];

final[node]=pact[col[node]];

if (nf[node]>1)
  df2(fiu[node][1]);
if (nf[node]>0)
  df2(fiu[node][0]);

/* restore the original permutation */
for (k=0;k<3;k++)
  pact[k]=p[k];
}

int main()
{
freopen(filein,"r",stdin);
freopen(fileout,"w",stdout);

scanf("%ld",&n);
memset(nf,0,sizeof(nf));
for (k=1;k<n;k++)
  {
  scanf("%ld %ld",&i,&j);

  nf[j]++;
  fiu[j][nf[j]-1]=i;
  }

memset(col,0,sizeof(col));
memset(howmany,0,sizeof(howmany));
memset(perm,0,sizeof(perm));
df(1);

memset(final,0,sizeof(final));
for (k=0;k<3;k++)
  pact[k]=k;

df2(1);

/*
printf("%ld %ld %ld\n",howmany[1][0],howmany[1][1],howmany[1][2]);
*/
for (i=1;i<=n;i++)
  printf("%ld ",final[i]+1);
printf("\n");

return 0;
}
