#include "basic.cpp"
#include <cstring>

double newd[MAXN][MAXC];
bool used[MAXN][MAXC];
double dp[MAXN][MAXC];

double solve(int id,int f)
{
    if ( used[id][f] ) return dp[id][f];
    used[id][f] = 1;
    double &d = dp[id][f] = 1e100;
    
    F(i,adj[id].size())
     {
	  int from = adj[id][i];
	  int newf = f - fuel[from][id];
	  if ( newf < 0 ) continue;
	  double newd = solve(from,newf) + dist[from][id];
	  if (newd < d) d = newd;
     }

    return d;
}


double floydwarshall()
{
        for (int k=1; k<=N; k++)
         if ( a[k].refuel )
          for (int i=1; i<=N; i++)
           if ( a[i].refuel )
            for (int j=1; j<=N; j++)
             if ( a[j].refuel || j==T )
              if ( newd[i][j] > newd[i][k] + newd[k][j] )
               {
                 newd[i][j] = newd[i][k] + newd[k][j];
               }
        return newd[S][T];
}



int main()
{
    readInput();
    for (int i=1; i<=N; i++)
      for (int j=1; j<=N; j++)
       newd[i][j] = 1e100;

    for (int i=1; i<=N; i++)
      if ( a[i].refuel )
       {
		  memset(used,0,sizeof(used));
		  used[i][0] = 1;
		  dp[i][0] = 0;
		  for (int j=1; j<=N; j++)
		    if ( (a[j].refuel && j > i) || j == T )
		     F(f,C+1)
		      if ( newd[i][j] > solve(j,f) )
		       newd[i][j] = newd[j][i] = dp[j][f];
       }

    printOutput(floydwarshall());
    
    return 0;
}
