#include <stdio.h>
#include <list>
#include <iostream>
#include <iterator>

using namespace std;

#define MAXN 150000

struct VERTEX2 {
    int v;
    list<VERTEX2>::iterator cross;
};
ostream & operator<<(ostream &a, const VERTEX2 &v)
{
        return a<<v.v;
}
struct VERTEX {
    int degree;
    int ods;
    int color;
    list<int> num;
    list<VERTEX2> sus;

    list<int>::iterator kde;
};

VERTEX graph[MAXN];
int n,m;

list<int> kopia[MAXN];

list<int> degree[MAXN];

list<int> zobr;

void zisnesus(int v, int &a, int &b)
{
    list<VERTEX2>::iterator it,it2,it3;
    int nas;
///    static int u=0;

    for (it = graph[v].sus.begin(); it != graph[v].sus.end(); it++) {
        for (it2 = it,it2++; it2 != graph[v].sus.end(); it2++) {
            nas=0;
/*            if (graph[it->v].degree > 100) {
                fprintf(stderr,"%d ", ++u);
            }*/
            for (it3 = graph[it->v].sus.begin(); it3 != graph[it->v].sus.end(); it3++) {
                if (it3->v == it2->v) {
                    nas=1;
                    break;
                }
            }
            if (nas == 0) {
                a=it->v;
                b=it2->v;
                return;
            }
        }
    }

    printf("Graf nie je planarny!!!\n");
    exit(1);
}

void zober(int co)
{
    list<VERTEX2>::iterator it;

    graph[co].ods=1;
    for (it = graph[co].sus.begin(); it != graph[co].sus.end(); it++) {
        graph[it->v].sus.erase(it->cross);
        degree[graph[it->v].degree].erase(graph[it->v].kde);
        graph[it->v].degree--;
        degree[graph[it->v].degree].push_front(it->v);
        graph[it->v].kde=degree[graph[it->v].degree].begin();
    }
}

void mergni(int a,int b)
{
    list<VERTEX2>::iterator it,it2;
    int nas;

    graph[a].num.splice(graph[a].num.begin(),graph[b].num);
    degree[graph[a].degree].erase(graph[a].kde);
    degree[graph[b].degree].erase(graph[b].kde);
    graph[b].kde=0;
    graph[a].kde=0;
    graph[b].ods=1;
    for (it = graph[b].sus.begin(); it != graph[b].sus.end(); it++) {
        degree[graph[it->v].degree].erase(graph[it->v].kde);
        graph[it->v].kde=0;
        nas=0;
        for (it2 = graph[a].sus.begin(); it2 != graph[a].sus.end(); it2++) {
            if (it2->v == it->v) {
                nas = 1;
                break;
            }
        }

        if (nas == 1) {
            graph[it->v].sus.erase(it->cross);
            graph[it->v].degree--;
        } else {
            graph[a].sus.push_front(*it);
            graph[a].sus.begin()->cross->cross=graph[a].sus.begin();
            graph[a].sus.begin()->cross->v=a;
            graph[a].degree++;
        }
    }

    degree[graph[a].degree].push_front(a);
    graph[a].kde=degree[graph[a].degree].begin();
    for (it = graph[b].sus.begin(); it != graph[b].sus.end(); it++) {
        if (graph[it->v].kde == 0) {
            degree[graph[it->v].degree].push_front(it->v);
            graph[it->v].kde=degree[graph[it->v].degree].begin();
        }
    }
}
void vypis_graph()
{
    int i;
    for (i = 0; i < n; i++) {
        if (graph[i].ods==1) continue;
        printf("vrchol cislo %d: zoznam vrcholov: ", i);
        copy(graph[i].num.begin(), graph[i].num.end(), ostream_iterator<int>(cout, " "));
        printf("\n");
        printf("zoznam susedov: ");
        copy(graph[i].sus.begin(), graph[i].sus.end(), ostream_iterator<VERTEX2>(cout, " "));
        printf("\n");
        printf("degree=%d\n", graph[i].degree);
    }
}

void vypis_deg()
{
    int i;
    printf("zoznamy pre stupne:\n");
    for (i = 0; i < n; i++) {
        printf("stupen=%d:",i);
        copy(degree[i].begin(), degree[i].end(), ostream_iterator<int>(cout, " "));
        printf("\n");
    }
}
   

int main()
{
//    fprintf(stderr,"begin...");
  stdin = fopen("color.in", "r");
  stdout = fopen("color.out", "w");
    int i,a,b,pocods,nas,v;
    list<int>::iterator it,it2,it3;
    VERTEX2 v1,v2;

    int color[6];


    scanf("%d %d", &n, &m);

    for (i = 0; i <n; i++) {
        graph[i].degree = 0;
        graph[i].color = -1;
        graph[i].ods=0;
        graph[i].num.push_front(i);
        graph[i].kde=0;
    }

    for (i = 0; i < m; i++) {
        scanf("%d %d", &a, &b);
        a--;b--;
        graph[a].degree++; graph[b].degree++;
        v1.v=a; v2.v=b;
        graph[a].sus.push_front(v2);
        graph[b].sus.push_front(v1);
        graph[a].sus.begin()->cross=graph[b].sus.begin();
        graph[b].sus.begin()->cross=graph[a].sus.begin();

        kopia[a].push_front(b);
        kopia[b].push_back(a);
    }

//    fprintf(stderr,"ahoj\n");
//    return 0;

    for (i = 0; i < n; i++) {
        degree[graph[i].degree].push_front(i);
        graph[i].kde=degree[graph[i].degree].begin();
    }

//    vypis_deg();

    pocods=0;
    while (1) {
        if (pocods>=n) {
            break;
        }
        nas=0;
        for (i=0; i <=5; i++) {
            if (degree[i].empty() == 0) {
                nas=1;
                break;
            }
        }
        if (nas == 1) {
            v=*degree[i].begin();
            degree[i].pop_front();
            pocods += graph[v].num.size();
            zobr.push_front(v);
            
            if (i == 5) {
               zisnesus(v,a,b);
            }
//            printf("Beriem v=%d,i=%d\n,pocods=%d\n", v,i,a,b,pocods);
            
            zober(v);
            
            if (i == 5) {
//                printf("mergujem %d,%d\n", a,b);
                mergni(a,b);
            }
/*            printf("\n");
            vypis_graph();
            vypis_deg();
            printf("\n");*/

        } else {
            printf("Chyba!!! Graf nie je planarny!!! (alebo bug v programe!\n");
            return 1;
        }
    }

    for (it=zobr.begin(); it != zobr.end(); it++) {
        for (i = 1; i <= 5; i++) {
            color[i]=0;
        }
        for (it2=graph[*it].num.begin(); it2!= graph[*it].num.end(); it2++) {
            for (it3=kopia[*it2].begin(); it3 != kopia[*it2].end(); it3++) {
                if (graph[*it3].color != -1) {
                    color[graph[*it3].color]=1;
                }
            }
        }
        nas=0;
        for (i = 1; i <=5; i++) {
            if (color[i] == 0) {
                nas=1;
                break;
            }
        }
        if (nas == 1) {
            for (it2=graph[*it].num.begin(); it2!= graph[*it].num.end(); it2++) {
                graph[*it2].color=i;
            }
        } else {
            printf("Fatal error!!! Bug v programe.\n");
            return 1;
        }
    }

    for (i = 0; i < n-1; i++) {
        printf("%d ", graph[i].color);
    }
    printf("%d\n", graph[i].color);
    
//    fprintf(stderr,"done\n");
    return 0;
}
