unit uStairs;

interface
const MAXN=1000;
type TARRAY=array[0..MAXN] of longint;

procedure Init_game(var n:longint; var stairs:TARRAY);
procedure Turn(from,coins:longint;var hisfrom,hiscoins:longint);

implementation
uses linux;

var moje_supertajne_pole:TARRAY;
var moje_supertajne_n:longint;
var moje_supertajne_max:longint;
var initialized:boolean;
var myxor:longint;

procedure Init_game(var n:longint; var stairs:TARRAY);
 var
  i:longint;
  g:string;
  f:text;

 begin
  if initialized then
   begin writeln('You lamma, Usama... called Init_game twice!'); halt(0); end;

{  g:=getenv('h4x0r'); }
  g := 'stairs.in';
  moje_supertajne_pole[0]:=47;
  if (g='') then
   begin
    n:=random(MAXN)+1;
    moje_supertajne_max:=n;
    moje_supertajne_n:=n;
    for i:=1 to n do moje_supertajne_pole[i]:=random(MAXN)+1;
   end
  else
   begin
    assign(f,g);
    reset(f);
    read(f,n); moje_supertajne_n:=n;
    for i:=1 to moje_supertajne_n do read(f,moje_supertajne_pole[i]);
    close(f);
    moje_supertajne_max:=moje_supertajne_n;
    while (moje_supertajne_pole[moje_supertajne_max]=0) do dec(moje_supertajne_max);
    myxor:=0;
   end;
  stairs:=moje_supertajne_pole;
  i:=1;
  while i<=moje_supertajne_n do
   begin myxor:=myxor xor moje_supertajne_pole[i]; inc(i,2); end;
  initialized:=TRUE;
 end;


procedure Turn(from, coins:longint; var hisfrom, hiscoins:longint);
var k:integer; 
 begin
  if not initialized then
   begin writeln('You lamma :-)  Forgot to call Init_game() !'); halt(0); end;
  if (from<1) or (from>moje_supertajne_n) then
   begin writeln('You fool, tahas zo zleho policka (',from,')'); halt(0); end;
  if (coins<=0) then
   begin writeln('You thief, kto nekradne, okrada rodinu! :-) (',coins,'<=0)'); halt(0); end;
  if (moje_supertajne_pole[from]<coins) then
   begin writeln('You bastard, a to si kde pocul, ze tam je ',coins,' veci ?!? (len ',
    moje_supertajne_pole[from],' ich tam je)'); halt(0); end;

  myxor:=myxor xor moje_supertajne_pole[from+(from and 1)-1];
  dec(moje_supertajne_pole[from],coins);
  inc(moje_supertajne_pole[from-1],coins);
  myxor:=myxor xor moje_supertajne_pole[from+(from and 1)-1];

  if (from=moje_supertajne_max) then
   while (moje_supertajne_pole[moje_supertajne_max]=0) do dec(moje_supertajne_max);
  if (moje_supertajne_max=0) then
   begin writeln('Dump.  Core dump.'); halt(0); end;

  hisfrom:=moje_supertajne_max;
  hiscoins:=random(moje_supertajne_pole[hisfrom])+1;

  if (myxor>0) then
   begin
    k:=1;
    while (k<=moje_supertajne_n) do
     begin
      if (myxor xor moje_supertajne_pole[k])<moje_supertajne_pole[k] then
       begin
        hisfrom:=k;
        hiscoins:=moje_supertajne_pole[k]-(moje_supertajne_pole[k] xor myxor);
        break;
       end;
      inc(k,2);
     end;
   end;

  myxor:=myxor xor moje_supertajne_pole[hisfrom+(hisfrom and 1)-1];
  dec(moje_supertajne_pole[hisfrom],hiscoins);
  inc(moje_supertajne_pole[hisfrom-1],hiscoins);
  myxor:=myxor xor moje_supertajne_pole[hisfrom+(hisfrom and 1)-1];

  if (hisfrom=moje_supertajne_max) then
   while (moje_supertajne_pole[moje_supertajne_max]=0) do dec(moje_supertajne_max);
  if (moje_supertajne_max=0) then
   begin writeln('Knock, knock... wake up Neo !'); halt(0); end;
 end;

 end.
