#include <cstdio>
#include <vector>

using namespace std;

class out_word {
private:
	bool first;
	
	void out(int w)
	{
		if (first) {
			printf("%d", w);
			first = false;
		} else
			printf(" %d", w);
	}
public:
	out_word() : first(true) { }
	~out_word() { putchar('\n'); }
	
	out_word& operator<<(int w)
	{
		out(w);
		return *this;
	}
	
	out_word& operator<<(vector<int> v)
	{
		for (vector<int>::const_iterator i = v.begin(); i != v.end(); i++)
			out(*i);
		return *this;
	}
};

vector<int> u(int a, int b)
{
	vector<int> ret;
	for (int i = a; i <= b; i++)
		ret.push_back(i);
	return ret;
}

vector<int> v(int a, int b)
{
	vector<int> ret;
	for (int i = a; i <= b; i++) {
		ret.push_back(i);
		ret.push_back(i-1);
	}
	return ret;
}

int main()
{
	stdin = fopen("tunes.in", "r");
	stdout = fopen("tunes.out", "w");
	int k;
	scanf("%d", &k);
	out_word ow;
	ow << 0 << v(1,k-4) << k-3 << k-1 << k-4 << k-2 << u(3,k-2) << 0
	   << k-1 << u(1,k-4) << 1 << 3 << 0 << 2 << v(4,k-1) << k-1;
	return 0;
}
