#include <algorithm>
#include <cstdio>
#include <cstdlib>

int main(int argc, char *argv[])
{
	stdin = fopen("tunes.in", "r");
	stdout = fopen("tunes.out", "w");
	int k;
	if (argc > 1)
		srand48(atoi(argv[1]));
	scanf("%d", &k);
	int n = 8 * k;
	int w[n];
	for (int i = 0; i < n; i++)
		w[i] = i % k;
	for (;;) {
		std::random_shuffle(w, w + n);
		bool stop = true;
		for (int i = 1; i < n; i++)
			if (w[i] == w[i-1]) {
				stop = false;
				break;
			}
		if (!stop)
			continue;
		for (int i = 3; i < n; i++)
			if (w[i] == w[i-2] && w[i-1] == w[i-3]) {
				stop = false;
				break;
			}
			
		if (stop)
			break;
	}
	printf("%d", w[0]);
	for (int i = 1; i < n; i++)
		printf(" %d", w[i]);
	printf("\n");
	return 0;
}
