#include <stdio.h>
#include <stdlib.h>

const int MAX_N=1000;		//pocet mnozin
const int MAX_H=1000;		//pocet hodin

int matrix[MAX_N][MAX_H],solved[MAX_H]; //spoleha se na nulovani
int solution[MAX_N];
int inv[] ={0,1,4,5,2,3,6,0};
	/*0,1,19,25,28,15,31,16,14,33,
			26,27,34,20,8,5,7,24,35,2,
			13,30,32,29,17,3,10,11,4,23,
			21,6,22,9,12,18,36};
*/
int N,H;

void read_input()
{
int i,inp;	
	scanf("%d %d",&H,&N);
	for (i=0;i<H;i++)
	{
		scanf("%d",&inp);
		matrix[i][0]=(inp+1)%7;
	}
	for (i=1;i<=N;i++)
	{
		int hour;
		while(1)
		{
			scanf("%d",&hour);
			if (hour==-1) break;
			matrix[hour-1][i]=1;
		}
	}

}

void horni_troj()
{
int line,id,cur_rad,i;
int swap;
int used[MAX_H];
	for(i=0;i<H;i++)
		used[i]=0;
	cur_rad=N;
	line=0;
	while (cur_rad)
	{
	//najde prvni nenulu a nepouzity sloupec
		for(i=line;((i<=H)&&(matrix[i][cur_rad]==0));i++);
		
		if (i>H) {--cur_rad;continue;}//volna promenna
		for (int j=0;j<=cur_rad;j++)
		{
	//printf("<%d\n>",i);
				
			swap=matrix[i][j];matrix[i][j]=matrix[line][j];matrix[line][j]=swap;
		}
		for (int j=0;j<=N;j++)	//vydeleni
			matrix[line][j]=(matrix[line][j]*inv[matrix[line][cur_rad]])%7;
//!!Vsechny hodnoty v matrix jsou nezaporne
		for (i=line+1;i<=H;i++)
			for (int j=0;j<=cur_rad;j++)	//odecteni
				matrix[i][j]=(matrix[i][j]-(matrix[line][j]*matrix[i][cur_rad])% 7 + 7) % 7;
		++line;
		--cur_rad;
		
	}
}

int solve()
{
int cur_rad,i;
int line=H-1;
	solution[0]=1;	//jen pomocne	
	while (line+1)
	{
		cur_rad=N+1;
		while (cur_rad && !matrix[line][--cur_rad]);//nalezne prvni nenulovy
		
		if (cur_rad>0) 
		{
			for (i = cur_rad-1;(i+1);i--)
				solution[cur_rad]=(solution[cur_rad]-(matrix[line][i]*solution[i])%7 + 7)%7;
		}
		else 
		{
			if (matrix[line][cur_rad]) return 1;
		}
		--line;
	}

	return 0;
		
}

int main(void)
{
int i,j;		
	
	read_input();

	/*for (i=0;i<H;i++){
		for (j=0;j<=N;j++)
			printf("%2d ",matrix[i][j]);
		printf("|\n");
	}*/
	//printf("----------------------------------------\n");
	//prevedeni na horni trojuhelnikovou
	horni_troj();
	/*for (i=0;i<H;i++){
		for (j=0;j<=N;j++)
			printf("%2d ",matrix[i][j]);
		printf("|\n");
	}*/
	
	if (solve()) printf("I can't win.");
	else 
	for (i=1;i<=N;i++)
		printf("%d ",solution[i]);
		
	/*	FILE *pom=fopen("inv","w");
	
	for (i=1;i<37;i++){
		for(j=1;(i*j)%37 != 1 ;j++);
		fprintf(pom,"%d,",j);
	}
	fclose(pom);*/

	return 0;
}
		
