#include <iostream>
#include <list>
#include <queue>
#include <set>

using namespace std;

#define REP(i,n) for (int i=0;i<n;++i)
#define FOREACH(it,x) for (__typeof((x).begin()) it=((x).begin()); it!=(x).end();++it)
#define FOR(i,p,k) for (int i=p; i<=k;++i)
#define ALL(x) x.begin(),x.end()
#define NUM(x) x.to_ulong()


const int max_town=100000;
const int inf=1000000000;

list<pair<int,int> > G[max_town];
	
int m,n;
	
bool od[max_town]={0};
int preorder[max_town]={0};
int back[max_town]={0};
int t=0;
set<int> articulation;
void dfs2(int v){
	od[v]=true;
	preorder[v]=back[v]=(++t);
	FOREACH(it,G[v]){
		int w=it->first;
		if (!od[w]){
			dfs2(w);
			back[v]<?=back[w];
			if (back[w]>=preorder[v]) articulation.insert(v);
		} else back[v]<?=preorder[w];
	}
}

int main(){
	cin >> n >> m;
	for (int i=0;i<m;++i){
		int x,y,z;
		cin >> x >> y >> z;
		G[x].push_back(make_pair(y,z));
		G[y].push_back(make_pair(x,z));
	}
	dfs2(1);
	articulation.insert(1);
	articulation.insert(n);
	cout << n- articulation.size() << endl;
	return 0;
}
