#include <iostream>
#include <list>
#include <queue>
#include <set>
#include <svio.h>

using namespace std;

#define REP(i,n) for (int i=0;i<n;++i)
#define FOREACH(it,x) for (__typeof((x).begin()) it=((x).begin()); it!=(x).end();++it)
#define FOR(i,p,k) for (int i=p; i<=k;++i)
#define ALL(x) x.begin(),x.end()
#define NUM(x) x.to_ulong()


const int max_town=100000;
const int inf=1000000000;

list<pair<int,int> > G[max_town];
	
int m,n,licz;

set<int> zb;

set<int> cur;
bool od[max_town]={0};
int dist[max_town];
void inter(set<int>& s, set<int>& a){
	set<int> r;
	set_intersection(ALL(s),ALL(a),inserter(r,r.begin()));
	s=r;
}
void dfs(int v, int d){
	if (dist[v]<d) return;
	cur.insert(v);
	if (v==n){
		/*cout << "zb ";
		FOREACH(it,zb) cout<<*it<<" ";
		cout << endl << "cur ";
		FOREACH(it,cur) cout<<*it<<" ";
		cout <<endl;*/
		if (dist[v]>d || zb.empty()) {licz=1; zb=cur;} 
		else {++licz;inter(zb,cur);}
	}
	dist[v]<?=d;
	od[v]=true;
	FOREACH(it,G[v]){
		if (!od[it->first])
			dfs(it->first,d+it->second);
	}
	cur.erase(v);
	od[v]=false;
}

int main(){
	n = read_int();
	m = read_int();
	for (int i=0;i<m;++i){
		int x,y,z;
		x = read_int();
		y = read_int();
		z = read_int();
		G[x].push_back(make_pair(y,z));
		G[y].push_back(make_pair(x,z));
	}
	FOR(i,1,n){dist[i]=inf;od[i]=false;}
	dist[1]=0;
	dfs(1,0);
	write_int(n-zb.size());
	return 0;
}
