//lukas
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <sstream>
#include <queue>
#include <bitset>
#include <utility>
#include <list>

#include <cstdio>
#include <cmath>
using namespace std;

#define REP(i,n) for(__typeof(n) i=0; i<(n); ++i)
#define FOR(i,a,b) for(__typeof(b) i=a; i<(b); ++i)
#define FOREACH(it,c) for(__typeof((c).begin()) it=(c).begin(); it!=(c).end(); ++it)

typedef pair<int, int> PI;
vector<PI> norm(vector<PI> a) {
    sort(a.begin(), a.end());
    int x=a[0].first, y=a[0].second;
    REP(i,a.size()) {
        a[i].first-=x;
        a[i].second-=y;
    }
    return a;
}
vector<PI> flip(vector<PI> a) {
    REP(i,a.size()) a[i].first*=-1;
    return norm(a);
}
int main() {
    int h[]={0, 1, 3, 4, 0, 1, 2, 6, 7, 3, 4, 5};
    int g[]={1, 2, 4, 5, 3, 4, 5, 7, 8, 6, 7, 8};
    int x1[]={0, 0, 1, -1};
    int y1[]={1, -1, 0, 0};
    string z[3];
    getline(cin, z[0]);
    getline(cin, z[1]);
    int n=2, m=3;

    set<vector<vector<PI> > > d;
    REP(i,1<<7) {
        bitset<20> b(i);
        bool bol[3][3]={0};
        vector<vector<PI> > vys;
        REP(j,n) REP(k,m) if (z[j][k]=='*' && !bol[j][k]) {
            queue<PI> f;
            vector<PI> gg;
            bol[j][k]=true; gg.push_back(PI(j, k));
            for (f.push(PI(j, k)); !f.empty(); f.pop()) REP(o,4) {
                int x=f.front().first, y=f.front().second;
                int s=x+x1[o], t=y+y1[o];
                bool ok=true;
                if (s<0 || s>=n || t<0 || t>=m) continue;
                if (bol[s][t] || z[s][t]!='*') continue;
                REP(w,12) if (b[w])
                    if ((x*m+y==h[w] && s*m+t==g[w]) || (x*m+y==g[w] && s*m+t==h[w]))
                        ok=false;
                if (!ok) continue;

                f.push(PI(s, t));
                bol[s][t]=true;
                gg.push_back(PI(s, t));
            }

            vector<vector<PI> > re(1, flip(gg));
            re.push_back(norm(gg));

            REP(oo,3) {
                gg=re.back();
                REP(i,gg.size()) {
                    int z1=gg[i].first, z2=gg[i].second;
                    gg[i].first=z2; gg[i].second=-z1;
                }
                re.push_back(flip(gg));
                re.push_back(norm(gg));
            }
            
            vys.push_back(*min_element(re.begin(), re.end()));
        }
        sort(vys.begin(), vys.end());
        d.insert(vys);
    }
    cout<<d.size()<<endl;
}
