#if 1
#include <stdio.h>
static inline int gc(void) { return getchar(); }
static inline void write_char(int c) { putchar(c); }
#else
#include "svio.h"
static int gclen = -1, gcpos = -1;
static int gc(void)
{
 restart:
  if (gcpos < gclen)
    {
      gcpos++;
      return read_char();
    }
  else if (gclen >= 0)
    {
      gcpos = gclen = -1;
      return '\n';
    }
  else
    {
      gcpos = 0;
      gclen = read_strlen();
      goto restart;
    }
}
#endif

#define MAX 10000000

int q[MAX];
int t[4], neg;

static void xf(void)
{
  int i = 0;
  int j = 0;
  for (;;)
    {
      // printf("#%d:%d\n", i,j);
      int z[4], k=i+1, l;
      if (!j)
	write_char('(');
      for (l=0; l<4; l++)
	{
	  z[l] = k;
	  // printf("\t%d -> %d\n", l, k);
	  if (q[k] < 0)
	    k++;
	  else
	    k = q[k] + 1;
	}
      if (j < 4)
	{
	  k = z[t[j++]];
	  if (q[k] < 0)
	    write_char('a' + ((-1-q[k]) ^ neg));
	  else
	    {
	      q[k] = i | (j << 28);
	      i = k;
	      j = 0;
	    }
	}
      else
	{
	  int oi = q[i];
	  write_char(')');
	  if (!i)
	    return;
	  q[i] = k;
	  i = oi & ((1 << 28) - 1);
	  j = oi >> 28;
	}
    }
}

int main(void)
{
  int N, i, j, sp, xp;

  sp = MAX;
  xp = 1;
  for (i=0;i<=MAX;i++)
    switch (gc())
      {
      case 'a':
	if (!xp--)
	  return 120;
	q[i] = -1;
	break;
      case 'b':
	if (!xp--)
	  return 120;
	q[i] = -2;
	break;
      case '(':
	if (!xp--)
	  return 120;
	q[i] = sp | (xp << 28);
	sp = i;
	xp = 4;
	break;
      case ')':
	if (sp < 0)
	  return 102;
	if (xp)
	  return 121;
	j = q[sp] & ((1 << 28) - 1);
	xp = q[sp] >> 28;
	q[sp] = i;
	q[i] = sp;
	sp = j;
	break;
      case '\n':
	goto done;
      default:
	return 101;
      }
  return 109;
 done:
  if (sp < MAX)
    return 103;
  if (xp)
    return 122;
  N = i;
  if (N >= MAX)
    return 123;

  t[0] = 0; t[1] = 1; t[2] = 2; t[3] = 3;
  neg = 0;
  for (i=0;;i++)
    switch (gc())
      {
      case 'L':
	j = t[0]; t[0] = t[1]; t[1] = t[3]; t[3] = t[2]; t[2] = j;
	break;
      case 'R':
	j = t[0]; t[0] = t[2]; t[2] = t[3]; t[3] = t[1]; t[1] = j;
	break;
      case 'X':
	j = t[0]; t[0] = t[1]; t[1] = j;
	j = t[2]; t[2] = t[3]; t[3] = j;
	break;
      case 'Y':
	j = t[0]; t[0] = t[2]; t[2] = j;
	j = t[1]; t[1] = t[3]; t[3] = j;
	break;
      case 'N':
	neg = !neg;
	break;
      case '\n':
	goto dotwo;
      default:
	return 112;
      }
 dotwo:

#if 0
  printf("N=%d\n", N);
  for (int i=0; i<N; i++) printf("%d: %d\n", i, q[i]);
#endif
  if (N > 1)
    xf();
  else
    write_char('a' + ((-1-q[0]) ^ neg));
  write_char('\n');
  return 0;
}
