#include <cstdio>
#include <cstdlib>
#include <vector>
#include <algorithm>
using namespace std;

vector<int> p,max_p;
int best=0;


long long cash(){
	vector<vector<long long> > d;
	d.resize(p.size());
	for(unsigned int i=0;i<d.size();i++)d[i].resize(p[0]+10,0);
	for(int i=0;i<=p[0];i++)d[0][i]=i;
	for(unsigned int i=1;i<p.size();i++){
		for(int j=1;j<=p[i];j++){
			d[i][j]=d[i-1][p[i-1]]+d[i][j-1]-d[i-1][j-1];
		}
	}
	long long m=0;
	for(unsigned int i=-0;i<d.size();i++){
		m+=d[i][p[i]];
	}
	return m;
}

int generate_partition(int n,int max){
	if(n==0){
//		for(unsigned int i=0;i<p.size();i++)printf("%d ",p[i]);
//		printf("\n");
		int f=cash();
//		printf(": %d\n",f);
		if(best<f){
			best=f;
			max_p.resize(p.size());
			copy(p.begin(),p.end(),max_p.begin());
		}
	}
	if(n<max)max=n;
	for(int i=1;i<=max;i++){
		p.push_back(i);
		generate_partition(n-i,i);
		p.resize(p.size()-1);
	}
	return 0;
}

int main(){
	int N;
	scanf("%d",&N);
	generate_partition(N,N);
	printf("%d\n%d",best,max_p[0]);
	for(unsigned int i=1;i<max_p.size();i++)printf(" %d",max_p[i]);
	printf("\n");
	return 0;
}
