
#include <stdio.h>
#include <stdlib.h>

#include "trees.h"

tree_t tree;

void loadTree( char *fn ) {
	FILE *f = fopen( fn, "rt" );
	fscanf( f, "%d", &tree.N );
	tree.rest = tree.N;
	tree.nodes = malloc( tree.N * sizeof *tree.nodes );
	int *buffer = malloc( tree.N * 2 * sizeof *tree.nodes );
	for( int i = 0; i < tree.N; ++ i ) {
		fscanf( f, "%d", &tree.nodes[ i ].ncount );
		tree.nodes[ i ].index = i;
		tree.nodes[ i ].tree = &tree;
		//tree.nodes[ i ].neighbors = malloc( tree.nodes[ i ].ncount * sizeof *tree.nodes[ i ].neighbors );
		tree.nodes[ i ].neighbors = buffer;
		buffer += tree.nodes[ i ].ncount;
		for( int j = 0; j < tree.nodes[ i ].ncount; ++ j ) {
			fscanf( f, "%d", &tree.nodes[ i ].neighbors[ j ] );
			tree.nodes[ i ].neighbors[ j ] --;
		}
		tree.nodes[ i ].tag = NULL;
		for( int j = 0; j < 4; ++ j )
			tree.nodes[ i ].avail[ j ] = 1;
		tree.nodes[ i ].deco = 5;
	}
	fclose( f );
}
