/* Stock Exchange
 * Slow solution O(mn)
 * Tomasz Idziaszek
 * June 2007 */

#include <cstdio>
#include <cassert>
using namespace std;

const int MAX = 100000;

int price[MAX];
int n, m, l, u, j, k, count, last;

int main() {
   scanf("%d%d", &n, &m);
   assert(1 <= n && n <= MAX);
   assert(1 <= m && m <= 1000000);
   for (int i = 0; i < n; ++i) {
      scanf("%d", &price[i]);
      assert(1 <= price[i] && price[i] <= 1000000000);
   }

   last = 0;
   for (int i = 0; i < m; ++i) {
      scanf("%d%d%d%d", &j, &k, &l, &u);
      l += last;
      u += last;
      assert(1 <= j && j <= k && k <= n);
      assert(1 <= l && l <= u && u <= 1000000000);
      count = 0;
      for (--j; j < k; ++j)
	 if (l <= price[j] && price[j] <= u) ++count;
      last = count;
      printf("%d\n", last);
   }
   return 0;
}

