program Books;
const
	MaxN = 55;
var
	mark: array [1.. MaxN, 1.. MaxN] of Boolean;
  b: array [1.. MaxN, 1.. MaxN] of LongInt;
  n, sol, i, j, max1, max2: LongInt;
begin
	
  // Input data
  ReadLn (n);
  for i := 1 to n do
  	for j := 1 to n do
    	Read (b [i][j]);
  sol := 0;
  FillChar (mark, SizeOf (mark), false);

  // mark [i][j] = True iff we can see books on field [i][j]
  // from any direction

  // Find horizontal visible books
  for i := 1 to n do begin
  	max1 := 0;
    max2 := 0;
    for j := 1 to n do begin
    	// Visible from left to right
      if (b [i][j] > max1) then begin
      	mark [i][j] := True;
      	max1 := b [i][j];
      end;

    	// Visible from right to left
      if (b [i][n + 1 - j] > max2) then begin
      	mark [i][n + 1 - j] := True;
        max2 := b [i][n + 1 - j];
      end;
    end;
  end;


  // Find vertical visible books
  for j := 1 to n do begin
  	max1 := 0;
    max2 := 0;
    for i := 1 to n do begin
	   	// Visible from top to bottom
    	if (b [i][j] > max1) then begin
      	mark [i][j] := True;
        max1 := b [i][j];
      end;

  	 	// Visible from bottom to top
      if (b [n + 1 - i][j] > max2) then begin
      	mark [n + 1 - i][j] := True;
        max2 := b [n + 1 - i][j];
      end;
    end;
  end;

  // Count solution
  for i := 1 to n do
  	for j := 1 to n do
    	if (mark [i][j]) then
      	Inc (sol);

  WriteLn (sol);
end.
