const
  MaxN = 1000;
  DayLenght = 24*60*60;

var
  n : Integer;
  tStart, tEnd : ARRAY[1..MaxN] of Longint;

  a : array[0..DayLenght-1] of Integer;
  sol : Integer;


  procedure Solve;
  var
    i : Integer;
    t : Longint;
  begin
    for t := 0 to DayLenght-1 do
      a[t] := 0;

    for i := 1 to n do
      for t := tStart[i] to tEnd[i] do
        inc(a[t]);

    sol := 0;

    for t := 0 to DayLenght-1 do
      if a[t] > sol then
        sol := a[t];
  end;



  function HmsToT(h, m, s : Integer) : Longint;
  begin
    HmsToT := ((h * 60) + m) * 60 + s;
  end;


  function ChToN(ch1, ch2 : Char) : Integer;
  begin
    ChToN := (Ord(ch1) - Ord('0')) * 10 + (Ord(ch2) - Ord('0'));
  end;



  procedure ReadInput;
  var
    i : Integer;
    s : String;
  begin
    Readln(n);

    for i := 1 to n do
    begin
      Readln(s);
      tStart[i] := HmsToT(ChToN(s[1], s[2]), ChToN(s[4], s[5]), ChToN(s[7], s[8]));
      tEnd[i]   := HmsToT(ChToN(s[10], s[11]), ChToN(s[13], s[14]), ChToN(s[16], s[17]));
      if (tStart[i] > tEnd[i]) then
        Writeln('Aco, ne valja ti test');
    end;
  end;


  procedure WriteOutput;
  begin
    Writeln(sol);
  end;



begin
  ReadInput;
  Solve;
  WriteOutput;
end.

