{
  Problem D : Punctuation Mark
  Author    : Yuan Hao
  Algorithm : Dynamic Programming
}

{$r-,q-,s-,n+,g+}
program Punct;
const
  fn_in            = 'punct.inp';
  fn_out           = 'punct.out';
  MaxN             = 100;
  MaxSentenceSize  = 50;
  MinSentenceWords = 3;
  MaxWordLen       = 10;
  MaxParagraphSize = 255;
  None             = $FF;
  ModSize          = 20;
type
  TH=array[1..MaxSentenceSize,1..MaxSentenceSize] of byte;
var
  words:array[1..maxn] of string[MaxWordLen];
  h:array[0..ModSize] of TH; { Memory Problem , so as Problem B }
  mk:array[0..MaxParagraphSize] of byte;
  len,n,ans:integer;
  para:string;
{  time:longint;}

  procedure init;
  var j,i:Integer;
  begin
    assign(input,fn_in);
    reset(input);
    readln(n);
    for i:=1 to n do
    begin
      readln(words[i]);
      for j:=1 to length(words[i]) do words[i][j]:=upcase(words[i][j]);
    end;
    readln(para);
    for j:=1 to length(para) do para[j]:=upcase(para[j]);
    close(input);
  end;

  function LookUp(st:string):boolean;
  var i:integer;
  begin
    for i:=1 to n do
      if st=words[i] then
      begin
        LookUp:=true;
        exit;
      end;
    LookUp:=false;
  end;

  procedure main;
  var i,j,k,l:Integer;
  begin
    ans:=0;
    len:=length(para);
    fillchar(mk,sizeof(mk),None);
    fillchar(h,sizeof(h),None);
    mk[0]:=0;
    for i:=1 to len do
      for j:=1 to 10 do
       if (i-j>=0) and (LookUp(copy(para,i-j+1,j))) then
       begin
         { new sentence }
         if mk[i-j]<>None then h[i mod modsize,1,j]:=mk[i-j]+1;
         for l:=1 to maxsentencesize-1 do
          for k:=1 to MaxSentenceSize do if k>j then
          begin
            if (h[(i-j) mod modsize,l,k-j]<>None) and
               ((h[(i-j) mod modsize,l,k-j]>h[i mod modsize,l+1,k]) or
                 (h[i mod modsize,l+1,k]=None)) then
                h[i mod modsize,l+1,k]:=h[(i-j) mod modsize,l,k-j];
            if (l>=2) and ((k mod (l+1))=0) and (h[i mod modsize,l+1,k]<>None) and
               ((h[i mod modsize,l+1,k]>mk[i]) or (mk[i]=None)) then
                 mk[i]:=h[i mod modsize,l+1,k];
          end;
       end;
    ans:=mk[len];
    if ans=none then ans:=0;
  end;

  procedure out;
  begin
{    writeln((meml[$40:$6C]-time)/18.2:0:3);}
    assign(output,fn_out);
    rewrite(output);
    writeln(ans);
    close(output);
  end;

  begin
{    time:=meml[$40:$6C];}
    init;
    main;
    out;
  end.