program third;
const
  inputfilename='';
  outputfilename='';
  maxn=20;
  Minn=8;
  maxsize=4845;
type
  Tdata=array [1..4] of shortint;
var
  n:integer;
  x,y:array [1..maxn] of real;
  dist:array [1..maxn,1..maxn] of real;
  turn:array [1..maxn,1..maxn] of shortint;
  getdata:array [1..maxn,1..maxn,1..maxn,1..maxn] of integer;
  gettemp:array [0..maxsize,1..4] of real;
  data:Tdata;
procedure init;
  var
    i,j:integer;
  begin
    assign (input,inputfilename);
    reset (input);
    readln (n);
    for i:=1 to n do
      readln (x[i],y[i]);
    close (input);
    for i:=1 to n do
      for j:=1 to n do
        dist[i,j]:=Sqrt(Sqr(x[i]-x[j])+Sqr(y[i]-y[j]));
  end;{init}
procedure out(ans:real);
  begin
    assign (output,outputfilename);
    rewrite (output);
    writeln (ans:0:2);
    close (output);
    halt;
  end;{out}
procedure sort;
  var
    k,i,j:integer;
    temp:shortint;
  begin
    if n<=1 then
      out(0);
    fillchar (turn,sizeof(turn),0);
    for k:=1 to n do
      begin
        for i:=1 to n do
          turn[k,i]:=i;
        for i:=1 to n-1 do
          for j:=i+1 to n do
            if dist[k,turn[k,i]]>dist[k,turn[k,j]] then
              begin
                temp:=turn[k,i];
                turn[k,i]:=turn[k,j];
                turn[k,j]:=temp;
              end;
        for j:=1 to n do
          if turn[k,j]=k then
            break;
        for i:=j to n-1 do
          turn[k,i]:=turn[k,i+1];
      end;
  end;{sort}
procedure solve1;
  var
    i:integer;
    best:real;
    vis:array [1..minn] of boolean;
  procedure search(depth,last:shortint;cost:real);
    var
      i,j:shortint;
    begin
      if cost+1e-4>best then
        exit;
      if depth=n then
        best:=cost
      else
        for i:=1 to n-1 do
          begin
            j:=turn[last,i];
            if vis[j] then
              begin
                vis[j]:=false;
                search(depth+1,j,cost+dist[last,j]);
                vis[j]:=true;
              end;
          end;
    end;{search}
  begin
    best:=1e30;
    fillchar (vis,sizeof(vis),true);
    for i:=1 to n do
      begin
        vis[i]:=false;
        search(1,i,0);
        vis[i]:=true;
      end;
    out(best);
  end;{solve1}
procedure preprocess;
  var
    t:array [1..maxn] of boolean;
    a:Tdata;
    i,temp,u,j:integer;
  function Get(a:Tdata):integer;
    var
      i,j,temp:shortint;
    begin
      for i:=1 to 3 do
        for j:=i+1 to 4 do
          if a[i]>a[j] then
            begin
              temp:=a[i];
              a[i]:=a[j];
              a[j]:=temp;
            end;
      Get:=Getdata[a[1],a[2],a[3],a[4]];
    end;{Get}
  procedure search(depth,last:shortint;cost:real);
    var
      i:shortint;
    begin
      if depth=4 then
        begin
          temp:=Get(a);
          u:=1;
          for i:=1 to 4 do
            if a[i]<last then
              inc(u);
          if cost<gettemp[temp,u] then
            gettemp[temp,u]:=cost;
        end
      else
        begin
          inc(depth);
          for i:=1 to n do
            if t[i] then
              begin
                a[depth]:=i;
                t[i]:=false;
                search(depth,i,cost+dist[last,i]);
                t[i]:=true;
              end;
        end;
    end;{search}
  begin
    fillchar (t,sizeof(t),true);
    for i:=0 to maxsize do
      for j:=1 to 4 do
        gettemp[i,j]:=1e30;
    for i:=1 to n do
      begin
        t[i]:=false;
        a[1]:=i;
        search (1,i,0);
        t[i]:=true;
      end;
  end;{preprocess}
procedure preprocessdata;
  var
    i:shortint;
    a:Tdata;
    temp:integer;
  procedure try(depth:shortint);
    var
      i:shortint;
    begin
      if depth=5 then
        begin
          inc(temp);
          getdata[a[1],a[2],a[3],a[4]]:=temp;
          exit;
        end;
      for i:=a[depth-1]+1 to n do
        begin
          a[depth]:=i;
          try(depth+1);
        end;
    end;{try}
  begin
    temp:=-1;
    for i:=1 to n-3 do
      begin
        a[1]:=i;
        try(2);
      end;
  end;{preprocessdata}
procedure solve2;
  var
    best:real;
    temp,i,maxdepth:integer;
    a:Tdata;
    vis:array [1..maxn] of boolean;
    a1:Tdata;
    temp1:integer;
    mincost:real;
    tot,maxtot:integer;
  procedure search(depth,last:shortint;cost:real);
    var
      i,j:shortint;
    begin
      if tot>=maxtot then
        exit;
      i:=0;
      for j:=1 to 4 do
        begin
          repeat
            inc(i);
          until vis[i];
          a1[j]:=i;
        end;
      temp1:=getdata[a1[1],a1[2],a1[3],a1[4]];
      mincost:=gettemp[temp1,1]+dist[last,a1[1]];
      for i:=2 to 4 do
        if gettemp[temp1,i]+dist[last,a1[i]]<mincost then
          mincost:=gettemp[temp1,i]+dist[last,a1[i]];
      if mincost+cost+1e-4>best then
        exit;
      if depth=maxdepth then
        begin
          best:=cost+mincost;
          exit;
        end;
      inc(tot);
      for i:=1 to n-1 do
        begin
          j:=turn[last,i];
          if vis[j] then
            begin
              vis[j]:=false;
              search(depth+1,j,cost+dist[last,j]);
              vis[j]:=true;
            end;
        end;
    end;{search}
  procedure try(depth:shortint);
    var
      i:shortint;
    begin
      if depth=5 then
        begin
          inc(temp);
          for i:=1 to 4 do
            vis[a[i]]:=false;
          for i:=1 to 4 do
            begin
              tot:=0;
              search (4,a[i],gettemp[temp,i]);
            end;
          for i:=1 to 4 do
            vis[a[i]]:=true;
          exit;
        end;
      for i:=a[depth-1]+1 to n do
        begin
          a[depth]:=i;
          try(depth+1);
        end;
    end;{try}
  begin
    maxtot:=1000;
    if n>=12 then
      case n of
        20:maxtot:=100;
      end;
    best:=1e30;
    temp:=-1;
    fillchar (vis,sizeof(vis),true);
    maxdepth:=n-4;
    for i:=1 to n-3 do
      begin
        a[1]:=i;
        try(2);
      end;
    out(best);
  end;{solve2}
begin
  init;
  sort;
  if n<=Minn then
    solve1;
  preprocessdata;
  preprocess;
  solve2;
end.
