program cross;
const
  inputfilename='cross.dat';
  outputfilename='cross.out';
  maxn=200;
var
  n1,n2:integer;
  f:array [0..maxn,0..maxn] of byte;
  a,b:array [1..maxn] of integer;
procedure init;
  var
    i:integer;
  begin
    assign (input,inputfilename);
    reset (input);
    readln (n1,n2);
    for i:=1 to n1 do
      read (a[i]);
    readln;
    for i:=1 to n2 do
      read (b[i]);
    close (input);
  end;{init}
procedure process;
  var
    i,j,u,v:integer;
    temp:byte;
  function Max(a,b:byte):byte;
    begin
      if a>b then
        Max:=a
      else
        Max:=b;
    end;{Max}
  function Found1(var t:integer):boolean;
    var
      k:integer;
    begin
      for k:=i-1 downto 1 do
        if a[k]=b[j] then
          begin
            t:=k;
            Found1:=true;
            exit;
          end;
      Found1:=false;
    end;{Found1}
  function Found2(var t:integer):boolean;
    var
      k:integer;
    begin
      for k:=j-1 downto 1 do
        if b[k]=a[i] then
          begin
            t:=k;
            Found2:=true;
            exit;
          end;
      Found2:=false;
    end;{Found2}
  begin
    fillchar (f,sizeof(f),0);
    for i:=1 to n1 do
      for j:=1 to n2 do
        begin
          temp:=Max(f[i-1,j],f[i,j-1]);
          if (a[i]<>b[j]) and Found1(u) and Found2(v) and (f[u-1,v-1]+1>temp) then
            temp:=f[u-1,v-1]+1;
          f[i,j]:=temp;
        end;
    assign (output,outputfilename);
    rewrite (output);
    writeln (f[n1,n2]*2);
    close (output);
  end;{process}
begin
  init;
  process;
end.