program sramoc;
const
  inputfilename='sramoc.dat';
  outputfilename='sramoc.out';
  maxn=1000+3;
var
  k,n:integer;
  vis:array [0..maxn] of integer;
  per,used:array [0..maxn] of integer;
procedure init;
  begin
    assign (input,inputfilename);
    reset (input);
    readln (k,n);
    close (input);
  end;{init}
function Can(t:integer):boolean;
  begin
    if t=0 then
      begin
        Can:=false;
        exit;
      end;
    while t>0 do
      begin
        if t mod 10>=k then
          begin
            Can:=false;
            exit;
          end;
        t:=t div 10;
      end;
    Can:=true;
  end;{Can}
procedure preprocess;
  begin
    if Can(n) then
      begin
        assign (output,outputfilename);
        rewrite (output);
        writeln (n);
        close (output);
        halt;
      end;
    fillchar (vis,sizeof(vis),0);
    fillchar (per,sizeof(per),0);
    fillchar (used,sizeof(used),0);
  end;{preprocess}
procedure out(t:integer);
  var
    temp:integer;
  begin
    assign (output,outputfilename);
    rewrite (output);
    write (t);
    temp:=t;
    repeat
      write (used[temp]);
      temp:=per[temp];
    until temp=0;
    writeln;
    close (output);
    halt;
  end;{out}
procedure solve;
  var
    temp:integer;
    i,j,u,v,tt:integer;
    tot:integer;
  begin
    vis[0]:=1;
    tot:=0;
    repeat
      inc(tot);
      for i:=0 to maxn do
        if vis[i]=tot then
          begin
            if Can(i) then
              out(i);
            vis[i]:=-1;
            for j:=0 to 9 do
              begin
                u:=i+n*j;
                tt:=u mod 10;
                if tt>=k then
                  continue;
                u:=u div 10;
                if vis[u]=0 then
                  begin
                    vis[u]:=tot+1;
                    per[u]:=i;
                    used[u]:=tt;
                  end;
              end;
          end;
    until false;
  end;{solve}
begin
  init;
  preprocess;
  solve;
end.