program satanic;
const
  inputfilename='satanic.dat';
  outputfilename='satanic.out';
  maxn=100;
var
  n,count:integer;
  f:array [1..maxn] of longint;
  turn:array [1..maxn] of integer;
  g:array [1..maxn,1..maxn] of longint;
procedure init;
  var
    i,j:integer;
  begin
    assign (input,inputfilename);
    reset (input);
    readln (n);
    for i:=1 to n do
      begin
        for j:=1 to n do
          read (g[i,j]);
        readln;
      end;
    close (input);
  end;{init}
procedure TP_Sort;
  var
    i,j:integer;
    found:boolean;
    du:array [1..maxn] of integer;
    vis:array [1..maxn] of boolean;
  procedure search(now:integer);
    var
      i:integer;
    begin
      vis[now]:=true;
      for i:=1 to n do
        if not vis[i] and (g[now,i]<>0) then
          search(i);
    end;{search}
  begin
    fillchar (vis,sizeof(vis),false);
    search(1);
    fillchar (du,sizeof(du),0);
    for i:=1 to n do
      if vis[i] then
        for j:=1 to n do
          if g[i,j]<>0 then
            inc(du[j]);
    Count:=0;
    repeat
      found:=false;
      for i:=1 to n do
        if vis[i] and (du[i]=0) then
          begin
            inc(Count);
            Turn[Count]:=i;
            du[i]:=maxint;
            for j:=1 to n do
              if g[i,j]<>0 then
                dec(du[j]);
            found:=true;
          end;
    until not found;
  end;{TP_Sort}
procedure solve;
  var
    i,j,u:integer;
    temp,t1:longint;
  begin
    for i:=1 to n do
      f[i]:=maxlongint;
    f[n]:=1;
    for u:=Count downto 1 do
      begin
        i:=Turn[u];
        if f[i]=maxlongint then
          continue;
        if f[i]<=0 then
          f[i]:=1;
        temp:=f[i];
        for j:=1 to n do
          if g[j,i]<>0 then
            begin
              t1:=(temp-g[j,i]-1) div 2+1;
              if t1<f[j] then
                f[j]:=t1;
            end;
      end;
  end;{solve}
procedure out;
  begin
    assign (output,outputfilename);
    rewrite (output);
    writeln (f[1]);
    close (output);
  end;{out}
begin
  init;
  TP_sort;
  solve;
  out;
end.