{$R-,Q-,S-}
Const
    InFile	= 'cross.dat';
    OutFile	= 'cross.out';
    Limit	= 200;

Type
    Tdata	= array[0..1 , 1..Limit] of longint;
    Topt	= array[0..Limit , 0..Limit] of longint;

Var
    data	: Tdata;
    opt	: Topt;
    N , M	: longint;

procedure init;
var
    i	: longint;
begin
    assign(INPUT , InFile); ReSet(INPUT);
      readln(N , M);
      for i := 1 to N do
        read(data[0 , i]);
      for i := 1 to M do
        read(data[1 , i]);
    Close(INPUT);
end;

procedure find(target , sign , start : longint; var posi : longint);
var
    i	: longint;
begin
    posi := 0;
    for i := start - 1 downto 1 do
      if data[sign , i] = target then
        begin
            posi := i;
            break;
        end;
end;

procedure work;
var
    i , j ,
    prevX ,
    prevY	: longint;
begin
    fillchar(opt , sizeof(opt) , 0);
    for i := 1 to N do
      for j := 1 to M do
        begin
            if opt[i - 1 , j] > opt[i , j] then opt[i , j] := opt[i - 1 , j];
            if opt[i , j - 1] > opt[i , j] then opt[i , j] := opt[i , j - 1];
            if data[0 , i] <> data[1 , j] then
              begin
                  find(data[0 , i] , 1 , j , prevY);
                  find(data[1 , j] , 0 , i , prevX);
                  if (prevX <> 0) and (prevY <> 0) then
                    if opt[prevX - 1 , prevY - 1] + 1 > opt[i , j] then
                      opt[i , j] := opt[prevX - 1 , prevY - 1] + 1;
              end;
        end;
end;

procedure out;
begin
    assign(OUTPUT , OutFile); ReWrite(OUTPUT);
      writeln(opt[N , M] * 2);
    Close(OUTPUT);
end;

Begin
    init;
    work;
    out;
End.
