{$R-,Q-,S-}
Const
    InFile	= 'sramoc.dat';
    OutFile	= 'sramoc.out';
    Limit	= 1001;

Type
    Tqueue	= array[1..Limit] of
    	    record
                       remainder , father , addnum	: longint;
                   end;
    Tvisited	= array[0..Limit - 1] of boolean;

Var
    queue	: Tqueue;
    visited	: Tvisited;
    K , M ,
    open ,
    closed	: longint;

procedure init;
begin
    assign(INPUT , InFile); ReSet(INPUT);
      readln(K , M);
    Close(INPUT);
    fillchar(queue , sizeof(queue) , 0);
    fillchar(visited , sizeof(visited) , 0);
end;

procedure work;
var
    i , tmp	: longint;
begin
    open := 1; closed := 0;
    for i := 1 to K - 1 do
      if not visited[i mod M] then
        begin
            inc(closed);
            visited[i mod M] := true;
            queue[closed].remainder := i mod M;
            queue[closed].father := -1;
            queue[closed].addnum := i;
        end;
    while not visited[0] do
      begin
          for i := 0 to K - 1 do
            begin
                tmp := (queue[open].remainder * 10 + i) mod M;
                if not visited[tmp] then
                  begin
                      inc(closed);
                      visited[tmp] := true;
                      queue[closed].remainder := tmp;
                      queue[closed].father := open;
                      queue[closed].addnum := i;
                  end;
            end;
          inc(open);
      end;
end;

procedure out;
type
    Tanswer	= array[1..Limit] of longint;
var
    answer	: Tanswer;
    len , i	: longint;
begin
    len := 0;
    i := closed;
    while queue[i].remainder <> 0 do dec(i);
    while i <> -1 do
      begin
          inc(len);
          answer[len] := queue[i].addnum;
          i := queue[i].father;
      end;

    assign(OUTPUT , OutFile); ReWrite(OUTPUT);
      for i := len downto 1 do
        write(answer[i]);
      writeln;
    Close(OUTPUT);
end;

Begin
    init;
    work;
    out;
End.
