{$R-,Q-,S-}
Const
    InFile	= 'satanic.dat';
    OutFile	= 'satanic.out';
    Limit	= 100;

Type
    Tmap	= array[1..Limit , 1..Limit] of longint;
    Topt	= array[1..Limit] of longint;

Var
    map	: Tmap;
    opt	: Topt;
    N	: integer;

procedure init;
var
    i , j	: integer;
begin
    assign(INPUT , InFile); ReSet(INPUT);
      readln(N);
      for i := 1 to N do
        for j := 1 to N do
          read(map[i , j]);
    Close(INPUT);
end;

procedure work;
var
    i , j ,
    tmp 	: integer;
    changed	: boolean;
begin
    fillchar(opt , sizeof(opt) , 0);
    opt[N] := 1;
    changed := true;
    while changed do
      begin
          changed := false;
          for i := 1 to N do
            if opt[i] > 0 then
              for j := 1 to N do
                if (i <> j) and (map[j , i] <> 0) then
                  begin
                      tmp := (opt[i] - map[j , i] + 1) div 2;
                      if tmp <= 0 then
                        tmp := 1;
                      if (opt[j] = 0) or (opt[j] > tmp) then
                        begin
                            opt[j] := tmp;
                            changed := true;
                        end;
                  end;
      end;
end;

procedure out;
begin
    assign(OUTPUT , OutFile); ReWrite(OUTPUT);
      writeln(opt[1]);
    Close(OUTPUT);
end;

Begin
    init;
    work;
    out;
End.
