Program Satanic;
Const
  Fn1 = 'Satanic.dat';
  Fn2 = 'Satanic.out';
  MaxN = 100;
Var
  N,Count              :Integer;
  F                    :Array [1..MaxN] of LongInt;
  Turn                 :Array [1..MaxN] of Integer;
  G                    :Array [1..MaxN,1..MaxN] of LongInt;
Procedure Init;
  Var
    i,j                :Integer;
  Begin
    Assign (Input,Fn1);
    Reset (Input);
    Readln (n);
    For i:=1 to N do
      Begin
        For j:=1 to N do
          Read (G[i,j]);
        Readln;
      End;
    Close (Input);
  End;{Init}
Procedure Preprocess;
  Var
    i,j                :Integer;
    Found              :Boolean;
    Du                 :Array [1..MaxN] of Integer;
    Vis                :Array [1..MaxN] of Boolean;
  Procedure Search(now:Integer);
    Var
      i                :Integer;
    Begin
      Vis[now]:=True;
      For I:=1 to n do
        if not Vis[I] and (G[now,I]<>0) then
          Search(I);
    End;{Search}
  Begin
    Fillchar (Vis,sizeof(Vis),False);
    search(1);
    fillchar (Du,sizeof(Du),0);
    For i:=1 to n do
      if Vis[i] then
        For j:=1 to n do
          if G[i,j]<>0 then
            Inc(du[j]);
    Count:=0;
    Repeat
      Found:=false;
      For I:=1 to n do
        if Vis[I] and (Du[I]=0) then
          Begin
            Inc(Count);
            Turn[Count]:=I;
            Du[I]:=Maxint;
            for J:=1 to n do
              if G[I,J]<>0 then
                Dec(du[J]);
            Found:=true;
          End;
    Until Not Found;
  End;{Preprocess}
Procedure Solve;
  Var
    i,j,u              :Integer;
    Temp,T             :LongInt;
  Begin
    For i:=1 to n do
      F[i]:=MaxLongInt;
    F[n]:=1;
    For u:=Count downto 1 do
      Begin
        i:=Turn[u];
        if F[i]=MaxLongInt then
          Continue;
        if F[i]<=0 then
          F[i]:=1;
        Temp:=F[i];
        For j:=1 to n do
          if G[j,i]<>0 then
            Begin
              T:=(Temp-G[j,i]-1) div 2+1;
              if T<F[j] then
                F[j]:=T;
            End;
      End;
  End;{Solve}
Procedure Out;
  Begin
    Assign (Output,Fn2);
    Rewrite (Output);
    Writeln (F[1]);
    Close (Output);
  End;{Out}
Begin
  Init;
  Preprocess;
  Solve;
  Out;
End.