const
   inf		='satanic.dat';
   outf		='satanic.out';
   limit	=100;

var
   n		:longint;
   s		:array[0..limit+1] of longint;
   map		:array[0..limit+1,0..limit+1] of longint;

procedure init;
var
   i,j		:longint;
begin
    assign(input,inf);reset(input);
      read(n);
      for i:=1 to n do
        for j:=1 to n do read(map[i,j]);
    close(input);
    fillchar(s,sizeof(s),0);
    s[n]:=1;
end;

procedure dfs(v:longint);
var
   i,t		:longint;
begin
    for i:=1 to n do
      if map[v,i]<>0 then
      begin
          if s[i]=0 then dfs(i);
	  t:=(s[i]-map[v,i]+1) div 2;
	  if t<1 then t:=1;
	  if (s[v]=0) or (t<s[v]) then s[v]:=t;
	  if t=1 then break;
      end;
    if s[v]=0 then s[v]:=20000;
end;

procedure workout;
begin
    dfs(1);
    assign(output,outf);rewrite(output);
      writeln(s[1]);
    close(output);
end;

BEGIN
    init;
    workout;
END.
