{$R-,Q-,I-,S-}
Const
    inf='b.in';
    outf='b.out';
    maxn=110;

Var
    n,m,count,tot:integer;
    finish:boolean;
    list:array[1..maxn]of integer;
    visited,used:array[1..maxn]of boolean;
    map:array[1..maxn,1..maxn]of boolean;
    ans:array[1..maxn*maxn,1..2]of integer;

procedure init;
var i,a,b:integer;
begin
    fillchar(map,sizeof(map),false);
    assign(input,inf); reset(input);
      read(n,m);
      for i:=1 to m do
        begin
            read(a,b);
            map[a,b]:=true; map[b,a]:=true;
        end;
    close(input);
end;

procedure out;
var i,j:integer;
begin
    assign(output,outf); rewrite(output);
      if count=n then begin
         for i:=1 to tot do
           begin
               writeln(ans[i,1],' ',ans[i,2]);
               map[ans[i,1],ans[i,2]]:=false;
               map[ans[i,2],ans[i,1]]:=false;
           end;
         for i:=1 to n do
           for j:=i+1 to n do
             if map[i,j] then writeln(i,' ',j);
      end
      else writeln('impossible');
    close(output);
end;

procedure dfs(now,len:integer);
var i:integer;
begin
    if finish then exit;
    if visited[now] then begin
        for i:=1 to len do
          if not(visited[list[i]]) then begin
            visited[list[i]]:=true;
            inc(count);
          end;
        for i:=1 to len-1 do
          begin
              inc(tot);
              ans[tot,1]:=list[i];
              ans[tot,2]:=list[i+1];
          end;
        finish:=true;
        exit;
    end;
    for i:=1 to n do
      if not(used[i]) and (map[i,now]) then begin
          map[i,now]:=false; map[now,i]:=false;
          list[len+1]:=i; used[i]:=true;
          dfs(i,len+1);
          map[i,now]:=true; map[now,i]:=true;
      end;
end;

procedure work;
var i,j:integer;
    f:boolean;
begin
    tot:=0; count:=1;
    fillchar(ans,sizeof(ans),0);
    fillchar(visited,sizeof(visited),false);

    visited[1]:=true;
    while count<n do
      begin
          finish:=false;
          fillchar(list,sizeof(list),0);
          f:=false;
          fillchar(used,sizeof(used),false);

          for i:=1 to n do
            if visited[i] then begin
                for j:=1 to n do
                  if not(visited[j]) then
                    if map[i,j] then begin
                        list[1]:=i; list[2]:=j;
                        used[j]:=true;
                        map[i,j]:=false; map[j,i]:=false;

                        dfs(j,2);
                        f:=true; break;
                    end;
                if f then break;
            end;

          if not(finish) then exit;
      end;
end;

Begin
    init;
    work;
    out;
End.

