{$R-,S-,Q-,I-}
program PB;
const
  maxn=100;
  inputfile='b.in';
  outputfile='b.out';
type
  integer=longint;
var
  n,m,h:integer;
  map,answer:array [1..maxn,1..maxn] of boolean;
  order,father,get:array [1..Maxn] of integer;
  reach:array [1..maxn] of boolean;
procedure init;
  var
    i,u,v:integer;
  begin
    fillchar(map,sizeof(map),0);
    fillchar(answer,sizeof(answer),0);
    readln(n,m);
    for i:=1 to m do
      begin
        readln(u,v);
        map[u,v]:=true;
        map[v,u]:=true;
      end;
  end;{init}
procedure DFS(now:integer);
  var
    k:integer;
  begin
    reach[now]:=True;
    inc(h);
    order[now]:=h;
    get[Now]:=h;
    for k:=1 to n do
      if map[now,k] then
        begin
          answer[now,k]:=True;
          map[now,k]:=False;
          map[k,now]:=False;
          if not reach[K] then
            begin
              father[K]:=now;
              DFS(K);
              if get[now]>get[k] then
                get[now]:=get[k];
            end
          else
            if order[k]<get[now] then
              get[now]:=order[k];
        end;
  end;{DFS}
function check:boolean;
  var
    k:integer;
  begin
    fillchar(reach,sizeof(reach),0);
    h:=0;
    DFS(1);
    check:=false;
    if h<n then
      exit;
    for k:=2 to n do
      if get[k]>order[father[k]] then
        exit;
    check:=True;
  end;{check}
procedure out;
  var
    i,j:integer;
  begin
    for i:=1 to n do
      for j:=1 to n do
        if answer[i,j] then
          writeln (i,' ',j);
  end;{out}
begin
  assign(input,inputfile);
  reset(input);
  assign(output,outputfile);
  rewrite(output);
  init;
  if check then
    out
  else
    writeln('impossible');
  close(input);
  close(output);
end.
