Program poke;
 const
   inputfilename='poke.in';
   outputfilename='poke.out';
 type
   Tcard=record key,col:byte; end;
   Tcards=array[1..5] of Tcard;
 var
   t:array[2..14,1..4] of boolean;
   com,hum:Tcards;
   clevel,hlevel,res:integer;

procedure readdata;
 var
   i,key,color:integer;
   st,s1:string;
   ch:char;
begin
  fillchar(t,sizeof(t),0);
  assign(input,inputfilename);
  reset(input);
  readln(st);
  {Computer's cards}
  delete(st,1,pos(' ',st));
  for i:=2 to 5 do
   begin
     if i<>5 then s1:=copy(st,1,pos(' ',st)-1) else s1:=st; ch:=s1[length(s1)];
     delete(st,1,length(s1)+1); delete(s1,length(s1),1);
     if length(s1)=2 then key:=10
      else
       case s1[1] of
         '2'..'9':key:=ord(s1[1])-48;
         'A':key:=14;
         'K':key:=13;
         'Q':key:=12;
         'J':key:=11;
       end;
     case ch of
       'S':color:=1;
       'H':color:=2;
       'C':color:=3;
       'D':color:=4;
     end;
     t[key,color]:=true; com[i].key:=key; com[i].col:=color;
   end;
  {Human's cards}
  readln(st);
  for i:=1 to 5 do
   begin
     if i<>5 then s1:=copy(st,1,pos(' ',st)-1) else s1:=st; ch:=s1[length(s1)];
     delete(st,1,length(s1)+1); delete(s1,length(s1),1);
     if length(s1)=2 then key:=10
      else
       case s1[1] of
         '2'..'9':key:=ord(s1[1])-48;
         'A':key:=14;
         'K':key:=13;
         'Q':key:=12;
         'J':key:=11;
       end;
     case ch of
       'S':color:=1;
       'H':color:=2;
       'C':color:=3;
       'D':color:=4;
     end;
     t[key,color]:=true; hum[i].key:=key; hum[i].col:=color;
   end;
  close(input);
end;

procedure swap(var a,b:Tcard);
 var
   temp:Tcard;
begin
  temp:=a; a:=b; b:=temp;
end;

function check(p:Tcards):integer;
 var
   samec,stra:boolean;
   same,i,j:byte;
begin
  samec:=false; stra:=false;
  if (p[1].col=p[2].col) and (p[2].col=p[3].col)
   and (p[3].col=p[4].col) and(p[4].col=p[5].col) then samec:=true;
  if (p[1].key+1=p[2].key) and (p[2].key+1=p[3].key) and
   (p[3].key+1=p[4].key) and (p[4].key+1=p[5].key) then stra:=true;
  same:=0;
  for i:=1 to 4 do
   for j:=i+1 to 5 do
    if p[i].key=p[j].key then inc(same);
  if samec and stra then check:=1
   else if same=6 then check:=3
    else if same=4 then check:=4
     else if samec then check:=5
      else if stra then check:=6
       else if same=3 then check:=7
        else if same=2 then check:=8
         else if same=1 then check:=9
          else check:=10;
end;

procedure rearrange(l:integer; var c:Tcards);
 begin
   case l of
     3:if c[4].key<>c[5].key then swap(c[5],c[1]);
     4:if (c[3].key<>c[4].key) and (c[4].key=c[5].key) then
        begin swap(c[4],c[2]); swap(c[5],c[1]); end;
     7:if (c[3].key=c[4].key) and (c[2].key=c[3].key) then swap(c[2],c[5])
        else if (c[1].key=c[2].key) and (c[2].key=c[3].key) then
         begin swap(c[4],c[1]); swap(c[5],c[2]); end;
     8:if c[4].key<>c[5].key then begin swap(c[5],c[1]); swap(c[5],c[3]); end
        else if (c[3].key<>c[4].key) and (c[3].key<>c[2].key) then swap(c[3],c[1]);
     9:if c[3].key=c[4].key then swap(c[3],c[5])
        else if c[2].key=c[3].key then begin swap(c[2],c[4]); swap(c[3],c[5]); end
         else if c[1].key=c[2].key then
          begin swap(c[1],c[5]); swap(c[2],c[4]); swap(c[1],c[3]); end;
   end;
 end;

function win:boolean;
 var
   i,j:integer;
   temp1:Tcards;
begin
  temp1:=com; win:=false;
  for i:=1 to 4 do
   for j:=i+1 to 5 do
    if com[j].key<com[i].key then swap(com[i],com[j]);
  clevel:=check(com);
  rearrange(clevel,com);
  if hlevel<clevel then win:=true
   else if hlevel=clevel then
    for i:=5 downto 1 do
     if com[i].key>hum[i].key then break
      else if hum[i].key>com[i].key then win:=true;
  com:=temp1;
end;

procedure main;
 var
   i,j:integer;
begin
  for i:=1 to 4 do
   for j:=i+1 to 5 do
    if hum[j].key<hum[i].key then swap(hum[i],hum[j]);
  hlevel:=check(hum);
  rearrange(hlevel,hum);
  for i:=2 to 14 do
   for j:=1 to 4 do
    if not t[i,j] then
     begin
       com[1].key:=i; com[1].col:=j;
       if win then inc(res);
     end;
end;

procedure print;
 begin
   assign(output,outputfilename);
   rewrite(output);
   writeln(res/43:0:4);
   close(output);
 end;

Begin
  readdata;
  main;
  print;
End.