#include <stdio.h>
#include <string.h>
#include <math.h>

FILE *fin  = fopen("A.DAT", "r+");
FILE *fout = fopen("A.OUT", "w+");

int compute(int lev, int mod);

int N, M;
int num[300001];
int used[300001];

int main() {
	fscanf(fin, "%d %d", &N, &M);

	num[1]=N;
	for ( int i=2; i<=N; ++i )
		if ( num[i-1]>7 )
			num[i]=M+1;
		else
			num[i]=int(pow(N, num[i-1]));

	fprintf(fout, "%d\n", compute(N, M));

	fclose(fin);
	fclose(fout);

	return 0;
}

int compute(int lev, int mod) {
	if ( lev==1 || N%mod==0 )
		return N%mod;
	else {
		int res;
		int p, q;

		memset(used, -1, (mod+1)*sizeof(int));
		p=1;
		for ( int i=0; ; ++i )
			if ( used[p]>=0 ) {
				q=i-used[p]; break;
			}
			else {
				used[p]=i;
				p=int((__int64)p*N%mod);
			}

		p=used[p];

		if ( p>=num[lev-1] ) {
			res=1;
			for ( int i=0; i<num[lev-1]; ++i )
				res=int((__int64)res*N%mod);
		}
		else {
			res=1;
			p=(compute(lev-1, q)+q-p%q)%q+p;

			for ( int i=0; i<p; ++i )
				res=int((__int64)res*N%mod);
		}

		return res;
	}
}