#include<iostream.h>
#include<fstream.h>
#include<string.h>

#define maxn 1010
#define maxm 2*maxn*maxn
#define inf 10000000

int c[maxm],f[maxm],ev[maxm],be[maxm],next[maxm],num=0;
int nbs[maxn],pnt[maxn],open[maxn],d[maxn],mk[maxn];
char g[maxn][maxn];

void AddEdge(int u,int v,int cc)
{
	next[++num]=nbs[u];    nbs[u]=num; be[num]=num+1;
	ev[num]=v; c[num]=cc;  f[num]=0; 
	next[++num]=nbs[v];    nbs[v]=num; be[num]=num-1;
	ev[num]=u; c[num]=0 ;  f[num]=0;
}

int maxflow(int n,int s,int t)
{
	int cur,tail,i,j,u,v,flow=0;
	do{	memset(mk,0,sizeof(mk));  memset(d,0,sizeof(d));
		open[0]=s; mk[s]=1; d[s]=0x3fffffff;
		for(pnt[s]=cur=tail=0; cur<=tail && !mk[t]; cur++)
			for(u=open[cur],j=nbs[u];j;j=next[j]) { v=ev[j];
				if(!mk[v]&&f[j]<c[j]){
					mk[v]=1; open[++tail]=v; pnt[v]=j;
					if(d[u]<c[j]-f[j]) d[v]=d[u]; else d[v]=c[j]-f[j];
				}
			}				
		if(!mk[t]) break; flow+=d[t];
		for(u=t;u!=s;u=ev[be[j]]){j=pnt[u];f[j]+=d[t];f[be[j]]=-f[j];}
	} while(d[t]>0); return flow;
}


int lx[maxn],ly[maxn],rx[maxn],ry[maxn],w[maxn],n;

int main()
{
	ifstream cin("d.dat");
	ofstream cout("d.out");
	int n,i,j,k;
	int src,sink,sum;
	memset(nbs,0,sizeof(nbs)); num=0;
	cin>>n; src=n+1; sink=n+2;	
	for(i=1,sum=0; i<=n; i++) {
		cin>>lx[i]>>ly[i]>>rx[i]>>ry[i]>>w[i];
		if(w[i]>0) { AddEdge(src,i,w[i]); sum+=w[i]; }
			else AddEdge(i,sink,-w[i]);
	}
	for(i=1;i<=n;i++) for(j=1;j<=n;j++)
		if( ly[i]<=ry[j] && !(rx[i]<=lx[j]) && !(lx[i]>=rx[j])) 
			g[i][j]=1;
	for(i=1;i<=n;i++) for(j=1;j<=n;j++) if(g[i][j])
		for(k=1;k<=n;k++) if(g[j][k] && g[i][k]) g[i][k]=0;
		
	for(i=1;i<=n;i++) for(j=1;j<=n;j++)
		if( g[i][j] ) AddEdge(i,j,inf);
	//cout<<num<<endl;
	cout<< sum-maxflow(n+2,src,sink) <<endl;
	return 0;
}
