Program _trans_GREEDY;

const MAXN = 16010;
      filein = 'trans.in';
      fileout = 'trans.out';
      maxtry = 100;

var c : array [1..MAXN] of byte;
    s, sw, sb : array [0..MAXN] of longint;
    i, j, k, m, n, q, t, min, v : longint;

function greedy1(k, t : longint) : longint;
var i, j, last, sum : longint;
begin
last := 0;
sum := 0;

while (last < n) do
  begin
    i := last + 1;
    j := 1;

    while (i <= n) and (c[i] = c[last+1]) and (j < k) do
      begin
        inc(i);
        inc(j);
      end;

    if (i = n + 1) or (c[i] <> c[last+1]) then
      dec(i);

    last := i;
    sum := sum + t;
  end;

greedy1 := sum;
end;

function greedy2(k, t : longint) : longint;
var i, j, last, sum : longint;
begin
last := 0;
sum := 0;

while (last < n) do
  begin
    i := last + 1;
    j := 1;

    while (i < n) and (j < k) do
      begin
        inc(i);
        inc(j);
      end;

    if (i = n + 1) or (c[i] <> c[last+1]) then
      dec(i);


    sum := sum + t;

    if (sw[i] - sw[last] < sb[i] - sb[last]) then
      sum := sum + (sw[i] - sw[last])
    else
      sum := sum + (sb[i] - sb[last]);

    last := i;
  end;

greedy2 := sum;
end;

function greedy3(k, t : longint) : longint;
var i, j, last, sum, limit : longint;
begin
randomize;

last := 0;
sum := 0;

while (last < n) do
  begin
    i := last + 1;
    j := 1;

    limit := random(k) + 1;

    while (i < n) and (j < limit) do
      begin
        inc(i);
        inc(j);
      end;

    if (i = n + 1) or (c[i] <> c[last+1]) then
      dec(i);


    sum := sum + t;

    if (sw[i] - sw[last] < sb[i] - sb[last]) then
      sum := sum + (sw[i] - sw[last])
    else
      sum := sum + (sb[i] - sb[last]);

    last := i;
  end;

greedy3 := sum;
end;

begin
assign(input, filein);
reset(input);
assign(output, fileout);
rewrite(output);

read(n);

sw[0] := 0;
sb[0] := 0;
for i := 1 to n do
  begin
    read(c[i], s[i]);

    sw[i] := sw[i-1];
    sb[i] := sb[i-1];

    if (c[i] = 0) then
      sb[i] := sb[i] + s[i]
    else
      sw[i] := sw[i] + s[i];
  end;

read(q);
for m := 1 to q do
  begin
    read(k, t);

    min := greedy1(k, t);

    v := greedy2(k, t);
    if (v < min) then
      min := v;

    for i := 1 to maxtry do
      begin
        v := greedy3(k, t);
        if (v < min) then
          min := v;
      end;

    writeln(min);
  end;

close(output);
close(input);
end.