{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{ Time Complexity : O(Q * N * K) }

Program _trans_;

const filein = 'trans.in';
      fileout = 'trans.out';
      MAXN = 16000;
      infinit = 1000000000;

type longarray = array [0..MAXN] of longint;
     plongarray = ^longarray;
     bytearray = array [0..MAXN] of byte;
     pbytearray = ^bytearray;

var s, min : plongarray;
    sum : array [0..1] of plongarray;
    c : pbytearray;
    i, j, k, n, q, iq, t, v0, v1 : longint;

begin
assign(input, filein);
reset(input);
assign(output, fileout);
rewrite(output);

read(n);

new(c);
new(s);
new(sum[0]);
new(sum[1]);

sum[0]^[0] := 0;
sum[1]^[0] := 0;

for i := 1 to n do
  begin
    read(c^[i], s^[i]);
    sum[c^[i]]^[i] := sum[c^[i]]^[i-1] + s^[i];
    sum[1-c^[i]]^[i] := sum[1-c^[i]]^[i-1];
  end;

new(min);

read(q);
for iq := 1 to q do
  begin
    read(k, t);

    if (q*k > 4000) and (k > 50) then
      k := 50;

    min^[0] := 0;
    for i := 1 to n do
      begin
        min^[i] := infinit;

        for j := i-1 downto 0 do
          begin
            if (i - j > k) then
              break;

            v0 := min^[j] + sum[c^[i]]^[i] - sum[c^[i]]^[j] + t;
            v1 := min^[j] + sum[1-c^[i]]^[i] - sum[1-c^[i]]^[j] + t;

            if (v0 < v1) and (v0 < min^[i]) then
              min^[i] := v0
            else
            if (v1 < min^[i]) then
              min^[i] := v1;
          end;
      end;

    writeln(min^[n]);
  end;

close(input);
close(output);
end.