/* Tiberiu Danet */

#include <stdio.h>

int n, k, lines, cols;
unsigned int v[96][3];
int Area, bit;
unsigned int bits[1 << 16];

#define countbits(a,b,c)   bits[a >> 16] + bits[a & 0xffff] + \
                           bits[b >> 16] + bits[b & 0xffff] + \
                           bits[c >> 16] + bits[c & 0xffff]

void compute (int line, int selected, unsigned int mask1, unsigned int mask2, unsigned int mask3)
{
	bit = countbits( mask1, mask2, mask3 );
		
	if ( selected * bit > Area )
		Area = selected * bit;
				
	if ( line == lines )
		return;
		
	if ( (selected + lines - line) * bit <= Area )
		return;

	compute( line + 1, selected, mask1, mask2, mask3 );
	compute( line + 1, selected + 1, mask1 & v[line][0], mask2 & v[line][1], mask3 & v[line][2] );
}

void gen_bits ()
{
	int i, j;
	
	for ( i = 0; i < 16; i++ )
		for ( j = 0; j < (1 << i); j++ )
			bits[j | (1 << i)] = bits[j] + 1;
}


void read_solve ()
{
	int i, j, x, y, aux;
	
	freopen( "bec.in", "rt", stdin );
	freopen( "bec.out", "wt", stdout );
	
	gen_bits();
	
	scanf( "%d%d%d", &lines, &cols, &n );
		
	for ( i = 0; i < n; i++ )
	{
		scanf( "%d%d", &x, &y );
		if ( lines > cols )
			aux = x, x = y, y = aux;
		v[x][y >> 5] |= (1 << (y & 31));
	}

	if ( cols < lines )
		lines = cols;	
	
	for ( i = 0; i < lines; i++ )
		for ( j = i + 1; j < lines; j++ )
			if ( countbits( v[i][0], v[i][1], v[i][2] ) > countbits( v[j][0], v[j][1], v[j][2] ) )
				aux = v[i][0], v[i][0] = v[j][0], v[j][0] = aux,
				aux = v[i][1], v[i][1] = v[j][1], v[j][1] = aux,
				aux = v[i][2], v[i][2] = v[j][2], v[j][2] = aux;
			
	compute( 0, 0, 0xffffffff, 0xffffffff, 0xffffffff );
	printf( "%d\n", Area );
}

int main ()
{
	read_solve ();
	return 0;
}
