#include <stdio.h>
#include <string.h>

#define SIZE 1100
char S[SIZE];
int N, L;
int First[SIZE][128];
int J[SIZE];

void preprocess()
{
    int i, p, c;
    for (c = 1; c <= 127; c++)
        for (First[L][c] = L, p = L, i = L-1; i >= 0; i--)
            First[i][c] = p = ((S[i] == c) ? i : p);
    for (i = 0; i <= L; i++) J[i] = L;
}

void addword(char *word)
{
    int i, j;
    char *p;
    for (i = 0; i < L; i++)
    {
        for (j = i-1, p = word; *p && j < J[i]; p++)
            j = First[j+1][(int)*p];
        if (J[i] > j) J[i] = j;
    }
}

int Res;
void recalculate()
{
    int i;
    Res = 0;
    for (i = 0; J[i] < L; Res++, i = J[i]+1);
}

void read_and_solve()
{
    FILE *fi = fopen("mesaj.in", "rt");
    FILE *fo = fopen("mesaj.out", "wt");
    char cuv[SIZE];
    fscanf(fi, "%s %d", S, &N);
    L = strlen(S);
    preprocess();
    while (N--)
    {
        fscanf(fi, "%s", cuv);
        addword(cuv);
        recalculate();
        fprintf(fo, "%d\n", Res);
    }
}
int main()
{
    read_and_solve();
    return 0;
}
