#include <stdio.h>
#include <stdlib.h>

#define InFile "poli.in"
#define OutFile "poli.out"
#define LgMax 20000

typedef char BigNo[LgMax];

BigNo a1, a2, a3, a;
int n, la1, la2, la3, la;

void add(BigNo a, int& la, BigNo b, int lb);//a=a+b
void sub(BigNo, int &, BigNo, int);//a=a-b
void mul(BigNo, int, int, BigNo, int &); //t=a*c
void copy(BigNo, int &, BigNo, int);//a=b
void out(void);
void in(void);
void solve(void);

int main()
{   in();
    solve();
    out();
  return 0;
}

void in(void)
{
	FILE *fin=fopen(InFile, "r");
    fscanf(fin,"%d",&n);
    fclose(fin);
}

void out(void)
{   FILE * fout=fopen(OutFile,"w");
    int i;
    for (i=la-1; i>=0; i--)
        fprintf(fout,"%d",a[i]);
    fprintf(fout,"\n");
	fclose(fout);
}

void solve(void)
{
int i, lt;
BigNo temp;
switch (n)
  {
  case 1: la=1; a[0]=1; return;
  case 2: la=1; a[0]=2; return;
  case 3: la=1; a[0]=6; return;
  case 4: la=2; a[0]=9; a[1]=1;return;
  case 5: la=2; a[0]=1; a[1]=6; return;
}
la1=2; a1[0]=1; a1[1]=6;
la2=2; a2[0]=9; a2[1]=1;
la3=1; a3[0]=6;
for (i=6; i<=n; i++)
    {
     mul(a1,la1,5,a,la);
     mul(a3,la3,4,temp,lt);
     add(a,la,temp, lt);
     mul(a2,la2,7,temp,lt);
     sub(a,la,temp,lt);
     copy(a3,la3, a2, la2);
     copy(a2,la2, a1, la1);
     copy(a1,la1, a, la);
    }
}
void add(BigNo a, int & la, BigNo b, int lb)
//a=a+b
{
int i, tr=0, sum;
for (i=0; i<la && i<lb; i++)
    {sum=a[i]+b[i]+tr;
     a[i]=sum%10;
     tr=sum/10;   }
if (i<la)
   for (; i<la; i++)
    {sum=a[i]+tr;
     a[i]=sum%10;
     tr=sum/10;   }
    else
    {
    for (; i<lb; i++)
        {sum=b[i]+tr;
         a[i]=sum%10;
         tr=sum/10;   }
    la=lb;
    }
if (tr) a[la++]=tr;
}


void sub(BigNo a, int & la, BigNo b, int lb)
//a=a-b
{
int i, tr=0, sum;
for (i=0; i<la && i<lb; i++)
    {sum=a[i]-b[i]+tr;
     if (sum<0)
        {a[i]=10+sum;tr=-1;}
        else
        {a[i]=sum; tr=0;}
     }
for (; i<la; i++)
    {sum=a[i]+tr;
     if (sum<0)
        {a[i]=10+sum;tr=-1;}
        else
        {a[i]=sum; tr=0;}
     }
while (a[la-1]==0 && la>1) la--;
}

void mul(BigNo a, int la, int c, BigNo t, int &lt)
//t=a*c
{
int tr=0, i;
for (i=0; i<la; i++)
    {
    t[i]=(c*a[i]+tr)%10;
    tr=(c*a[i]+tr)/10;
    }
lt=la;
if (tr) t[lt++]=tr;
}


void copy(BigNo a, int& la, BigNo b, int lb)
{
int i;
for (i=0; i<lb; i++) a[i]=b[i];
la=lb;
}

