#include <stdio.h>

int N, K;
long long X, total;
int p[10], r[10];

long long gcd (long long a, long long b, long long *k, long long *l)
{
	long long x, y, d;

	if ( b == 0 )
	{
		*k = 1;
		*l = 0;
		return a;
	}

	d = gcd( b, a % b, &x, &y );
	*k = y;
	*l = x - (a / b) * y;
	return d;
}

long long get_rest (long long p1, long long r1, long long p2, long long r2)
{
	long long k, l, r, p = p1 * p2;

	gcd( p1, p2, &k, &l );

	r = p1 * k * (r2 - r1) + r1;
	r = (r % p + p) % p;

	return r;
}

void add (int i, long long cur_p, long long cur_r, int sign)
{
	total += sign * ((X + cur_p - cur_r) / cur_p);
	for ( ; i < K; i++ )
		add( i + 1, cur_p * p[i], get_rest( cur_p, cur_r, p[i], r[i] ), -sign );
}

long long count (long long mid)
{
	total = 0;
	X = mid;
	add( 0, 1, 0, 1 );
	return total;
}

void read_solve ()
{
	int i;
	long long a, b, mid, MAX = 1LL << 50;

	freopen( "resturi.in", "rt", stdin );
	freopen( "resturi.out", "wt", stdout );
	
	scanf( "%d%d", &K, &N );
	for ( i = 0; i < K; i++ )
		scanf( "%d%d", p + i, r + i );

	for ( a = -1, b = MAX; b - a > 1; )
	{
		mid = (a + b) / 2;
		if ( count( mid ) >= N )
			b = mid;
		else
			a = mid;
	}

	printf( "%lld\n", b );
}

int main ()
{
	read_solve();
	return 0;
}
